;*DDK*************************************************************************/
;
; COPYRIGHT (C) Microsoft Corporation, 1989
; COPYRIGHT    Copyright (C) 1995 IBM Corporation
;
;    The following IBM OS/2 WARP source code is provided to you solely for
;    the purpose of assisting you in your development of OS/2 WARP device
;    drivers. You may use this code in accordance with the IBM License
;    Agreement provided in the IBM Device Driver Source Kit for OS/2. This
;    Copyright statement may not be removed.;
;*****************************************************************************/
;*****************************************************************************
;*
;* SOURCE FILE NAME = SVGADEFS.H
;*
;* DESCRIPTIVE NAME =
;*
;*
;* VERSION = V2.0
;*
;* DATE
;*
;* DESCRIPTION  Contains SVGA definitions.
;*
;* FUNCTIONS
;*
;* NOTES        When included into VVID sources, #ifdef SVGA
;*              must be used before #include!
;*
;* STRUCTURES
;*
;* EXTERNAL REFERENCES
;*
;* EXTERNAL FUNCTIONS
;*
;* CHANGE ACTIVITY =
;*   DATE      FLAG        APAR   CHANGE DESCRIPTION
;*   --------  ----------  -----  --------------------------------------
;*   mm/dd/yy  @Vr.mpppxx  xxxxx  xxxxxxx
;*   12/29/92                     - Created.
;*   03/12/93                     - OEMINFO structure changed.
;*   08/31/93                     - Recognize Cirrus Logic GD5428 chip
;*   10/28/93                     - Recognize Additional Adapters
;*   12/06/93              76476  - Add ID for Chips & Technologies
;*   12/15/93              76685  - Add Artist Graphics manufacturer
;*   02/21/94             D79562  Recognize Additional Adapters/Chips
;*   04/14/94             D81883  WD90C24 allow more unlocks
;*   04/26/94             D82003  WD90C24 preserve locks for BIOS setmodes
;*   05/12/94                     Add more Cirrus chipsets
;*   05/13/94             F74819  ATI Mach8/32 check in files
;*   05/18/94                     WD90C33 Parse new style PMI
;*   06/22/94              87347  Define Tseng Chip Names for consistant use
;*   07/25/94              89911  Define Tseng W32xD Revisions
;*   07/28/94              88172  Define a Chips and Technologies chiptype
;*   08/02/94             D91551  Fix various DAC programming problems
;*   08/19/94             D94209  Add more DAC detection
;*   09/01/94              89853  Add support for S3864 with ICD2061 clock chip
;*   09/10/94             D86373  Weitek: PCI screen01 incorrect
;*   09/15/94                     Identify DAC as RGB (blue first) or BGR (red first)
;*   09/17/94             D92593  Adding monitor configuration enhancements.
;*   09/26/94             D97637  Changing Music DAC 4910 from BGR to RGB.
;*   10/05/94             D101610 Increase size of CLEANDATA for MACH32
;*   10/25/94             103192  TSENG Rev D wont install
;*   11/30/94  @V3.0YEE01 105950  Support S3 964
;*   01/20/95  @V3.0YEE02   99391 Support TBird-Enhanced (800x600 flat panel)
;****************************************************************************  
INCL_DOSERRORS	EQU	1

MAX_LOCKUNLOCKCMD	EQU	40                               ;             
MAX_CLEANDATA	EQU	200       ;  Includes DACs        /*@V3.0YEE01*/
MAX_SETBANK_CMD	EQU	25                               ;             
MAX_GETBANK_CMD	EQU	20                               ;             
MAX_MODESET_CMD	EQU	84                               ;             
DEFAULT_ADAPTER	EQU	(-1 )
UNKNOWN_ADAPTER	EQU	0 
VIDEO7_ADAPTER	EQU	1        ;  bugbug line up with cleanups!   
TRIDENT_ADAPTER	EQU	2 
TSENG_ADAPTER	EQU	3 
WESTERNDIG_ADAPTER	EQU	4 
ATI_ADAPTER	EQU	5 
IBM_ADAPTER	EQU	6 
CIRRUS_ADAPTER	EQU	7 
S3_ADAPTER	EQU	8 
CHIPS_ADAPTER	EQU	9                       ;               
WEITEK_ADAPTER	EQU	10                      ;               
NUMBER9_ADAPTER	EQU	11                      ;               
GENERIC_PCISVGA_ADAPTER	EQU	12                       ; @senja
 ;  remember to update SVGA_LASTADAPTER when adding new adapter support   
SVGA_FIRSTADAPTER	EQU	VIDEO7_ADAPTER         ;               
SVGA_LASTADAPTER	EQU	GENERIC_PCISVGA_ADAPTER
;             start   
ifdef FAMILY2
ORCHID_MC_ADAPTER	EQU	2        ;               
ORCHID_MC_ID	EQU	86H     ;               
endif
; 
;* DAC types
VGA_DAC	EQU	0                                      ;             
DEFAULT_DAC	EQU	VGA_DAC                               ;             
HICOLOR_DAC	EQU	1       ;  Unidentified                /*          */
WINBOND_DAC	EQU	HICOLOR_DAC                           ;             
BT485_DAC	EQU	2       ;  Brooktree 485               /*          */
Weitek_BT485DAC	EQU	3       ;  BT485 used by Weitek        
SC15025_DAC	EQU	4       ;  SC15025                     
SierraDAC	EQU	SC15025_DAC ;  Use more specific name!   
ATT490_DAC	EQU	5 
ATTDAC	EQU	ATT490_DAC ;  Use more specific name!   
MU9C1880_DAC	EQU	6       ;  MU9C4870, MU9C1880, SS2410  
MU9C4870_DAC	EQU	MU9C1880_DAC                          ;             
TRUECOLOR_DAC	EQU	7                                      ;             
IMSG173_DAC	EQU	8       ; These DACS identified, but not programmed  
InmosDAC	EQU	IMSG173_DAC ;  Use more specific name!   
CH8398_DAC	EQU	9 
ChrontelDAC	EQU	CH8398_DAC ;  Use more specific name!   
CIRRUS_DAC	EQU	10 
ICS5341_DAC	EQU	11 
ICS5342_DAC	EQU	ICS5341_DAC                            ;             
SGS1702_DAC	EQU	12 
SGSThomsonDAC16	EQU	SGS1702_DAC ;  Use more specific name!   
SGS1703_DAC	EQU	13                                      ;             
MU9C4910_DAC	EQU	14       ;  MU9C4910 (blue byte first)   
                                 ;   note that the MU9C1880 is also true color, but   
                                 ;        it does not need to be identified because   
                                 ;        behaves like the others in its group        
MusicDAC16RGB	EQU	MU9C4910_DAC ;  Use more specific name!   
ATI68830_DAC	EQU	15       ;  ATI 68830 & compatible                
S3SDAC_DAC	EQU	16       ;  S3 SDAC                               
ATT498_DAC	EQU	17       ;  AT&T 498 CLOCKDAC                     
SGS1700_DAC	EQU	18       ;  SGS 1700 DAC                          
TLC34075_DAC	EQU	19       ;  Texas Instruments TLC34075  
ATI68875_DAC	EQU	TLC34075_DAC
BT476_DAC	EQU	20       ;  Brooktree 476/478                     
BT478_DAC	EQU	BT476_DAC
BT481_DAC	EQU	21       ;  Brooktree 481/482                     
BT482_DAC	EQU	BT481_DAC
ATI68860_DAC	EQU	22       ;  ATI 68860/68880                       
MU9CBUG_DAC	EQU	23 
CH8391_DAC	EQU	24 
W82C490_DAC	EQU	25 
ATT491_DAC	EQU	26 
ATT492_DAC	EQU	27 
ATT493_DAC	EQU	28 
ATT497_DAC	EQU	29 
WD90C24_DAC	EQU	30 
MU9C9910_DAC	EQU	31       ;  (blue byte first)   
ATT409_DAC	EQU	32 
TI3025_DAC	EQU	33       ;  TI Viewpoint 3025 CLOCKDAC  @V3.0YEE01  
MAX_DAC	EQU	34                                    ; @V3.0YEE01  
VGADAC_NAME	EQU	<"VGA_RGB">
HICOLOR_NAME	EQU	<"HICOLOR_RGB">
BT485_NAME	EQU	<"BT485_RGB">
VIPER_NAME	EQU	<"BT485_RGB">
SC15025_NAME	EQU	<"SC15025_RGB">
ATT490_NAME	EQU	<"ATT20C490_RGB">
MU9C1880_NAME	EQU	<"MU9C1880_BGR">
TRUECOLOR_NAME	EQU	<"TRUECOLOR_RGB">
IMSG173_NAME	EQU	<"IMSG173_RGB">
CH8398_NAME	EQU	<"CH8398_RGB">
CIRRUS_NAME	EQU	<"CIRRUS_RGB">
ICS5341_NAME	EQU	<"ICS5341_RGB">
SGS1702_NAME	EQU	<"SGS1702_RGB">
SGS1703_NAME	EQU	<"SGS1703_RGB">
MU9C4910_NAME	EQU	<"MU9C4910_RGB">
ATI68830_NAME	EQU	<"ATI68830_RGB">
S3SDAC_NAME	EQU	<"S3SDAC_RGB">
ATT498_NAME	EQU	<"ATT20C498_RGB">
SGS1700_NAME	EQU	<"SGS1700_RGB">
TLC34075_NAME	EQU	<"TLC34075_RGB">
ATI68875_NAME	EQU	<"ATI68875_RGB">
BT476_NAME	EQU	<"BT476_RGB">
BT481_NAME	EQU	<"BT481_RGB">
ATI68860_NAME	EQU	<"ATI68860_RGB">
MU9CBUG_NAME	EQU	<"MU9C1880BUG_BGR">
CH8391_NAME	EQU	<"CH8391_RGB">
W82C490_NAME	EQU	<"W82C490_RGB">
ATT491_NAME	EQU	<"ATT20C491_RGB">
ATT492_NAME	EQU	<"ATT20C492_RGB">
ATT493_NAME	EQU	<"ATT20C493_RGB">
ATT497_NAME	EQU	<"ATT20C497_RGB">
WD90C24_NAME	EQU	<"WD90C24_RGB">
MU9C9910_NAME	EQU	<"MU9C9910_RGB">
ATT409_NAME	EQU	<"ATT20C409_RGB">
TI3025_NAME	EQU	<"TVP3025_RGB">
WEITEK_P9000_INCREMENT	EQU	0040H  ; Spacing between potential bases.
WEITEK_P9000_REGISTERS	EQU	0010H  ; Base address offset for registers.
WEITEK_P9000_VRAM	EQU	0020H  ; Base address offset for VRAM.
WEITEK_P9000_SYSCONFIG	EQU	0004H  ; Offset for config reg
WEITEK_P9000_INTERRUPT	EQU	0008H  ; Offset for interrupt reg
WEITEK_P9000_ENABLE	EQU	000cH  ; Offset for interrupt enable reg
WEITEK_P9000_MEMCONFIG	EQU	0184H  ; Offset for memory config reg
WEITEK_P9000_REGLENGTH	EQU	2000H  ; Length for register addressability
;             end     
UNKNOWN_CHIP	EQU	0 
VIDEO7_HT205_CHIP	EQU	1 
VIDEO7_HT208_CHIP	EQU	2 
VIDEO7_HT209_CHIP	EQU	3 
MAX_VIDEO7_CHIP	EQU	VIDEO7_HT209_CHIP               ;             
VIDEO7_HT205_NAME	EQU	<"HT205">
VIDEO7_HT208_NAME	EQU	<"HT208">
VIDEO7_HT209_NAME	EQU	<"HT209">
TRIDENT_8800_CHIP	EQU	1 
TRIDENT_8900_CHIP	EQU	2 
MAX_TRIDENT_CHIP	EQU	TRIDENT_8900_CHIP               ;             
TRIDENT_8800_NAME	EQU	<"TR8800">
TRIDENT_8900_NAME	EQU	<"TR8900">
TSENG_ET3000_CHIP	EQU	1 
TSENG_ET4000_CHIP	EQU	2 
TSENG_ET4000W32_CHIP	EQU	3     ;  w32                               
TSENG_ET4000W32I_CHIP	EQU	4     ;  w32i (level a)                    
TSENG_ET4000W32IB_CHIP	EQU	5     ;  w32i level b                      
TSENG_ET4000W32IC_CHIP	EQU	6     ;  w32i level c                      
TSENG_ET4000W32PA_CHIP	EQU	7     ;  w32p level a                      
TSENG_ET4000W32PB_CHIP	EQU	8     ;  w32p level b                      
TSENG_ET4000W32PC_CHIP	EQU	9     ;  w32p level c                      
TSENG_ET4000W32ID_CHIP	EQU	10     ;  w32i level d                      
TSENG_ET4000W32PD_CHIP	EQU	11     ;  w32p level d                      
TSENG_ET4000W32PX_CHIP	EQU	12     ;  all others                        
MAX_TSENG_CHIP	EQU	12 
TSENG_ET3000_NAME	EQU	<"ET3000">
TSENG_ET4000_NAME	EQU	<"ET4000">
TSENG_ET4000W32_NAME	EQU	<"ET4000W32">
TSENG_ET4000W32I_NAME	EQU	<"ET4000W32IREVA">
TSENG_ET4000W32IB_NAME	EQU	<"ET4000W32IREVB">
TSENG_ET4000W32IC_NAME	EQU	<"ET4000W32IREVC">
TSENG_ET4000W32PA_NAME	EQU	<"ET4000W32PREVA">
TSENG_ET4000W32PB_NAME	EQU	<"ET4000W32PREVB">
TSENG_ET4000W32PC_NAME	EQU	<"ET4000W32PREVC">
TSENG_ET4000W32ID_NAME	EQU	<"ET4000W32IREVD">
TSENG_ET4000W32PD_NAME	EQU	<"ET4000W32PREVD">
TSENG_ET4000W32PX_NAME	EQU	<"ET4000W32PREVC_COMPATABLE">
WESTERNDIG_PVGA1A_CHIP	EQU	1 
WESTERNDIG_WD9000_CHIP	EQU	2  ;  PVGA1B   
WESTERNDIG_WD9011_CHIP	EQU	3  ;  PVGA1C   
WESTERNDIG_WD9030_CHIP	EQU	4  ;  PVGA1D   
WESTERNDIG_WD9026_CHIP	EQU	5  ;  PVGA1F                     /*          */
WESTERNDIG_WD9027_CHIP	EQU	6                                ;             
WESTERNDIG_WD9031_CHIP	EQU	7  ;  PVGA1DW                    /*          */
WESTERNDIG_WD9024_CHIP	EQU	8                                ;             
WESTERNDIG_WD9033_CHIP	EQU	9  ;  PVGA2DW                    /*          */
MAX_WESTERNDIG_CHIP	EQU	WESTERNDIG_WD9033_CHIP          ;             
WESTERNDIG_PVGA1A_NAME	EQU	<"PVGA1A">
WESTERNDIG_WD9000_NAME	EQU	<"PVGA1B">
WESTERNDIG_WD9011_NAME	EQU	<"PVGA1C">
WESTERNDIG_WD9030_NAME	EQU	<"PVGA1D">
WESTERNDIG_WD9026_NAME	EQU	<"WD90C26">
WESTERNDIG_WD9027_NAME	EQU	<"WD90C27">
WESTERNDIG_WD9031_NAME	EQU	<"WD90C31">
WESTERNDIG_WD9024_NAME	EQU	<"WD90C24">
WESTERNDIG_WD9033_NAME	EQU	<"WD90C33">
ATI_18800_CHIP	EQU	1  ; VGAWONDER  
ATI_28800_CHIP	EQU	2  ; VGAWONDER+/XL  
ATI_38800_CHIP	EQU	3  ; MACH8/GraphicsUltra         /*          */
ATI_68800_CHIP	EQU	4  ; MACH32/GraphicsUltraPro     /*          */
ATI_88800_CHIP	EQU	5  ; MACH64                      /*          */
MAX_ATI_CHIP	EQU	ATI_88800_CHIP                  ;             
ATI_18800_NAME	EQU	<"ATI18800">
ATI_28800_NAME	EQU	<"ATI28800">
ATI_38800_NAME	EQU	<"ATI38800MACH8">
ATI_68800_NAME	EQU	<"ATI68800MACH32">
ATI_88800_NAME	EQU	<"ATI88800MACH64">
IBM_SVGA_CHIP	EQU	1 
MAX_IBM_CHIP	EQU	IBM_SVGA_CHIP                   ;             
IBM_SVGA_NAME	EQU	<"IBMSVGA">
CIRRUS_5420_CHIP	EQU	1                                ;             
CIRRUS_5422_CHIP	EQU	2 
CIRRUS_5424_CHIP	EQU	3 
CIRRUS_5426_CHIP	EQU	4 
CIRRUS_5428_CHIP	EQU	5                                ;             
CIRRUS_5429_CHIP	EQU	6                                ;             
CIRRUS_543X_CHIP	EQU	7                                ;             
CIRRUS_5434_CHIP	EQU	8                                ;             
MAX_CIRRUS_CHIP	EQU	CIRRUS_5434_CHIP                ;             
CIRRUS_5420_NAME	EQU	<"GD5420">
CIRRUS_5422_NAME	EQU	<"GD5422">
CIRRUS_5424_NAME	EQU	<"GD5424">
CIRRUS_5426_NAME	EQU	<"GD5426">
CIRRUS_5428_NAME	EQU	<"GD5428">
CIRRUS_5429_NAME	EQU	<"GD5429">
CIRRUS_543X_NAME	EQU	<"GD543X">
CIRRUS_5434_NAME	EQU	<"GD5434">
S3_86C805_CHIP	EQU	1            ;  801 or 805   
S3_86C928_CHIP	EQU	2 
S3_86C911_CHIP	EQU	3            ;               
S3_86C864_CHIP	EQU	4                                ;             
S3_86C964_CHIP	EQU	5                                ;             
MAX_S3_CHIP	EQU	S3_86C964_CHIP                  ;             
S3_86C805_NAME	EQU	<"S386C80X">
S3_86C928_NAME	EQU	<"S386C928">
S3_86C911_NAME	EQU	<"S386C911">
S3_86C864_NAME	EQU	<"S386C864">
S3_86C964_NAME	EQU	<"S386C964">
CHIPS_FIRST_CHIP	EQU	1                 ;  bogus chip                
MAX_CHIPS_CHIP	EQU	1                                ;             
WEITEK_P9000_CHIP	EQU	1                                ;             
WEITEK_W5186_CHIP	EQU	2                                ;             
WEITEK_W5286_CHIP	EQU	3                                ;             
WEITEK_P9100_CHIP	EQU	4                                ;             
MAX_WEITEK_CHIP	EQU	WEITEK_P9100_CHIP               ;             
WEITEK_P9000_NAME	EQU	<"P9000">
WEITEK_W5186_NAME	EQU	<"W5186">
WEITEK_W5286_NAME	EQU	<"W5286">
; 
;* OEM manufacturer defines.
UNKNOWN_MANUFACTURER	EQU	0                                ;             
DIAMOND_MANUFACTURER	EQU	1                                ;             
ORCHID_MANUFACTURER	EQU	2                                ;             
NUMBER9_MANUFACTURER	EQU	3                                ;             
ARTIST_MANUFACTURER	EQU	4                                ;             
LACUNA_MANUFACTURER	EQU	5                                ;             
STB_MANUFACTURER	EQU	6                                ;             
S3_MANUFACTURER	EQU	7                                ;             
CIRRUS_MANUFACTURER	EQU	8 
MIROCRYSTAL_MANUFACTURER	EQU	9                             ;             
VIDEOLOGIC_MANUFACTURER	EQU	10                            ;             
THINKPAD_MANUFACTURER	EQU	11                              ; @V3.0YEE02  
MANUFACTURER_MAX	EQU	THINKPAD_MANUFACTURER           ; @V3.0YEE02  
DEFAULT_MANUFACTURER	EQU	UNKNOWN_MANUFACTURER            ;             
; 
;* Mode flag values
;* used in VIDEOMODEINFO
MODE_FLAG_NOT_MONO	EQU	0001H   ;  Mono-compatible                    
MODE_FLAG_GRAPHICS	EQU	0002H   ;  Text mode, Graphics                
MODE_FLAG_NO_CLR_BRST	EQU	0004H   ;  Disable Color burst                
MODE_FLAG_NATIVE	EQU	0008H   ;  Native (advanced function) mode    
IGNORE_CLR_BRST	EQU	0010H   ;  Disable color burst doesn't make   
                                        ;  sense for this mode                
NOT_PLASMA	EQU	0020H   ;             won't work on plasma    
                                        ;  display                            
MODE_FLAG_VGA_ENTRY	EQU	0040H   ;  VGA mode, need clean up            
; 
;* definitions of bus type
;  
ISA_BUS	EQU	0 
VLB_BUS	EQU	1 
PCI_BUS	EQU	2 
EISA_BUS	EQU	3 
PCMCIA_BUS	EQU	4 
MCA_BUS	EQU	5 
; 
; endian type
LITTLE_ENDIAN	EQU	0 
BIG_ENDIAN	EQU	1 
; 
;* VIDEOPMI.DLL prototypes.
; 
;* Save Restore constants
STATEFLAG_REGISTERS	EQU	0001H   ;                                     
STATEFLAG_CLUT	EQU	0002H   ;                                     
STATEFLAG_VRAM	EQU	0004H   ;                                     
STATEFLAG_FONT	EQU	0008H   ;                                     
; 
;* Function request parameters supported.
PMIREQUEST_SETMODE	EQU	0 
PMIREQUEST_LOCKREGISTERS	EQU	1 
PMIREQUEST_UNLOCKREGISTERS	EQU	2 
PMIREQUEST_CLEANUP	EQU	3 
PMIREQUEST_SAVESTATE	EQU	4 
PMIREQUEST_RESTORESTATE	EQU	5 
PMIREQUEST_GETBANK	EQU	6 
PMIREQUEST_SETBANK	EQU	7 
PMIREQUEST_GETCLUT	EQU	8 
PMIREQUEST_SETCLUT	EQU	9 
PMIREQUEST_GETPALETTE	EQU	10 
PMIREQUEST_SETPALETTE	EQU	11 
PMIREQUEST_GETFONT	EQU	12 
PMIREQUEST_SETFONT	EQU	13 
PMIREQUEST_TUNEDISPLAY	EQU	14         ;               
PMIREQUEST_QUERYMAXMODEENTRIES	EQU	15 
PMIREQUEST_QUERYMAXMODELISTSIZE	EQU	16 
PMIREQUEST_QUERYMODEINFODATA	EQU	17 
PMIREQUEST_QUERYMAXTRAPENTRIES	EQU	18 
PMIREQUEST_QUERYTRAPLISTDATA	EQU	19 
PMIREQUEST_QUERYMODEHRDWRLIST	EQU	20         ;               
PMIREQUEST_LOADPMIFILE	EQU	21 
PMIREQUEST_IDENTIFYADAPTER	EQU	22 
PMIREQUEST_MAX	EQU	(PMIREQUEST_IDENTIFYADAPTER + 1 ) ;  last entry + 1   
ifndef INCL_DOSDEVIOCTL                ; @senja: bsedev.h can't be used by vvid
ifndef BSEDEV_INCLUDED                 ; don't define if bsedev already included
SCREENDD_SVGA_ID	EQU	08H     ;  Get SVGA info IOCTL   
SCREENDD_SVGA_OEM	EQU	09H     ;  Get OEM info IOCTL   
SCREENDD_CATEGORY	EQU	80H 
SCREENDD_NAME	EQU	<"SCREEN$">
                                           ;  SCREENDD_SVGA_ID   

OEMSVGAINFO	STRUC
AdapterType	DW	?
ChipType	DW	?
Memory	DD	?
OEMSVGAINFO	ENDS
                                           ;  SCREENDD_SVGA_OEM   

OEMINFO	STRUC
OEMLength	DD	?
Manufacturer	DW	?
ManufacturerData	DD	?
OEMINFO	ENDS
endif
endif
