/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#ifndef DDTPCMC_H
#define DDTPCMC_H
/*
************************************************************************
**
** Classification: IBM Test Tool
**
** Original Author and Date: Kishan Kasety, March 1994.
**
** Filename:    DDTPCMC.H
**
** Description: This file provides the functional description for the 
**              PCMCIA stub routines for device driver test.
**
** Revisions:
**
*************************************************************************
*/

#include "ddt.h"
#include <stdio.h>


// PCMCIA Device Driver Test Procedures.

extern "C" {

APIRET _export PCMC_Open		( Kwd_List& );
APIRET _export PCMC_Close		( Kwd_List& );
APIRET _export PCMC_GetAdapterCount	( Kwd_List& );
APIRET _export PCMC_AckInterrupt	( Kwd_List& );
APIRET _export PCMC_PriorHandler	( Kwd_List& );
APIRET _export PCMC_SSAddr		( Kwd_List& );
APIRET _export PCMC_AccessOffsets	( Kwd_List& );
APIRET _export PCMC_GetAdapter		( Kwd_List& );
APIRET _export PCMC_GetSSInfo		( Kwd_List& );
APIRET _export PCMC_GetVendorInfo	( Kwd_List& );
APIRET _export PCMC_InqAdapter		( Kwd_List& );
APIRET _export PCMC_SetAdapter		( Kwd_List& );
APIRET _export PCMC_VendorSpecific	( Kwd_List& );
APIRET _export PCMC_GetSocket		( Kwd_List& );
APIRET _export PCMC_GetStatus		( Kwd_List& );
APIRET _export PCMC_InqSocket		( Kwd_List& );
APIRET _export PCMC_ResetSocket		( Kwd_List& );
APIRET _export PCMC_SetSocket		( Kwd_List& );
APIRET _export PCMC_GetPage		( Kwd_List& );
APIRET _export PCMC_GetWindow		( Kwd_List& );
APIRET _export PCMC_InqWindow		( Kwd_List& );
APIRET _export PCMC_SetPage		( Kwd_List& );
APIRET _export PCMC_SetWindow		( Kwd_List& );
APIRET _export PCMC_GetEDC		( Kwd_List& );
APIRET _export PCMC_InquireEDC		( Kwd_List& );
APIRET _export PCMC_PauseEDC		( Kwd_List& );
APIRET _export PCMC_ReadEDC		( Kwd_List& );
APIRET _export PCMC_ResumeEDC		( Kwd_List& );
APIRET _export PCMC_SetEDC		( Kwd_List& );
APIRET _export PCMC_StartEDC		( Kwd_List& );
APIRET _export PCMC_StopEDC		( Kwd_List& );
VOID   printerror			(ULONG&, Kwd_List &);
} // extern "C"
#endif
