/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = DTT-DLL.H
 *
 * DESCRIPTIVE NAME = Test case header file
 *
 *
 *      DISCLAIMER OF WARRANTIES.  The following enclosed code is sample
 *      code created by IBM Corporation.  This sample code is not part of
 *      any standard or IBM product and is provided to you solely for the
 *      purpose of assisting you in the development of your applications.
 *      The code is provided "AS IS", without warranty of any kind.  IBM
 *      shall not be liable for any damages arising out of your use of the
 *      sample code, even if they have been advised of the possibility of
 *      such damages.
 *
 * VERSION = V1.1
 *
 * DATE      10/31/92
 *
 * DESCRIPTION  This header file is a common include file that is included
 *              by the DTT.H and DTTDLLDF.H includes files.  It contains
 *              variables, constants, and typedefs that are common to both
 *              the DTT and the test case DLLs.
 *
 * FUNCTIONS    None
 *
 * NOTES
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
*/

#include <stdlib.h>


 /*
 ** User defined messages for communication between test cases and the
 ** client window of the test processor.
 */

#define WM_TEST_DOES_DEVCALLS    WM_USER + 200
#define WM_DTHREAD_DOES_DEVCALLS WM_TEST_DOES_DEVCALLS + 1
#define WM_GET_DEVOPENSTRUC      WM_DTHREAD_DOES_DEVCALLS + 1
#define WM_TEST_SIGNATURE        WM_GET_DEVOPENSTRUC + 1
#define WM_TEST_LOG              WM_TEST_SIGNATURE + 1
#define WM_GET_ENV_INFO          WM_TEST_LOG + 1
#define WM_LOG_SIGNATURE         WM_GET_ENV_INFO + 1
#define WM_TEST_PROGRESS         WM_LOG_SIGNATURE + 1



 /*
 ** Define the function type for the test cases defined in the DLLs
 ** and the parameters that will be passed to the InitTest procedure
 ** of each DLL to determine the test case entry points.
 */

 /*
 ** definition of the initialization info structure used by DTT to get
 ** info from the test case dll
 */


#define ENTRYPOINTS  50        /* Maximum number of test cases within a DLL */
#define NAMELENGTH   40        /* Maximum length of test case name          */


 /*
 ** #defines and typedef used by the WM_GET_ENV_INFO user defined message
 */

#define DTT_INTERACTIVE 0
#define DTT_SCRIPT      1
#define DTT_SCREEN      0

#define TEST_CASE_SIZE   (sizeof(TEST_CASE_COMPONENT))
#define ENTRY_POINT_SIZE ( sizeof(ENTRYPOINT))

//typedef VOID (APIENTRY    *PDLLFN)(HPS,HWND,BOOL);
typedef VOID (APIENTRY    DLLFN)(HPS,HWND,BOOL);
typedef DLLFN *PDLLFN;

typedef struct _TESTINITINFO
{
   USHORT   ntests;
   CHAR     group_name[NAMELENGTH];
   CHAR     test_names[ENTRYPOINTS][NAMELENGTH];
   PDLLFN   test_addrs[ENTRYPOINTS];
}  TESTINITINFO,  *PTESTINITINFO;

struct  _EntryPoint
{
        CHAR   szTestName[NAMELENGTH];
        struct _TestCaseComponent * pTestCaseComponent;
        PDLLFN TestAddress;
};

typedef struct _EntryPoint ENTRYPOINT, * PENTRYPOINT;


struct _TestCaseComponent
{
    USHORT      ntests;
    CHAR        group_name[NAMELENGTH];
    struct _EntryPoint * pEntryPoint;
    HMODULE     DLL_Handle;
    USHORT      TestCaseFlags;
    CHAR        FullDllName[_MAX_PATH];
};

typedef struct _TestCaseComponent TEST_CASE_COMPONENT, * PTEST_CASE_COMPONENT;


 /*
 **  Test case component flags
 */

#define TESTCASELOADED        0x0001   /* Test case is loaded                 */
#define TESTCASEPERMANENT     0x0002   /* Test case is permanently loaded     *.


 /*
 ** definition of the operating environment info structure that is filled in
 ** upon request of the test case dll
 */

typedef struct _TESTENVIRONMENTINFO
{
   USHORT   usOperatingMode;
   USHORT   usOutputMode;
   ULONG    ulPSType;
}  TESTENVINFO,  *PTESTENVINFO;


 /*
 ** Logging level defines
 */

#define L_HDR     1
#define L_ABORT   2
#define L_FAIL    4
#define L_WARN    6
#define L_TRACE   7
#define L_LOTRACE 8
#define L_DEBUG   9
