/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/***************************************************************************
 *\\ddd
 * Subtask Name: DTT
 *
 * Module name: GreArc
 *
 * Purpose: GreArc.dll include file
 *
 *  $header$
 *
 * Revision Log:  01/07/91 ,PDVT ,Mike Abuzant
 *                Prototype
 *
 *                10/14/91 ,DTT , Ken McFadden
 *                              Gre Arc Testcase
 *
 *
 *
 *
 *
 *
 * Contents:  This file contains the following definitions:
 *
 *              - function prototypes
 *              - number of tests
 *      - name of tests
 *
 * Limitations:
 *  None
 *
 *\\end
 ***************************************************************************/

/* declare all dll functions */
VOID  APIENTRY InitTest(PVOID, PTESTINITINFO );
extern VOID  APIENTRY GreArcPre1(HPS, HWND, BOOL);
extern VOID  APIENTRY GreArcPre2(HPS, HWND, BOOL);
extern VOID  APIENTRY GreSetandGetArcParametersExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreSetandGetDefArcParametersExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreArcExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GrePartialArcExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreFullArcInteriorExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreFullArcBoundaryExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreFullArcBothExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreBoxInteriorExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreBoxBoundaryExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreBoxBothExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GrePolyFilletExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GrePolyFilletSharpExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GrePolySplineExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreDrawConicsInPathExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreCookWholePathExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreCookPathCurvesExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreRenderPathExh(HPS, HWND, BOOL);
extern VOID  APIENTRY GreSetArcandDefArcParametersRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreGetArcandDefArcParametersRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreArcRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GrePartialArcRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreFullArcInteriorRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreFullArcBoundaryRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreFullArcBothRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreBoxInteriorRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreBoxBoundaryRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreBoxBothRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GrePolyFilletRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GrePolyFilletSharpRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GrePolySplineRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreDrawConicsInPathRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreCookWholePathRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreCookPathCurvesRc(HPS, HWND, BOOL);
extern VOID  APIENTRY GreRenderPathRc(HPS, HWND, BOOL);

PCHAR  TestCaseName= "GreArcTests";
int    seed = 0;
LONG   ErrorCount;
CHAR   szDontMatch[] = "arc parameters don't match";

static  NAMES_AND_ADDRESSES EntryPointList[]=
   {
        TOKENIZEFUNCTIONNAME(GreArcPre1),
        TOKENIZEFUNCTIONNAME(GreArcPre2),
        TOKENIZEFUNCTIONNAME(GreSetandGetArcParametersExh),
        TOKENIZEFUNCTIONNAME(GreSetandGetDefArcParametersExh),
        TOKENIZEFUNCTIONNAME(GreArcExh),
        TOKENIZEFUNCTIONNAME(GrePartialArcExh),
        TOKENIZEFUNCTIONNAME(GreFullArcInteriorExh),
        TOKENIZEFUNCTIONNAME(GreFullArcBoundaryExh),
        TOKENIZEFUNCTIONNAME(GreFullArcBothExh),
        TOKENIZEFUNCTIONNAME(GreBoxInteriorExh),
        TOKENIZEFUNCTIONNAME(GreBoxBoundaryExh),
        TOKENIZEFUNCTIONNAME(GreBoxBothExh),
        TOKENIZEFUNCTIONNAME(GrePolyFilletExh),
        TOKENIZEFUNCTIONNAME(GrePolyFilletSharpExh),
        TOKENIZEFUNCTIONNAME(GrePolySplineExh),
        // TOKENIZEFUNCTIONNAME(GreDrawConicsInPathExh),
        // TOKENIZEFUNCTIONNAME(GreCookWholePathExh),
        // TOKENIZEFUNCTIONNAME(GreCookPathCurvesExh),
        // TOKENIZEFUNCTIONNAME(GreRenderPathExh),
        TOKENIZEFUNCTIONNAME(GreSetArcandDefArcParametersRc),
        TOKENIZEFUNCTIONNAME(GreGetArcandDefArcParametersRc),
        TOKENIZEFUNCTIONNAME(GreArcRc),
        TOKENIZEFUNCTIONNAME(GrePartialArcRc),
        TOKENIZEFUNCTIONNAME(GreFullArcInteriorRc),
        TOKENIZEFUNCTIONNAME(GreFullArcBoundaryRc),
        TOKENIZEFUNCTIONNAME(GreFullArcBothRc),
        TOKENIZEFUNCTIONNAME(GreBoxInteriorRc),
        TOKENIZEFUNCTIONNAME(GreBoxBoundaryRc),
        TOKENIZEFUNCTIONNAME(GreBoxBothRc),
        TOKENIZEFUNCTIONNAME(GrePolyFilletRc),
        TOKENIZEFUNCTIONNAME(GrePolyFilletSharpRc),
        TOKENIZEFUNCTIONNAME(GrePolySplineRc),
        // TOKENIZEFUNCTIONNAME(GreDrawConicsInPathRc),
        // TOKENIZEFUNCTIONNAME(GreCookWholePathRc),
        // TOKENIZEFUNCTIONNAME(GreCookPathCurvesRc),
        // TOKENIZEFUNCTIONNAME(GreRenderPathRc),
   };

typedef struct {
          POINTL Max;
          POINTL Min;
        } PSRANGE;

typedef PSRANGE FAR *PPSRANGE;
