/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#pragma pagesize(59)

/* const char header=$header$ */

#define INCL_DOSPROCESS
#define INCL_DEV      // include all DEV definitions
#define INCL_WIN
#define INCL_GPI      // include all Gpi definitions
#define INCL_GRE_ARCS
#define INCL_DDIMISC
#define INCL_DDIBUNDLES
#define INCL_ERRORS   // include all Gpi error definitions

#include <os2.h>
#include <pmddi.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "DTTDLLDF.h"               // test case defines
#include "common1.h"
#include "grearcp.h"

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreArcPre1()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          precesion test of GrePartialArc(), GreFullArcInterior(),
 *          GreFullArcBoundary(), GreFullArcBoth(), GreArc().
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 10/18/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              if device = printer then
 *                   ABORTENTRY();
 *              ENTER_MAIN();
 *              set limits for clip region;
 *              create region;
 *              set clip region;
 *              call gpi_grid(HALF_INCH);
 *              set pattern to PATSYM_DENSE7;
 *              destroy region;
 *              SUBENTER(Circle/Ellipse Test);
 *                set pointl to x = 2" and y = max page size - 2";
 *                print text strings;
 *                set color to red;
 *                set arc prameters: r = 0, q = 1/2", p = 1/2" and s = 0;
 *                GreSetArcParameters();
 *                GreGetArcParameters();
 *                compare arc parameters;
 *                GreFullArcInterior();
 *                set arc prameters: r = 0, q = 1", p = 2" and s = 0;
 *                GreSetArcParameters();
 *                GreGetArcParameters();
 *                compare arc parameters;
 *                GreFullArcBoundary();
 *                set color to blue;
 *                set arc prameters: r = 0, q = 1", p = 1" and s = 0;
 *                GreSetArcParameters();
 *                GreGetArcParameters();
 *                compare arc parameters;
 *                GreFullArcBoth();
 *                set color to black;
 *              SUBEXIT();
 *
 *              SUBENTER(Semi-Circle Test);
 *                set pointl to x = 1" and y = 1";
 *                print text strings;
 *                set color to red;
 *                set arc prameters: r = 0, q = 1", p = 1" and s = 0;
 *                GreSetArcParameters();
 *                GreGetArcParameters();
 *                compare arc parameters;
 *                GrePartialArc();
 *                set arc prameters: r = 0, q = 2", p = 2" and s = 0;
 *                GreSetArcParameters();
 *                GreGetArcParameters();
 *                compare arc parameters;
 *                GrePartialArc();
 *                set color to black;
 *              SUBEXIT();
 *
 *              SUBENTER(Chords Test);
 *                set pointl to x = 7" and y = 3";
 *                print text strings;
 *                set color to red;
 *                apointl to 1" arc;
 *                GreArc();
 *                apointl to 2" arc;
 *                GreArc();
 *                set color to black;
 *              SUBEXIT();
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreArcPre1(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static CHAR     szApiEntryName[] = "GreArcPre1";         // entry point name
static CHAR     szSetGetName[] = "GreGetandSetArcParameters:";
static CHAR     szSetName[] = "GreSetArcParameters";
static CHAR     szGetName[] = "GreGetArcParameters";
static CHAR     szGreFullInterior[] = "GreFullArcInterior";
static CHAR     szGreFullBoundary[] = "GreFullArcBoundary";
static CHAR     szGreFullBoth[] = "GreFullArcBoth";
static CHAR     szGrePartial[] = "GrePartialArc";
static CHAR     szGreArc[] = "GreArc";

static POINTL   ptl;
static POINTL   aptl[2];
static ARCPARAMS arcParm1, arcParm2;
static HDC      hDC;
static RECTL    rect;
static HRGN     hrgn;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
        {
           ENTER_MAIN(szApiEntryName);
           ErrorCount = 0;
           hDC = GpiQueryDevice(hPS);
           rect.xLeft = 0;
           rect.yBottom = (alDevCaps[CAPS_HEIGHT] / pg_size_y) * 3/4; // Device height in pixels.
           rect.xRight = alDevCaps[CAPS_WIDTH ];              // Device width in pixels.
           rect.yTop = alDevCaps[CAPS_HEIGHT];
           hrgn=GpiCreateRegion(hPS,1L,&rect);
           GpiSetClipRegion(hPS,hrgn,NULL);

           gpi_grid(hPS, HALF_INCH);
           GpiSetPattern(hPS, PATSYM_DENSE7);
           GpiSetClipRegion(hPS,NULLHANDLE,&hrgn);
           GpiDestroyRegion(hPS,hrgn);

           SUBENTER(szSetGetName, "Circle/Ellipse Test");
           ptl.x = delta_x * 2;                                // set position for the location
           ptl.y = delta_y * (pg_size_y - 2);                           // of drawing to the PS.
           MapPt(ptl);
           WorldWriteString(ptl.x,
                            ((ptl.y - syPosition) - MapY(delta_y / 2 - 2)),
                            "Full Interior");
           WorldWriteString(ptl.x,
                            ((ptl.y - syPosition) - MapY(delta_y - 2)),
                            "Full Boundary");
           WorldWriteString(ptl.x + MapX(delta_x * 2),
                            ((ptl.y - syPosition) - MapY(delta_y - 2)),
                            "Full Both");
           GpiMove(hPS, &ptl);
           GpiSetColor(hPS, CLR_RED);
           arcParm1.lR = 0L;                                // set arc parameters for 1/2" circle.
           arcParm1.lQ = delta_y/2;
           arcParm1.lP = delta_x/2;
           arcParm1.lS = 0L;
           MapArc(arcParm1);
           if (!GreSetArcParameters(hDC, &arcParm1))            // set parameters.
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szSetName,szOne);
             }
           if (!GreGetArcParameters(hDC, &arcParm2))            // get current parameters.
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGetName,szOne);
             }
           if(memcmp(&arcParm1, &arcParm2, sizeof(ARCPARAMS)))  // compare current parameters
             {                                                     // with set parameters.
                ErrorCount++;
                ERRSTATUS(TRUE,szDontMatch,szOne);
             }
           if (!GreFullArcInterior(hDC, MAKEFIXED(1,0)))         // draw object from set parameters.
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGreFullInterior,szOne);
             }

           GpiSetColor(hPS, CLR_DARKCYAN);
           arcParm1.lR = 0L;                                    // set arc parameters to a 1" by 2"
           arcParm1.lQ = delta_y;                                  // ellipse.
           arcParm1.lP = delta_x * 2;
           arcParm1.lS = 0L;
           MapArc(arcParm1);
           if (!GreSetArcParameters(hDC, &arcParm1))             // set parameters.
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szSetName,szTwo);
             }
           if (!GreGetArcParameters(hDC, &arcParm2))            // get current parameters.
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGetName,szTwo);
             }
           if(memcmp(&arcParm1, &arcParm2, sizeof(ARCPARAMS)))  // compare current parameters
             {                                                     // to set parameters.
                ErrorCount++;
                ERRSTATUS(TRUE,szDontMatch,szTwo);
             }
           if (!GreFullArcBoundary(hDC, MAKEFIXED(1,0)))        // draw object from set parameters.
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGreFullBoundary,szOne);
             }
           ptl.x = delta_x * 4;                                 // set position to far edge of
           ptl.y = delta_y * (pg_size_y - 2);                      // the ellipse.
           MapPt(ptl);
           GpiMove(hPS, &ptl);
           GpiSetColor(hPS, CLR_BLUE);
           arcParm1.lR = 0L;                                    // set arc parameters to be a
           arcParm1.lQ = delta_y;                                  // 1" circle.
           arcParm1.lP = delta_x;
           arcParm1.lS = 0L;
           MapArc(arcParm1);
           if (!GreSetArcParameters(hDC, &arcParm1))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szSetName,szTwo);
             }
           if (!GreGetArcParameters(hDC, &arcParm2))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGetName,szTwo);
             }
           if(memcmp(&arcParm1, &arcParm2, sizeof(ARCPARAMS)))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szDontMatch,szTwo);
             }
           if (!GreFullArcBoth(hDC, MAKEFIXED(1,0)))            // draw object where far edge of
             {                                                     // the ellipse intersects the
                ErrorCount++;                                      // center of the circle.
                ERRSTATUS(TRUE,szGreFullBoth,szOne);
             }
           GpiSetColor(hPS, CLR_BLACK);
           SUBEXIT();

           SUBENTER(szSetGetName, "Semi-Circle Test");
           ptl.x = delta_x;                                     // set position for the location
           ptl.y = delta_y;                                        // of drawing to the PS.
           MapPt(ptl);
           WorldWriteString(ptl.x - MapX(delta_x / 2),
                            ptl.y,
                            "Semi-Circles");
           GpiMove(hPS, &ptl);
           GpiSetColor(hPS, CLR_PINK);
           arcParm1.lR = 0L;                                    // set arc parameters to a 1"
           arcParm1.lQ = delta_y;                                  // semi-circle.
           arcParm1.lP = delta_x;
           arcParm1.lS = 0L;
           MapArc(arcParm1);
           if (!GreSetArcParameters(hDC, &arcParm1))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szSetName,szOne);
             }
           if (!GreGetArcParameters(hDC, &arcParm2))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGetName,szOne);
             }
           if(memcmp(&arcParm1, &arcParm2, sizeof(ARCPARAMS)))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szDontMatch,szOne);
             }
           if (!GrePartialArc(hDC, &ptl, MAKEFIXED(1,0),
                                         MAKEFIXED(0,0),
                                         MAKEFIXED(90,0)))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGrePartial,szOne);
             }

           GpiSetColor(hPS, CLR_DARKGREEN);
           ptl.x = delta_x;
           ptl.y = delta_y;
           MapPt(ptl);
           GpiMove(hPS, &ptl);
           arcParm1.lR = 0L;                            // set arc parameters to a 2"
           arcParm1.lQ = delta_y * 2;                      // semi-circle.
           arcParm1.lP = delta_x * 2;
           arcParm1.lS = 0L;
           MapArc(arcParm1);
           if (!GreSetArcParameters(hDC, &arcParm1))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szSetName,szTwo);
             }
           if (!GreGetArcParameters(hDC, &arcParm2))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGetName,szTwo);
             }
           if(memcmp(&arcParm1, &arcParm2, sizeof(ARCPARAMS)))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szDontMatch,szTwo);
             }
           if (!GrePartialArc(hDC, &ptl, MAKEFIXED(1,0),
                                         MAKEFIXED(0,0),
                                         MAKEFIXED(90,0)))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGrePartial,szTwo);
             }
           GpiSetColor(hPS, CLR_BLACK);
           SUBEXIT();

           SUBENTER(szSetGetName, "Chords Test");
           ptl.x = delta_x * 7;                         // set position for the location
           ptl.y = delta_y * 3;                            // of drawing to the PS.
           MapPt(ptl);
           WorldWriteString(ptl.x - MapX(delta_x/2),
                            ptl.y - MapY(delta_y/2),
                            "Chords");
           GpiSetColor(hPS, CLR_DARKRED);
           GpiMove(hPS, &ptl);
           aptl[0].x = ptl.x - MapX(delta_x);           // setup arc info.
           aptl[0].y = ptl.y;
           aptl[1].x = ptl.x - MapX(delta_x);
           aptl[1].y = ptl.y - MapY(delta_y);

           if (!GreArc(hDC, aptl))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGreArc,szOne);
             }

           ptl.x = delta_x * 7;
           ptl.y = delta_y * 3;
           MapPt(ptl);
           GpiMove(hPS, &ptl);

           GpiSetColor(hPS, CLR_DARKBLUE);
           aptl[0].x = ptl.x - MapX(delta_x * 2);       // setup arc info.
           aptl[0].y = ptl.y;
           aptl[1].x = ptl.x - MapX(delta_x * 2);
           aptl[1].y = ptl.y - MapY(delta_y * 2);

           if (!GreArc(hDC, aptl))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGreArc,szTwo);
             }
           GpiSetColor(hPS, CLR_BLACK);
           SUBEXIT();
           EXIT_MAIN(szApiEntryName);
        }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreArcPre2()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          precesion test of GrePartialArc(), GreFullArcInterior(),
 *          GreFullArcBoundary(), GreFullArcBoth(), GreArc().
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 10/22/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print PS.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              if device = printer then
 *                   ABORTENTRY();
 *              ENTER_MAIN();
 *              set limits for clip region;
 *              create region;
 *              set clip region;
 *              call gpi_grid(HALF_INCH);
 *              destroy region;
 *              SUBENTER(PolyFillet Test);
 *                set pointl to x = 2" and y = max page size - 3";
 *                print text strings;
 *                set color to red;
 *                set apointl to 1" circle;
 *                GrePolyFillet();
 *                set apointl to 2" by 4" ellipse;
 *                GrePolyFillet();
 *                set color to black;
 *              SUBEXIT();
 *
 *              SUBENTER(PolyFilletSharp Test);
 *                set pointl to x = 5" and y = max page size - 3";
 *                print text strings;
 *                set color to red;
 *                set apointl to 1" arc;
 *                GrePolyFillet();
 *                set apointl to 2" arc;
 *                GrePolyFillet();
 *                set apointl to 3" arc;
 *                GrePolyFillet();
 *                set color to black;
 *              SUBEXIT();
 *
 *              SUBENTER(PolySpline Test);
 *                set pointl to x = 0" and y = 2";
 *                print text strings;
 *                set color to red;
 *                set apointl to 2" sine wave;
 *                GrePolySpline();
 *                set color to black;
 *              SUBEXIT();
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreArcPre2(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static CHAR     szApiEntryName[] = "GreArcPre2";         // entry point name
static CHAR     szGrePolyFillet[] = "GrePolyFillet";
static CHAR     szGrePolyFilletSharp[] = "GrePolyFilletSharp";
static CHAR     szGrePolySpline[] = "GrePolySpline";

static POINTL   ptl;
static POINTL   aptl[128];
static FIXED    afx[1];
static HDC      hDC;
static RECTL    rect;
static HRGN     hrgn;
LONG            cnt1,cnt2;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
        {
           ENTER_MAIN(szApiEntryName);
           ErrorCount = 0;
           hDC = GpiQueryDevice(hPS);
           rect.xLeft = 0;
           rect.yBottom = (alDevCaps[CAPS_HEIGHT] / pg_size_y) * 3/4; // Device height in pixels.
           rect.xRight = alDevCaps[CAPS_WIDTH ];              // Device width in pixels.
           rect.yTop = alDevCaps[CAPS_HEIGHT];
           hrgn=GpiCreateRegion(hPS,1L,&rect);
           GpiSetClipRegion(hPS,hrgn,NULL);

           gpi_grid(hPS, HALF_INCH);
           GpiSetClipRegion(hPS,NULLHANDLE,&hrgn);
           GpiDestroyRegion(hPS,hrgn);

           SUBENTER(szSetGetName, "PolyFillet Test");
           ptl.x = delta_x * 2;                                 // set position for the location
           ptl.y = delta_y * (pg_size_y - 3);                      // of drawing to the PS.
           MapPt(ptl);
           WorldWriteString(ptl.x,
                            ((ptl.y - syPosition) - MapY(2)),
                            "PolyFillet");
           GpiMove(hPS, &ptl);
           GpiSetColor(hPS, CLR_RED);
           aptl[0].x = ptl.x + MapX(delta_x/2);                 // setup arc info to draw a
           aptl[0].y = ptl.y;                                      // 1" circle.
           aptl[1].x = aptl[0].x;
           aptl[1].y = ptl.y + MapY(delta_y);
           aptl[2].x = ptl.x - MapX(delta_x/2);
           aptl[2].y = aptl[1].y;
           aptl[3].x = aptl[2].x;
           aptl[3].y = ptl.y;
           aptl[4].x = ptl.x;
           aptl[4].y = ptl.y;

           if (!GrePolyFillet(hDC, &aptl[0], 5L))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGrePolyFillet,szOne);
             }

           GpiSetColor(hPS, CLR_DARKBLUE);
           aptl[0].x = ptl.x + MapX(delta_x * 2);               // setup arc info to draw 2" by 4"
           aptl[1].x = aptl[0].x;                                  // ellipse.
           aptl[1].y = ptl.y + MapY(delta_y * 2);
           aptl[2].x = ptl.x - MapX(delta_x * 2);
           aptl[2].y = aptl[1].y;
           aptl[3].x = aptl[2].x;
           if (!GrePolyFillet(hDC, &aptl[0], 5L))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGrePolyFillet,szTwo);
             }

           GpiSetColor(hPS, CLR_BLACK);
           SUBEXIT();

           SUBENTER(szSetGetName, "PolyFilletSharp Test");
           ptl.x = delta_x * 5;
           ptl.y = delta_y * (pg_size_y - 3);
           MapPt(ptl);
           WorldWriteString(ptl.x,
                            ((ptl.y - syPosition) - MapY(2)),
                            "PolyFilletSharp");
           GpiSetColor(hPS, CLR_DARKRED);
           afx[0] = MAKEFIXED(1,0);
           aptl[0].x = ptl.x + MapX(delta_x/2);                 // setup arc info to draw a
           aptl[0].y = ptl.y + MapY(delta_y * 2);                  // 1" arc.
           aptl[1].x = ptl.x + MapX(delta_x);
           aptl[1].y = ptl.y;

           GpiMove(hPS, &ptl);
           if (!GrePolyFilletSharp(hDC, &aptl[0], 2L, &afx[0]))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGrePolyFilletSharp,szOne);
             }

           GpiSetColor(hPS, CLR_DARKGREEN);
           aptl[0].x = ptl.x + MapX(delta_x);                   // setup arc info to draw a
           aptl[0].y = ptl.y + MapY(delta_y * 4);                  // 2" arc.
           aptl[1].x = ptl.x + MapX(delta_x * 2);
           aptl[1].y = ptl.y;

           GpiMove(hPS, &ptl);
           if (!GrePolyFilletSharp(hDC, &aptl[0], 2L, &afx[0]))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGrePolyFilletSharp,szTwo);
             }

           GpiSetColor(hPS, CLR_PINK);
           aptl[0].x = ptl.x + MapX(delta_x + delta_x/2);       // setup arc info to draw a
           aptl[0].y = ptl.y + MapY(delta_y * 6);                  // 3" arc.
           aptl[1].x = ptl.x + MapX(delta_x * 3);
           aptl[1].y = ptl.y;

           GpiMove(hPS, &ptl);
           if (!GrePolyFilletSharp(hDC, &aptl[0], 2L, &afx[0]))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGrePolyFilletSharp,szThree);
             }

           GpiSetColor(hPS, CLR_BLACK);
           SUBEXIT();

           SUBENTER(szSetGetName, "PolySpline Test");
           ptl.x = 0L;
           ptl.y = delta_y * 2;
           MapPt(ptl);
           WorldWriteString(ptl.x + MapX(delta_x * 4),
                            ptl.y + MapY(delta_y),
                            "PolySpline");
           GpiMove(hPS, &ptl);
           GpiSetColor(hPS, CLR_DARKCYAN);

           cnt2 = 2;
           aptl[0].x = ptl.x;                           // setup arc info to draw a
           aptl[0].y = ptl.y + MapY(delta_y);              // 2" sine wave.
           aptl[1].x = ptl.x + MapX(delta_x);
           aptl[1].y = aptl[0].y;
           aptl[2].x = aptl[1].x;
           aptl[2].y = ptl.y;

           aptl[3].x = aptl[1].x;
           aptl[3].y = ptl.y - MapY(delta_y);
           aptl[4].x = MapX(delta_x * cnt2++);
           aptl[4].y = aptl[3].y;
           aptl[5].x = aptl[4].x;
           aptl[5].y = ptl.y;

           for (cnt1=6;cnt1<24;cnt1++)
             {
                aptl[cnt1].x = aptl[cnt1-2].x;
                aptl[cnt1].y = aptl[0].y;cnt1++;
                aptl[cnt1].x = MapX(delta_x * cnt2++);
                aptl[cnt1].y = aptl[0].y;cnt1++;
                aptl[cnt1].x = aptl[cnt1-1].x;
                aptl[cnt1].y = ptl.y;cnt1++;

                aptl[cnt1].x = aptl[cnt1-2].x;
                aptl[cnt1].y = aptl[3].y;cnt1++;
                aptl[cnt1].x = MapX(delta_x * cnt2++);
                aptl[cnt1].y = aptl[3].y;cnt1++;
                aptl[cnt1].x = aptl[cnt1-1].x;
                aptl[cnt1].y = ptl.y;
             }

           aptl[cnt1].x = aptl[cnt1-2].x;                       // continue sine wave to
           aptl[cnt1].y = aptl[0].y;cnt1++;                        // end of graph.
           aptl[cnt1].x = MapX(delta_x * cnt2++);
           aptl[cnt1].y = aptl[0].y;cnt1++;
           aptl[cnt1].x = aptl[cnt1-1].x;
           aptl[cnt1].y = ptl.y;cnt1++;

           if (!GrePolySpline(hDC, &aptl[0], cnt1))
             {
                ErrorCount++;
                ERRSTATUS(TRUE,szGrePolySpline,szOne);
             }

           GpiSetColor(hPS, CLR_BLACK);
           SUBEXIT();

           EXIT_MAIN(szApiEntryName);
        }
   return;
}
