/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#pragma pagesize(59)

/* const char header=$header$ */

#define INCL_DOSPROCESS
#define INCL_DEV      // include all DEV definitions
#define INCL_WIN
#define INCL_GPI      // include all Gpi definitions
#define INCL_GRE_ARCS
#define INCL_GRE_DEVSUPPORT
#define INCL_DDIMISC
#define INCL_DDIBUNDLES
#define INCL_ERRORS   // include all Gpi error definitions

#include <os2.h>
#include <pmddi.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <malloc.h>
#include "DTTDLLDF.h"               // test case defines
#include "common1.h"
#include "grearcr.h"

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreSetArcandDefArcParametersRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreSetArcParameters and
 *          GreSetDefaultArcParameters.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 10/31/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set arc parameters to r=0, q=1, p=1, s=0;
 *
 *              set arc and set default arc parameters using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              set arc and set default arc parameters;
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreSetArcandDefArcParametersRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GreSetArcandDefArcParametersRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC;
static ARCPARAMS       arcParm;
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;
             arcParm.lR = 0L;                                // set arc parameters for 1/2" circle.
             arcParm.lQ = 1L;
             arcParm.lP = 1L;
             arcParm.lS = 0L;
             MapArc(arcParm);

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GreSetArcParameters(ThDC, &arcParm);
             CHECKRC(err, PMERR_INV_HDC, "GreSetArcParameters");
             err = GreSetDefaultArcParameters(ThDC, &arcParm);
             CHECKRC(err, PMERR_INV_HDC, "GreSetDefaultArcParameters");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreSetArcParameters(hDC, &arcParm);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC(err, PMERR_HDC_BUSY, "GreSetArcParameters");
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreSetDefaultArcParameters(hDC, &arcParm);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC(err, PMERR_HDC_BUSY, "GreSetDefaultArcParameters");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreGetArcandDefArcParametersRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreGetArcParameters and
 *          GreGetDefaultArcParameters.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 10/31/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set arc and set default arc parameters using r=0, q=1, p=1, s=0;
 *
 *              get arc and get default arc parameters using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              get arc and get default arc parameters;
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreGetArcandDefArcParametersRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GreGetArcandDefArcParametersRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC;
static ARCPARAMS       arcParm;
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;
             arcParm.lR = 0L;                                // set arc parameters for 1/2" circle.
             arcParm.lQ = 1L;
             arcParm.lP = 1L;
             arcParm.lS = 0L;
             MapArc(arcParm);

             if (!GreSetArcParameters(hDC, &arcParm))            // set parameters.
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetArcParameters",NULL);
               }
             if (!GreSetDefaultArcParameters(hDC, &arcParm))            // set parameters.
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetDefaultArcParameters",NULL);
               }

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GreGetArcParameters(ThDC, &arcParm);
             CHECKRC(err, PMERR_INV_HDC, "GreSetArcParameters");
             err = GreGetDefaultArcParameters(ThDC, &arcParm);
             CHECKRC(err, PMERR_INV_HDC, "GreSetDefaultArcParameters");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreGetArcParameters(hDC, &arcParm);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC(err, PMERR_HDC_BUSY, "GreGetArcParameters");
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreGetDefaultArcParameters(hDC, &arcParm);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC(err, PMERR_HDC_BUSY, "GreGetDefaultArcParameters");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreArcRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreArc.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 10/31/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set cursor position;
 *              setup arc points
 *
 *              call GreArc() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GreArc();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set first arc point to 0xFFFFFF;
 *              call GreArc();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *
 *              open a memory device context;
 *              call GreArc();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreArcRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GreArcRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl, aptl[2];
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);
             aptl[0].x = ptl.x - MapX(delta_x);           // setup arc info.
             aptl[0].y = ptl.y;
             aptl[1].x = ptl.x - MapX(delta_x);
             aptl[1].y = ptl.y - MapY(delta_y);

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GreArc(ThDC, aptl);
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GreArc");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreArc(hDC, aptl);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GreArc");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             aptl[0].x = 0xFFFFFFFL;
             aptl[0].y = 0xFFFFFFFL;
             err = GreArc(hDC, aptl);
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GreArc");
             aptl[0].x = ptl.x - MapX(delta_x);           // setup arc info.
             aptl[0].y = ptl.y;
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GreArc(hDC1, aptl);
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GreArc");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GrePartialArcRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GrePartialArc.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 10/31/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set arc parameters using r=0, q=1", p=1", s=0;
 *              set cursor position;
 *
 *              call GrePartialArc() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GrePartialArc();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set arc parameters using r=0, q=0xFFFFFF, p=0xFFFFFF, s=0;
 *              call GrePartialArc();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set arc parameters to r=0, q=1", p=1", s=0;
 *
 *              open a memory device context;
 *              call GrePartialArc();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              call GrePartialArc() using 0xFFFFFF for multiplier;
 *              check return for PMERR_INV_MULTIPLIER;
 *
 *              call GrePartialArc() using 0xFFFFFF for angle parameter;
 *              check return for PMERR_INV_ANGLE_PARM;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GrePartialArcRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GrePartialArcRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl;
static ARCPARAMS       arcParm;
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             arcParm.lR = 0L;                                    // set arc parameters to a 1"
             arcParm.lQ = delta_y;                                  // semi-circle.
             arcParm.lP = delta_x;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  CLEANUP("GreSetArcParameters()",szApiEntryName);
                  return ;
               }

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GrePartialArc(ThDC, &ptl, MAKEFIXED(1,0),
                                             MAKEFIXED(0,0),
                                             MAKEFIXED(90,0));
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GrePartialArc");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GrePartialArc(hDC, &ptl, MAKEFIXED(1,0),
                                                 MAKEFIXED(0,0),
                                                 MAKEFIXED(90,0));
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GrePartialArc");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             arcParm.lR = 0L;
             arcParm.lQ = 0xFFFFFFL;
             arcParm.lP = 0xFFFFFFL;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetArcParameters",NULL);
               }

             err = GrePartialArc(hDC, &ptl, MAKEFIXED(1,0),
                                            MAKEFIXED(0,0),
                                            MAKEFIXED(90,0));
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GrePartialArc");

             arcParm.lR = 0L;                                    // set arc parameters to a 1"
             arcParm.lQ = delta_y;                                  // semi-circle.
             arcParm.lP = delta_x;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetArcParameters",NULL);
               }
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GrePartialArc(hDC1, &ptl, MAKEFIXED(1,0),
                                             MAKEFIXED(0,0),
                                             MAKEFIXED(90,0));
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GrePartialArc");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_MULTIPLIER Return Code",NULL);
             err = GrePartialArc(hDC, &ptl, MAKEFIXED(0xFFFFFFL,0),
                                            MAKEFIXED(0,0),
                                            MAKEFIXED(90,0));
             CHECKRC((err != GPI_ERROR), PMERR_INV_MULTIPLIER, "GrePartialArc");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_ANGLE_PARM Return Code",NULL);
             err = GrePartialArc(hDC, &ptl, MAKEFIXED(1,0),
                                            MAKEFIXED(0xFFFFFFL,0),
                                            MAKEFIXED(90,0));
             CHECKRC((err != GPI_ERROR), PMERR_INV_ANGLE_PARM, "GrePartialArc");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreFullArcInteriorRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreFullArcInterior.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 10/31/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set arc parameters using r=0, q=1", p=1", s=0;
 *              set cursor position;
 *
 *              call GreFullArcInterior() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GreFullArcInterior();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set arc parameters using r=0, q=0xFFFFFF, p=0xFFFFFF, s=0;
 *              call GreFullArcInterior();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set arc parameters to r=0, q=1", p=1", s=0;
 *
 *              open a memory device context;
 *              call GreFullArcInterior();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              call GreFullArcInterior() using 0xFFFFFF for multiplier;
 *              check return for PMERR_INV_MULTIPLIER;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreFullArcInteriorRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GreFullArcInteriorRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl;
static ARCPARAMS       arcParm;
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             arcParm.lR = 0L;                                    // set arc parameters to a 1"
             arcParm.lQ = delta_y;                                  // semi-circle.
             arcParm.lP = delta_x;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  CLEANUP("GreSetArcParameters()",szApiEntryName);
                  return ;
               }

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GreFullArcInterior(ThDC, MAKEFIXED(1,0));
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GreFullArcInterior");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreFullArcInterior(hDC, MAKEFIXED(1,0));
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GreFullArcInterior");
             SUBEXIT();

             SUBENTER("Checking PMERR_PATH_LIMIT_EXCEEDED Return Code",NULL);
             err = GreFullArcInterior(hDC, MAKEFIXED(255,0));
             CHECKRC((err != GPI_ERROR), PMERR_PATH_LIMIT_EXCEEDED, "GreFullArcInterior");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             arcParm.lR = 0L;
             arcParm.lQ = 0xFFFFFFL;
             arcParm.lP = 0xFFFFFFL;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetArcParameters",NULL);
               }

             err = GreFullArcInterior(hDC, MAKEFIXED(1,0));
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GreFullArcInterior");

             arcParm.lR = 0L;                                    // set arc parameters to a 1"
             arcParm.lQ = delta_y;                                  // semi-circle.
             arcParm.lP = delta_x;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetArcParameters",NULL);
               }
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GreFullArcInterior(hDC1, MAKEFIXED(1,0));
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GreFullArcInterior");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_MULTIPLIER Return Code",NULL);
             err = GreFullArcInterior(hDC, MAKEFIXED(0xFFFFFFL,0));
             CHECKRC((err != GPI_ERROR), PMERR_INV_MULTIPLIER, "GreFullArcInterior");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreFullArcBoundaryRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreFullArcBoundary.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 10/31/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set arc parameters using r=0, q=1", p=1", s=0;
 *              set cursor position;
 *
 *              call GreFullArcBoundary() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GreFullArcBoundary();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set arc parameters using r=0, q=0xFFFFFF, p=0xFFFFFF, s=0;
 *              call GreFullArcBoundary();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set arc parameters to r=0, q=1", p=1", s=0;
 *
 *              open a memory device context;
 *              call GreFullArcBoundary();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              call GreFullArcBoundary() using 0xFFFFFF for multiplier;
 *              check return for PMERR_INV_MULTIPLIER;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreFullArcBoundaryRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GreFullArcBoundaryRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl;
static ARCPARAMS       arcParm;
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             arcParm.lR = 0L;                                    // set arc parameters to a 1"
             arcParm.lQ = delta_y;                                  // semi-circle.
             arcParm.lP = delta_x;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  CLEANUP("GreSetArcParameters()",szApiEntryName);
                  return ;
               }

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GreFullArcBoundary(ThDC, MAKEFIXED(1,0));
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GreFullArcBoundary");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreFullArcBoundary(hDC, MAKEFIXED(1,0));
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GreFullArcBoundary");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             arcParm.lR = 0L;
             arcParm.lQ = 0xFFFFFFL;
             arcParm.lP = 0xFFFFFFL;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetArcParameters",NULL);
               }

             err = GreFullArcBoundary(hDC, MAKEFIXED(1,0));
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GreFullArcBoundary");

             arcParm.lR = 0L;                                    // set arc parameters to a 1"
             arcParm.lQ = delta_y;                                  // semi-circle.
             arcParm.lP = delta_x;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetArcParameters",NULL);
               }
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GreFullArcBoundary(hDC1, MAKEFIXED(1,0));
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GreFullArcBoundary");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_MULTIPLIER Return Code",NULL);
             err = GreFullArcBoundary(hDC, MAKEFIXED(0xFFFFFFL,0));
             CHECKRC((err != GPI_ERROR), PMERR_INV_MULTIPLIER, "GreFullArcBoundary");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreFullArcBothRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreFullArcBoth.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 10/31/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set arc parameters using r=0, q=1", p=1", s=0;
 *              set cursor position;
 *
 *              call GreFullArcBoth() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GreFullArcBoth();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set arc parameters using r=0, q=0xFFFFFF, p=0xFFFFFF, s=0;
 *              call GreFullArcBoth();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set arc parameters to r=0, q=1", p=1", s=0;
 *
 *              open a memory device context;
 *              call GreFullArcBoth();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              call GreFullArcBoth() using 0xFFFFFF for multiplier;
 *              check return for PMERR_INV_MULTIPLIER;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreFullArcBothRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GreFullArcBothRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl;
static ARCPARAMS       arcParm;
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             arcParm.lR = 0L;                                    // set arc parameters to a 1"
             arcParm.lQ = delta_y;                                  // semi-circle.
             arcParm.lP = delta_x;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  CLEANUP("GreSetArcParameters()",szApiEntryName);
                  return ;
               }

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GreFullArcBoth(ThDC, MAKEFIXED(1,0));
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GreFullArcBoth");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreFullArcBoth(hDC, MAKEFIXED(1,0));
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GreFullArcBoth");
             SUBEXIT();

             SUBENTER("Checking PMERR_PATH_LIMIT_EXCEEDED Return Code",NULL);
             err = GreFullArcBoth(hDC, MAKEFIXED(255,0));
             CHECKRC((err != GPI_ERROR), PMERR_PATH_LIMIT_EXCEEDED, "GreFullArcBoth");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             arcParm.lR = 0L;
             arcParm.lQ = 0xFFFFFFL;
             arcParm.lP = 0xFFFFFFL;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetArcParameters",NULL);
               }

             err = GreFullArcBoth(hDC, MAKEFIXED(1,0));
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GreFullArcBoth");

             arcParm.lR = 0L;                                    // set arc parameters to a 1"
             arcParm.lQ = delta_y;                                  // semi-circle.
             arcParm.lP = delta_x;
             arcParm.lS = 0L;
             MapArc(arcParm);
             if (!GreSetArcParameters(hDC, &arcParm))
               {
                  ErrorCount++;
                  ERRSTATUS(TRUE,"GreSetArcParameters",NULL);
               }
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GreFullArcBoth(hDC1, MAKEFIXED(1,0));
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GreFullArcBoth");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_MULTIPLIER Return Code",NULL);
             err = GreFullArcBoth(hDC, MAKEFIXED(0xFFFFFFL,0));
             CHECKRC((err != GPI_ERROR), PMERR_INV_MULTIPLIER, "GreFullArcBoth");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreBoxInteriorRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreBoxInterior.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/26/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set cursor position;
 *              set BOXPARAMS sturcture with point at x=2" y=2" and xy size=1";
 *
 *              call GreBoxInterior() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GreBoxInterior();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set BOXPARAMS sturcture with point at x=0xFFFFFFF y=0xFFFFFFF;
 *              call GreBoxInterior();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set BOXPARAMS sturcture with point at x=2" y=2";
 *
 *              set BOXPARAMS sturcture with point at x=0xFFFFFF y=0xFFFFFF;
 *              call GreBoxInterior();
 *              check return for PMERR_PATH_LIMIT_EXCEEDED;
 *              re-set BOXPARAMS sturcture with point at x=2" y=2";
 *
 *              open a memory device context;
 *              call GreBoxInterior();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              set BOXPARAMS sturcture with xy size=-1;
 *              call GreBoxInterior();
 *              check return for PMERR_INV_BOX_ROUNDING_PARM;
 *              re-set BOXPARAMS sturcture with xy size=1";
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreBoxInteriorRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GreBoxInteriorRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl;
static BOXPARAMS       aptl;
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             aptl.ptl.x = MapX(delta_x * 2);
             aptl.ptl.y = MapY(delta_y * 2);
             aptl.sizl.cx = MapX(delta_x);
             aptl.sizl.cy = MapY(delta_y);

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GreBoxInterior(ThDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GreBoxInterior");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreBoxInterior(hDC, &aptl);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GreBoxInterior");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             aptl.ptl.x = 0xFFFFFFFL;
             aptl.ptl.y = 0xFFFFFFFL;
             err = GreBoxInterior(hDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GreBoxInterior");
             aptl.ptl.x = MapX(delta_x * 2);
             aptl.ptl.y = MapY(delta_y * 2);
             SUBEXIT();

             SUBENTER("Checking PMERR_PATH_LIMIT_EXCEEDED Return Code",NULL);
             aptl.ptl.x = 0xFFFFFFL;
             aptl.ptl.y = 0xFFFFFFL;
             err = GreBoxInterior(hDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_PATH_LIMIT_EXCEEDED, "GreBoxInterior");
             aptl.ptl.x = MapX(delta_x * 2);
             aptl.ptl.y = MapY(delta_y * 2);
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GreBoxInterior(hDC1, &aptl);
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GreBoxInterior");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_BOX_ROUNDING_PARM Return Code",NULL);
             aptl.sizl.cx = -1L;
             aptl.sizl.cy = -1L;
             err = GreBoxInterior(hDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_INV_BOX_ROUNDING_PARM, "GreBoxInterior");
             aptl.sizl.cx = MapX(delta_x);
             aptl.sizl.cy = MapY(delta_y);
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreBoxBoundaryRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreBoxBoundary.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/26/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set cursor position;
 *              set BOXPARAMS sturcture with point at x=2" y=2" and xy size=1";
 *
 *              call GreBoxBoundary() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GreBoxBoundary();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set BOXPARAMS sturcture with point at x=0xFFFFFFF y=0xFFFFFFF;
 *              call GreBoxBoundary();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set BOXPARAMS sturcture with point at x=2" y=2";
 *
 *              set BOXPARAMS sturcture with point at x=0xFFFFFF y=0xFFFFFF;
 *              call GreBoxBoundary();
 *              check return for PMERR_PATH_LIMIT_EXCEEDED;
 *              re-set BOXPARAMS sturcture with point at x=2" y=2";
 *
 *              open a memory device context;
 *              call GreBoxBoundary();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              set BOXPARAMS sturcture with xy size=-1;
 *              call GreBoxBoundary();
 *              check return for PMERR_INV_BOX_ROUNDING_PARM;
 *              re-set BOXPARAMS sturcture with xy size=1";
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreBoxBoundaryRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GreBoxBoundaryRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl;
static BOXPARAMS       aptl;
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             aptl.ptl.x = MapX(delta_x * 2);
             aptl.ptl.y = MapY(delta_y * 2);
             aptl.sizl.cx = MapX(delta_x);
             aptl.sizl.cy = MapY(delta_y);

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GreBoxBoundary(ThDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GreBoxBoundary");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreBoxBoundary(hDC, &aptl);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GreBoxBoundary");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             aptl.ptl.x = 0xFFFFFFFL;
             aptl.ptl.y = 0xFFFFFFFL;
             err = GreBoxBoundary(hDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GreBoxBoundary");
             aptl.ptl.x = MapX(delta_x * 2);
             aptl.ptl.y = MapY(delta_y * 2);
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GreBoxBoundary(hDC1, &aptl);
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GreBoxBoundary");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_BOX_ROUNDING_PARM Return Code",NULL);
             aptl.sizl.cx = -1L;
             aptl.sizl.cy = -1L;
             err = GreBoxBoundary(hDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_INV_BOX_ROUNDING_PARM, "GreBoxBoundary");
             aptl.sizl.cx = MapX(delta_x);
             aptl.sizl.cy = MapY(delta_y);
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreBoxBothRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreBoxBoth.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/26/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set cursor position;
 *              set BOXPARAMS sturcture with point at x=2" y=2" and xy size=1";
 *
 *              call GreBoxBoth() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GreBoxBoth();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set BOXPARAMS sturcture with point at x=0xFFFFFFF y=0xFFFFFFF;
 *              call GreBoxBoth();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set BOXPARAMS sturcture with point at x=2" y=2";
 *
 *              set BOXPARAMS sturcture with point at x=0xFFFFFF y=0xFFFFFF;
 *              call GreBoxBoth();
 *              check return for PMERR_PATH_LIMIT_EXCEEDED;
 *              re-set BOXPARAMS sturcture with point at x=2" y=2";
 *
 *              open a memory device context;
 *              call GreBoxBoth();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              set BOXPARAMS sturcture with xy size=-1;
 *              call GreBoxBoth();
 *              check return for PMERR_INV_BOX_ROUNDING_PARM;
 *              re-set BOXPARAMS sturcture with xy size=1";
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreBoxBothRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GreBoxBothRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl;
static BOXPARAMS       aptl;
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             aptl.ptl.x = MapX(delta_x * 2);
             aptl.ptl.y = MapY(delta_y * 2);
             aptl.sizl.cx = MapX(delta_x);
             aptl.sizl.cy = MapY(delta_y);

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GreBoxBoth(ThDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GreBoxBoth");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GreBoxBoth(hDC, &aptl);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GreBoxBoth");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             aptl.ptl.x = 0xFFFFFFFL;
             aptl.ptl.y = 0xFFFFFFFL;
             err = GreBoxBoth(hDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GreBoxBoth");
             aptl.ptl.x = MapX(delta_x * 2);
             aptl.ptl.y = MapY(delta_y * 2);
             SUBEXIT();

             SUBENTER("Checking PMERR_PATH_LIMIT_EXCEEDED Return Code",NULL);
             aptl.ptl.x = 0xFFFFFFL;
             aptl.ptl.y = 0xFFFFFFL;
             err = GreBoxBoth(hDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_PATH_LIMIT_EXCEEDED, "GreBoxBoth");
             aptl.ptl.x = MapX(delta_x * 2);
             aptl.ptl.y = MapY(delta_y * 2);
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GreBoxBoth(hDC1, &aptl);
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GreBoxBoth");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_BOX_ROUNDING_PARM Return Code",NULL);
             aptl.sizl.cx = -1L;
             aptl.sizl.cy = -1L;
             err = GreBoxBoth(hDC, &aptl);
             CHECKRC((err != GPI_ERROR), PMERR_INV_BOX_ROUNDING_PARM, "GreBoxBoth");
             aptl.sizl.cx = MapX(delta_x);
             aptl.sizl.cy = MapY(delta_y);
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GrePolyFilletRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GrePolyFillet.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/26/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set cursor position;
 *              set pointl's at (0,0) and at 2 times PS;
 *
 *              call GrePolyFillet() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GrePolyFillet();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set pointl's at (0xFFFFFF,0xFFFFFF);
 *              call GrePolyFillet();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set pointl's at (0,0) and at 2 times PS;
 *
 *              open a memory device context;
 *              call GrePolyFillet();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              call GrePolyFillet() using 0xFFFFFF for length;
 *              check return for PMERR_INV_LENGTH_OR_COUNT;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GrePolyFilletRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GrePolyFilletRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl, aptl[2];
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             aptl[0].x = 0L;
             aptl[0].y = 0L;
             aptl[1].x = ptl.x * 2;
             aptl[1].y = ptl.y * 2;

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GrePolyFillet(ThDC, &aptl[0], 2L);
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GrePolyFillet");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GrePolyFillet(hDC, &aptl[0], 2L);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GrePolyFillet");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             aptl[0].x = 0xFFFFFFFL;
             aptl[0].y = 0xFFFFFFFL;
             err = GrePolyFillet(hDC, &aptl[0], 2L);
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GrePolyFillet");
             aptl[0].x = 0L;
             aptl[0].y = 0L;
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GrePolyFillet(hDC1, &aptl[0], 2L);
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GrePolyFillet");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_LENGTH_OR_COUNT Return Code",NULL);
             err = GrePolyFillet(hDC, &aptl[0], 0xFFFFFFFFL);
             CHECKRC((err != GPI_ERROR), PMERR_INV_LENGTH_OR_COUNT, "GrePolyFillet");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GrePolyFilletSharpRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GrePolyFilletSharp.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/26/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set cursor position;
 *              set pointl's at (0,0) and at 2 times PS;
 *              set sharp value at 0;
 *
 *              call GrePolyFilletSharp() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GrePolyFilletSharp();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set pointl's at (0xFFFFFF,0xFFFFFF);
 *              call GrePolyFilletSharp();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set pointl's at (0,0) and at 2 times PS;
 *
 *              open a memory device context;
 *              call GrePolyFilletSharp();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              call GrePolyFilletSharp() using 0xFFFFFF for length;
 *              check return for PMERR_INV_LENGTH_OR_COUNT;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GrePolyFilletSharpRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GrePolyFilletSharpRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl, aptl[2];
static FIXED           afx[2];
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

             if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             aptl[0].x = 0L;
             aptl[0].y = 0L;
             aptl[1].x = ptl.x * 2;
             aptl[1].y = ptl.y * 2;

             afx[0] = MAKEFIXED(0,0);
             afx[1] = MAKEFIXED(0,0);

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GrePolyFilletSharp(ThDC, &aptl[0], 2L, afx);
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GrePolyFilletSharp");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GrePolyFilletSharp(hDC, &aptl[0], 2L, afx);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GrePolyFilletSharp");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             aptl[0].x = 0xFFFFFFFL;
             aptl[0].y = 0xFFFFFFFL;
             err = GrePolyFilletSharp(hDC, &aptl[0], 2L, afx);
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GrePolyFilletSharp");
             aptl[0].x = 0L;
             aptl[0].y = 0L;
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GrePolyFilletSharp(hDC1, &aptl[0], 2L, afx);
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GrePolyFilletSharp");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_LENGTH_OR_COUNT Return Code",NULL);
             err = GrePolyFilletSharp(hDC, &aptl[0], 0xFFFFFFFFL, afx);
             CHECKRC((err != GPI_ERROR), PMERR_INV_LENGTH_OR_COUNT, "GrePolyFilletSharp");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GrePolySplineRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GrePolySpline.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/26/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Can not Print.
 *
 *\\end
 *****************************************************************************/
#pragma page()
/*****************************************************************************
 *\\algorithm
 * {
 *      if (SelectionCall)
 *              WinSendMsg ();
 *      else {
 *              ensure PS not to Printer;
 *              ENTER_MAIN();
 *              set cursor position;
 *              set pointl's at (0,0), 2 times PS and size of PS;
 *
 *              call GrePolySpline() using -1 for hps;
 *              check retern for PMERR_INV_HPS;
 *
 *              make PS busy;
 *              call GrePolySpline();
 *              check return for PMERR_PS_BUSY;
 *              free ps;
 *
 *              set pointl's at (0xFFFFFF,0xFFFFFF);
 *              call GrePolySpline();
 *              check return for PMERR_COORDINATE_OVERFLOW;
 *              re-set pointl's at (0,0), 2 times PS and size of PS;
 *
 *              open a memory device context;
 *              call GrePolySpline();
 *              check return for PMERR_BITMAP_NOT_SELECTED;
 *
 *              call GrePolySpline() using 0xFFFFFF for length;
 *              check return for PMERR_INV_LENGTH_OR_COUNT;
 *
 *              EXIT_MAIN();
 *      }
 * }
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GrePolySplineRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR           szApiEntryName = "GrePolySplineRc";        //      entry point name
static ERRORID         err;
static HDC             ThDC, hDC, hDC1;
static HAB             hAB;
static POINTL          ptl, aptl[3];
register INT           i;

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
             ENTER_MAIN(szApiEntryName);
             hDC = GpiQueryDevice(hPS);
             ErrorCount = 0;

            if ((hAB=WinQueryAnchorBlock(hWndClient))==NULLHANDLE)
               {
                  CLEANUP("WinQueryAnchorBlock()",szApiEntryName);
                  return ;
               }
             ptl.x = delta_x * 7;                         // set position for the location
             ptl.y = delta_y * 3;                            // of drawing to the PS.
             MapPt(ptl);
             GpiMove(hPS, &ptl);

             aptl[0].x = 0L;
             aptl[0].y = 0L;
             aptl[1].x = ptl.x * 2;
             aptl[2].y = ptl.y * 2;
             aptl[2].x = ptl.x;
             aptl[1].y = ptl.y;

             SUBENTER("Checking PMERR_INV_HDC Return Code",NULL);
             ThDC = (HDC) -1;
             err = GrePolySpline(ThDC, &aptl[0], 3L);
             CHECKRC((err != GPI_ERROR), PMERR_INV_HDC, "GrePolySpline");
             SUBEXIT();

             SUBENTER("Checking PMERR_HDC_BUSY Return Code",NULL);
             for (i=0;i<10;i++)
               {
                  MAKEPSBUSY(hPS);
                  err = GrePolySpline(hDC, &aptl[0], 3L);
                  FREEPS;
                  if (err == GPI_ERROR)
                     break;
               }
             CHECKRC((err != GPI_ERROR), PMERR_HDC_BUSY, "GrePolySpline");
             SUBEXIT();

             SUBENTER("Checking PMERR_COORDINATE_OVERFLOW Return Code",NULL);
             aptl[0].x = 0xFFFFFFFL;
             aptl[0].y = 0xFFFFFFFL;
             err = GrePolySpline(hDC, &aptl[0], 3L);
             CHECKRC((err != GPI_ERROR), PMERR_COORDINATE_OVERFLOW, "GrePolySpline");
             aptl[0].x = 0L;
             aptl[0].y = 0L;
             SUBEXIT();

             SUBENTER("Checking PMERR_BITMAP_NOT_SELECTED Return Code",NULL);
             if ((hDC1=DevOpenDC(hAB,
                                 OD_MEMORY,
                                 "*",
                                 0L,
                                 (PDEVOPENDATA)NULL,
                                 hDC))==DEV_ERROR)                  //Open a memory Device Context.
               {
                  CLEANUP("DevOpenDC()",szApiEntryName);
                  return ;
               }
             err = GrePolySpline(hDC1, &aptl[0], 3L);
             CHECKRC((err != GPI_ERROR),PMERR_BITMAP_NOT_SELECTED,"GrePolySpline");
             SUBEXIT();

             SUBENTER("Checking PMERR_INV_LENGTH_OR_COUNT Return Code",NULL);
             err = GrePolySpline(hDC, &aptl[0], 0xFFFFFFFFL);
             CHECKRC((err != GPI_ERROR), PMERR_INV_LENGTH_OR_COUNT, "GrePolySpline");
             SUBEXIT();

             DeletePrinterOutput(szApiEntryName);
             EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreDrawConicsInPathRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreDrawConicsInPath.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/25/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Not enough documentation to program.
 *
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreDrawConicsInPathRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR    szApiEntryName = "GreDrawConicsInPathRc";        //      entry point name

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
           ENTER_MAIN(szApiEntryName);
           DeletePrinterOutput(szApiEntryName);
           EXIT_MAIN(szApiEntryName);
     }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreCookWholePathRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreCookWholePath.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/25/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Not enough documentation to program.
 *
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreCookWholePathRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR    szApiEntryName = "GreCookWholePathRc";        //      entry point name

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
     {
           ENTER_MAIN(szApiEntryName);
           DeletePrinterOutput(szApiEntryName);
           EXIT_MAIN(szApiEntryName);
      }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreCookPathCurvesRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreCookPathCurves.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/25/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Not enough documentation to program.
 *
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreCookPathCurvesRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR    szApiEntryName = "GreCookPathCurvesRc";        //      entry point name

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
        {
           ENTER_MAIN(szApiEntryName);
           DeletePrinterOutput(szApiEntryName);
           EXIT_MAIN(szApiEntryName);
        }
   return;
}

#pragma page()
/*****************************************************************************
 *\ddd
 * Routine Name: GreRenderPathRc()
 *
 * Purpose: This is an entry point for the DTT that does an
 *          return code test of GreRenderPath.
 *
 *
 *
 * System Requirements:
 *              NONE
 *
 *
 * Revision Log: 11/25/91 ,DTT, Ken McFadden
 *
 *
 * Inputs:
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    SelectionCall  // selection parameter
 *
 * Outputs:
 *              NONE
 *
 * Subroutines Required:
 *              NONE
 *
 * Limitations:
 *              Not enough documentation to program.
 *
 *\\end
 *****************************************************************************/
#pragma page()
VOID  APIENTRY GreRenderPathRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
static PCHAR    szApiEntryName = "GreRenderPathRc";        //      entry point name

   if (SelectionCall)
     {
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
     }
   else
        {
           ENTER_MAIN(szApiEntryName);
           DeletePrinterOutput(szApiEntryName);
           EXIT_MAIN(szApiEntryName);
        }
   return;
}
