/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#ifndef GREATT2_H
#define GREATT2_H
/***************************************************************************
 *\\ddd
 * Subtask Name: pdvt
 *
 * Module name:  GreAtt2.h
 *
 * Purpose: Gre Attributes DLL include file
 *
 *  $header$
 *
 * Revision Log:  11/09/90 ,PDVT ,Mike Abuzant
 *	          		- Created Initial file. 
 *                09/15/91 ,PDVT , Mike Abuzant
 *                -  This template was taken from GpiBtmp test case.
 *                10/02/91 ,PDVT , Mike Abuzant
 *                -  This template was taken from GpiBtmp test case.
 *                - and customized for GreAtt2.H   
 *
 * Contents:  This file contains the following definitions:
 *
 *		- function prototypes
 *		- define's specific to GreAtt2
 *
 * Limitations:
 *  None
 *
 *\\end
 ***************************************************************************/

/* declare all local functions */

VOID CompareDefaultAttibutesSetting(HPS hPS, HWND hWndClient,PCHAR EntryName);

VOID SetNewAttibutes(HPS hPS, HWND hWndClient,PCHAR EntryName,
                     LONG     lGlobalAtttributFlag,
                     PUSHORT  pusColorIndex, PUSHORT  pusMixIndex,
                     PUSHORT  pusBackMixIndex,PUSHORT  pusBackColorIndex);



/* declare all DLL functions */

VOID  APIENTRY GreInitializeAttributesRc(HPS hPS,HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY GreSetCursorExh(HPS hPS,HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY GreSetCursorRc(HPS hPS,HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY GreGetDefaultAttributesRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetDefaultAttributesRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAttributesRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreGetAttributesRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetGlobalAttributeRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetGlobalAttributeExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreInvalidateVisRegionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreInvalidateVisRegionExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreInitializeAttributesExh1(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreInitializeAttributesExh2(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetAttributesExh1(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetAttributesExh2(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetAttributesExh3(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetAttributesExh4(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetAttributesExh5(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetAttributesExh6(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetDefaultAttrsExh1(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetDefaultAttrsExh2(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetDefaultAttrsExh3(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetDefaultAttrsExh4(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetDefaultAttrsExh5(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetAndGetDefaultAttrsExh6(HPS hPS, HWND hWndClient, BOOL SelectionCall);


typedef struct _MyBitMap
          {
            SHORT   height;
            SHORT   width;
            PBYTE   BitMapBuffer;
          } MyBitMap;


typedef  struct _ATTRIBUTES {
             LONG    lAttrValue;
             PCHAR   AttrSymbolicName;
        } ATTRIBUTES;
//
// This section defines all common constant used throughout the test case
//


#define SIMPLIES_FACTOR  (0.09424780)

#define COMMON_SUFFICE3(String)                                        \
            "Default  "#String" attributes are %s set to their standard defaults."

#define COMMON_SUFFICE2(String)                                        \
             "Queried and set current "#String" attributes are %s the same"

#define COMMON_SUFFICE1(String)                                        \
            "Current "#String" attributes are %s set to their defaults."


#define GOOD_FUNCTION(fSuccess)   ((fSuccess)==TRUE  ? "" : "NOT")


#define VALIDATE_ATTRS(lFlags,lReturnedFlags)                           \
               (BOOL)(((lFlags) & (lReturnedFlags)) ? TRUE : FALSE )


#define MY_BITMAP_ID         3L

#define MY_FONT_ID           100L

#define  CROSS_WIDTH         16
#define  CROSS_HEIGHT        16


#define  CROSS_WIDTH         16
#define  CROSS_HEIGHT        16

#define  K_SHAPE_WIDTH       9
#define  K_SHAPE_HEIGHT      9

#define  DIAMOND_WIDTH       9
#define  DIAMOND_HEIGHT      9

#define  CAT_WIDTH           32
#define  CAT_HEIGHT          32

#define  SHAPE_WIDTH         8
#define  SHAPE_HEIGHT        8

#define  BRICK_WIDTH         8
#define  BRICK_HEIGHT        8

#define  PAT1_WIDTH          8
#define  PAT1_HEIGHT         8

#define  PAT2_WIDTH          8
#define  PAT2_HEIGHT         8



#define CHANGE_IMAGE    (IBB_COLOR | IBB_BACK_COLOR | IBB_MIX_MODE | \
                         IBB_BACK_MIX_MODE )

#define CHANGE_LINE     (LBB_COLOR | LBB_MIX_MODE | LBB_GEOM_WIDTH | LBB_TYPE | \
                          LBB_END | LBB_JOIN)

#define CHANGE_MARKER   (MBB_COLOR | MBB_BACK_COLOR | MBB_MIX_MODE | \
                           MBB_BACK_MIX_MODE | MBB_SYMBOL |MBB_BOX)

#define CHANGE_AREA     (ABB_COLOR | ABB_BACK_COLOR | ABB_MIX_MODE | \
                           ABB_BACK_MIX_MODE | ABB_SYMBOL )


#define CHANGE_CHAR     (CBB_COLOR | CBB_BACK_COLOR | CBB_MIX_MODE  | \
                          CBB_BACK_MIX_MODE | CBB_ANGLE | CBB_SHEAR  | \
                          CBB_DIRECTION | CBB_BOX | CBB_SET  | CBB_MODE)


#define IMAGE_ATTRIBUTES  (IBB_COLOR | IBB_BACK_COLOR | IBB_MIX_MODE | \
                           IBB_BACK_MIX_MODE )

#define LINE_ATTRIBUTES   (LBB_COLOR | LBB_MIX_MODE )


#define MARKER_ATTRIBUTES (MBB_COLOR | MBB_BACK_COLOR | MBB_MIX_MODE | \
                           MBB_BACK_MIX_MODE )

#define CHAR_ATTRIBUTES   (CBB_COLOR | CBB_BACK_COLOR | CBB_MIX_MODE | \
                           CBB_BACK_MIX_MODE )


#define AREA_ATTRIBUTES   (ABB_COLOR | ABB_BACK_COLOR | ABB_MIX_MODE | \
                           ABB_BACK_MIX_MODE )

/* Macro to get a random integer within a specified range */
#define GETRANDOM( min, max ) ((rand() % (int)(((max)+1) - (min))) + (min))


#define  NUMBEROFELEMENTS(ArrayName)  (sizeof(ArrayName)/sizeof(ArrayName[0]))

#define  INC(Counter,ArrayName)  \
                  Counter=((++Counter)%NUMBEROFELEMENTS(ArrayName))

#define   TOKENIZE_ATTRIBUTES(Attr) { Attr, #Attr}

#ifdef MAINSOURCEFILE

CHAR achLogLine[100];      //Buffer used for printing error messages

LONG ErrorCount;          //Error counter.

/* set function name for dll init routine */

CHAR * TestCaseName= "GreAttributes2";

NAMES_AND_ADDRESSES EntryPointList[]=
   {
        TOKENIZEFUNCTIONNAME(GreSetAndGetAttributesExh1     ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetAttributesExh2     ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetAttributesExh3     ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetAttributesExh4     ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetAttributesExh5     ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetAttributesExh6     ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetDefaultAttrsExh1   ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetDefaultAttrsExh2   ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetDefaultAttrsExh3   ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetDefaultAttrsExh4   ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetDefaultAttrsExh5   ),
        TOKENIZEFUNCTIONNAME(GreSetAndGetDefaultAttrsExh6   ),
        TOKENIZEFUNCTIONNAME(GreInitializeAttributesExh1    ),
        TOKENIZEFUNCTIONNAME(GreInitializeAttributesExh2    ),
        TOKENIZEFUNCTIONNAME(GreSetGlobalAttributeExh       ),
//      TOKENIZEFUNCTIONNAME(GreSetCursorExh                ),
//      TOKENIZEFUNCTIONNAME(GreInvalidateVisRegionExh      ),
        TOKENIZEFUNCTIONNAME(GreSetAttributesRc             ),
        TOKENIZEFUNCTIONNAME(GreSetDefaultAttributesRc      ),
        TOKENIZEFUNCTIONNAME(GreSetGlobalAttributeRc        ),
        TOKENIZEFUNCTIONNAME(GreGetAttributesRc             ),
        TOKENIZEFUNCTIONNAME(GreGetDefaultAttributesRc      ),
        TOKENIZEFUNCTIONNAME(GreSetCursorRc                 ),
        TOKENIZEFUNCTIONNAME(GreInitializeAttributesRc      ),
//      TOKENIZEFUNCTIONNAME(GreInvalidateVisRegionRc       ),
   };


ATTRIBUTES asLineType[]={
                      TOKENIZE_ATTRIBUTES(LINETYPE_DOT),
                      TOKENIZE_ATTRIBUTES(LINETYPE_SHORTDASH),
                      TOKENIZE_ATTRIBUTES(LINETYPE_DASHDOT),
                      TOKENIZE_ATTRIBUTES(LINETYPE_DOUBLEDOT),
                      TOKENIZE_ATTRIBUTES(LINETYPE_LONGDASH),
                      TOKENIZE_ATTRIBUTES(LINETYPE_DASHDOUBLEDOT),
                      TOKENIZE_ATTRIBUTES(LINETYPE_DOUBLEDOT),
                      TOKENIZE_ATTRIBUTES(LINETYPE_SOLID),
                     };

ATTRIBUTES asLineEnd[]={
                      TOKENIZE_ATTRIBUTES(LINEEND_FLAT),
                      TOKENIZE_ATTRIBUTES(LINEEND_SQUARE),
                      TOKENIZE_ATTRIBUTES(LINEEND_ROUND),
                     };

ATTRIBUTES asLineJoin[]={
                      TOKENIZE_ATTRIBUTES(LINEJOIN_MITRE),
                      TOKENIZE_ATTRIBUTES(LINEJOIN_BEVEL),
                      TOKENIZE_ATTRIBUTES(LINEJOIN_ROUND),
                      TOKENIZE_ATTRIBUTES(LINEJOIN_ROUND),
                     };

ATTRIBUTES asDirection[]={
                      TOKENIZE_ATTRIBUTES(CHDIRN_LEFTRIGHT ),
                      TOKENIZE_ATTRIBUTES(CHDIRN_RIGHTLEFT ),
                      TOKENIZE_ATTRIBUTES(CHDIRN_TOPBOTTOM ),
                      TOKENIZE_ATTRIBUTES(CHDIRN_BOTTOMTOP),
                     };

ATTRIBUTES asSymbol[]={
                      TOKENIZE_ATTRIBUTES(MARKSYM_CROSS),
                      TOKENIZE_ATTRIBUTES(MARKSYM_PLUS),
                      TOKENIZE_ATTRIBUTES(MARKSYM_DIAMOND),
                      TOKENIZE_ATTRIBUTES(MARKSYM_SQUARE),
                      TOKENIZE_ATTRIBUTES(MARKSYM_EIGHTPOINTSTAR),
                      TOKENIZE_ATTRIBUTES(MARKSYM_SOLIDDIAMOND),
                      TOKENIZE_ATTRIBUTES(MARKSYM_SIXPOINTSTAR),
                      TOKENIZE_ATTRIBUTES(MARKSYM_SOLIDSQUARE),
                      TOKENIZE_ATTRIBUTES(MARKSYM_DOT),
                      TOKENIZE_ATTRIBUTES(MARKSYM_SMALLCIRCLE),
                    };


ATTRIBUTES asBackMix[]={
                      TOKENIZE_ATTRIBUTES(BM_OR),
                      TOKENIZE_ATTRIBUTES(BM_OVERPAINT),
                      TOKENIZE_ATTRIBUTES(BM_XOR),
                      TOKENIZE_ATTRIBUTES(BM_LEAVEALONE),
                      };


ATTRIBUTES asMix[]={
                      TOKENIZE_ATTRIBUTES(FM_MERGESRCNOT),
                      TOKENIZE_ATTRIBUTES(FM_OR),
                      TOKENIZE_ATTRIBUTES(FM_OVERPAINT),
                      TOKENIZE_ATTRIBUTES(FM_XOR),
                      TOKENIZE_ATTRIBUTES(FM_AND),
                      TOKENIZE_ATTRIBUTES(FM_OVERPAINT),
                      TOKENIZE_ATTRIBUTES(FM_NOTMERGESRC),
                      TOKENIZE_ATTRIBUTES(FM_NOTXORSRC),
                      TOKENIZE_ATTRIBUTES(FM_AND),
                      TOKENIZE_ATTRIBUTES(FM_INVERT),
                      TOKENIZE_ATTRIBUTES(FM_MERGESRCNOT),
                  };


ATTRIBUTES  asColor[]={
                      TOKENIZE_ATTRIBUTES(CLR_RED),
                      TOKENIZE_ATTRIBUTES(CLR_CYAN),
                      TOKENIZE_ATTRIBUTES(CLR_PINK),
                      TOKENIZE_ATTRIBUTES(CLR_BLACK),
                      TOKENIZE_ATTRIBUTES(CLR_BLUE),
                      TOKENIZE_ATTRIBUTES(CLR_GREEN),
                      TOKENIZE_ATTRIBUTES(CLR_PALEGRAY),
                      TOKENIZE_ATTRIBUTES(CLR_BROWN),
                      TOKENIZE_ATTRIBUTES(CLR_YELLOW),
                      TOKENIZE_ATTRIBUTES(CLR_GREEN),
                      TOKENIZE_ATTRIBUTES(CLR_DARKCYAN),
                      TOKENIZE_ATTRIBUTES(CLR_DARKGREEN),
                      TOKENIZE_ATTRIBUTES(CLR_DARKBLUE),
                      TOKENIZE_ATTRIBUTES(CLR_DARKGRAY),
                  };


ATTRIBUTES  asPattern[]={
                      TOKENIZE_ATTRIBUTES(PATSYM_DENSE8),
                      TOKENIZE_ATTRIBUTES(PATSYM_DIAG1),
                      TOKENIZE_ATTRIBUTES(PATSYM_DIAG4),
                      TOKENIZE_ATTRIBUTES(PATSYM_DENSE4),
                      TOKENIZE_ATTRIBUTES(PATSYM_VERT),
                      TOKENIZE_ATTRIBUTES(PATSYM_HORIZ),
                      TOKENIZE_ATTRIBUTES(PATSYM_DENSE1),
                      TOKENIZE_ATTRIBUTES(PATSYM_DENSE4),
                      TOKENIZE_ATTRIBUTES(PATSYM_DIAG2),
                    };


BYTE abShape[]={0x3c,0x00,0x00,0x00,    // bitmap to be drawn
                0x42,0x00,0x00,0x00,  
                0x81,0x00,0x00,0x00,
                0x99,0x00,0x00,0x00,
                0x99,0x00,0x00,0x00,
                0x81,0x00,0x00,0x00,
                0x42,0x00,0x00,0x00,
                0x3c,0x00,0x00,0x00
               };

BYTE abPat1[]={0x08,0x00,0x00,0x00,    // bitmap to be drawn
               0x08,0x00,0x00,0x00,  
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x3C,0x00,0x00,0x00,
               0x42,0x00,0x00,0x00,
               0x81,0x00,0x00,0x00
               };

BYTE abPat2[]={0x0f,0x00,0x00,0x00,    // bitmap to be drawn
               0x08,0x00,0x00,0x00,  
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0xf0,0x00,0x00,0x00
               };

BYTE abCross[]={0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,   
                0x01,0x00,0x00,0x00,0xff,0xff,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00
               };

BYTE abDiamond[]={0x08,0x00,0x00,0x00,
                 0x14,0x00,0x00,0x00,
                 0x22,0x00,0x00,0x00,
                 0x49,0x00,0x00,0x00,
                 0x9c,0x80,0x00,0x00,
                 0x49,0x00,0x00,0x00,
                 0x22,0x00,0x00,0x00,
                 0x14,0x00,0x00,0x00,
                 0x08,0x00,0x00,0x00
               };

BYTE abKShape[]={0xc0,0x00,0x00,0x00,
                 0xa0,0x00,0x00,0x00,
                 0x90,0x00,0x00,0x00,
                 0x88,0x00,0x00,0x00,
                 0x87,0x80,0x00,0x00,
                 0x88,0x00,0x00,0x00,
                 0x90,0x00,0x00,0x00,
                 0xa0,0x00,0x00,0x00,
                 0xc0,0x00,0x00,0x00
               };


BYTE abBrick[]= {0x00,0x00,0x00,0x00,
                 0xf3,0x00,0x00,0x00,
                 0xf3,0x00,0x00,0x00,
                 0xf3,0x00,0x00,0x00,
                 0x00,0x80,0x00,0x00,
                 0x3f,0x00,0x00,0x00,
                 0x3f,0x00,0x00,0x00,
                 0x3f,0x00,0x00,0x00
               };




BYTE abCat[]={0x00,0xff,0xff,0x00,0x00,0xa2,0x45,0x00,
              0x00,0xa2,0x45,0x00,0x00,0xa2,0x45,0xe0,
              0x00,0xa2,0x45,0x10,0x00,0xa2,0x45,0x08,
              0x00,0x9c,0x39,0x08,0x00,0xc0,0x03,0x04,

              0x00,0x40,0x02,0x04,0x00,0x40,0x02,0x04,
              0x00,0x40,0x02,0x04,0x00,0x20,0x04,0x04,
              0x00,0x20,0x04,0x04,0x00,0x20,0x04,0x04,
              0x00,0x10,0x08,0x04,0x00,0x10,0x08,0x08,

              0x00,0x10,0x08,0x10,0x00,0x08,0x10,0x20,
              0x00,0x08,0x10,0xc0,0x00,0x08,0x10,0x00,
              0x00,0x07,0xe0,0x00,0x00,0x08,0x10,0x00,
              0x00,0xfc,0x3f,0x00,0x00,0x09,0x90,0x00,

              0x00,0xfc,0x3f,0x00,0x00,0x08,0x10,0x00,
              0x00,0x1a,0x58,0x00,0x00,0x28,0x14,0x00,
              0x00,0x48,0x12,0x00,0x00,0x8f,0xf1,0x00,
              0x01,0x04,0x20,0x80,0x01,0xf8,0x1f,0x80
             };



#else
   extern      ATTRIBUTES asLineType[];
   extern      ATTRIBUTES asLineEnd[];
   extern      ATTRIBUTES asLineJoin[];
   extern      ATTRIBUTES asDirection[];
   extern      ATTRIBUTES asSymbol[];
   extern      ATTRIBUTES asBackMix[];
   extern      ATTRIBUTES asMix[];
   extern      ATTRIBUTES asColor[];
   extern      ATTRIBUTES asPattern[];

   extern      BYTE       abDiamond[];
   extern      BYTE       abCross[];
   extern      BYTE       abCat[];
   extern      BYTE       abShape[];
   extern      BYTE       abKShape[];
   extern      BYTE       abBrick[];
   extern      BYTE       abPat1[];
   extern      BYTE       abPat2[];

   extern      LONG       ErrorCount;

#endif    

#endif
