/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#ifndef GREBIT2_H
#define GREBIT2_H
/***************************************************************************
 *\\ddd
 * Subtask Name: pdvt
 *
 * Module name:  GreBit2.h
 *
 * Purpose: Gre bitMap DLL include file
 *
 *  $header$
 *
 * Revision Log:  11/09/90 ,PDVT ,Mike Abuzant
 *	          		- Created Initial file. 
 *                09/15/91 ,PDVT , Mike Abuzant
 *                -  This template was taken from GpiBtmp test case.
 *
 * Contents:  This file contains the following definitions:
 *
 *		- function prototypes
 *		- define's specific to GreBit2
 *
 * Limitations:
 *  None
 *
 *\\end
 ***************************************************************************/

/* declare all DLL functions */

VOID GreSelectBitmap_test1(HPS hPS,HWND hWndClient);
VOID  APIENTRY GreBitApp1(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreBitApp2(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreBitApp3(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreBitApp4(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetBitmapIDExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetBitmapIdRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSelectBitmapExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetBitmapDimensionExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreQueryBitmapHandleRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreGetBitmapParametersExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreCreateBitmapRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreDeleteBitmapRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreGetBitmapDimensionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetBitmapDimensionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreGetBitmapParametersRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSelectBitmapRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreDeviceSetCursorRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetBitmapOwnerRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSaveScreenBitsRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreRestoreScreenBitsRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreRestoreScreenBitsExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreCopyDCLoadDataRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreDeviceSetCursorExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreCopyDCLoadDataExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetBitmapOwnerRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetBitmapOwnerExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);

INT GreApp1(HPS hPS,HWND hWndClient);
INT GreApp2(HPS hPS,HWND hWndClient);
VOID GreApp3(HPS hPS,HWND hWndClient);

//
// This section defines all common constant used throughout the test case
//

#define  MAX_BITMAPSIZE       (64000U)
#define  MAX_RANDOM           (2048)

#define  MY_BITMAP_ID         3L

#define  MY_FONT_ID           100L

#define  CROSS_WIDTH         16
#define  CROSS_HEIGHT        16


#define  CROSS_WIDTH         16
#define  CROSS_HEIGHT        16

#define  K_SHAPE_WIDTH       9
#define  K_SHAPE_HEIGHT      9

#define  DIAMOND_WIDTH       9
#define  DIAMOND_HEIGHT      9

#define  CAT_WIDTH           32
#define  CAT_HEIGHT          32

#define  SHAPE_WIDTH         8
#define  SHAPE_HEIGHT        8

#define  BRICK_WIDTH         8
#define  BRICK_HEIGHT        8

#define  PAT1_WIDTH          8
#define  PAT1_HEIGHT         8

#define  PAT2_WIDTH          8
#define  PAT2_HEIGHT         8


#define CHANGE_IMAGE    (IBB_COLOR | IBB_BACK_COLOR | IBB_MIX_MODE | \
                         IBB_BACK_MIX_MODE )

#define CHANGE_LINE     (LBB_COLOR | LBB_MIX_MODE | LBB_GEOM_WIDTH | LBB_TYPE | \
                          LBB_END | LBB_JOIN |LBB_WIDTH)

#define CHANGE_MARKER   (MBB_COLOR | MBB_BACK_COLOR | MBB_MIX_MODE | \
                           MBB_BACK_MIX_MODE | MBB_SYMBOL |MBB_BOX)

#define CHANGE_CHAR     (CBB_COLOR | CBB_BACK_COLOR | CBB_MIX_MODE  | \
                          CBB_BACK_MIX_MODE | CBB_ANGLE | CBB_SHEAR  | \
                          CBB_DIRECTION | CBB_BOX)

/* Macro to get a random integer within a specified range */
#define GETRANDOM( min, max ) ((rand() % (int)(((max)+1) - (min))) + (min))


#define  NUMBEROFELEMENTS(ArrayName)  (sizeof(ArrayName)/sizeof(ArrayName[0]))

#define  INCROMENTWITHWRAP(Counter,ArrayName)  \
                  Counter=((++Counter)%NUMBEROFELEMENTS(ArrayName))


typedef struct _MyBitMap
          {
            SHORT   height;
            SHORT   width;
            PBYTE   BitMapBuffer;
          } MyBitMap;


#ifdef MAINSOURCEFILE

CHAR achLogLine[100];      //Buffer used for printing error messages

LONG ErrorCount;          //Error counter.

/* set function name for dll init routine */

CHAR * TestCaseName= "GreBitMaps2";

static  NAMES_AND_ADDRESSES EntryPointList[]=
   {
        TOKENIZEFUNCTIONNAME(GreBitApp1                    ),
        TOKENIZEFUNCTIONNAME(GreBitApp2                    ),
        TOKENIZEFUNCTIONNAME(GreBitApp3                    ),
//      TOKENIZEFUNCTIONNAME(GreBitApp4                    ),
        TOKENIZEFUNCTIONNAME(GreSelectBitmapExh            ),
//      TOKENIZEFUNCTIONNAME(GreDeviceSetCursorExh         ),
        TOKENIZEFUNCTIONNAME(GreSetBitmapIDExh             ),
        TOKENIZEFUNCTIONNAME(GreGetBitmapParametersExh     ),
        TOKENIZEFUNCTIONNAME(GreSetBitmapDimensionExh      ),
        TOKENIZEFUNCTIONNAME(GreCopyDCLoadDataExh          ),
//      TOKENIZEFUNCTIONNAME(GreRestoreScreenBitsExh       ),
        TOKENIZEFUNCTIONNAME(GreCopyDCLoadDataRc           ),
        TOKENIZEFUNCTIONNAME(GreRestoreScreenBitsRc        ),
        TOKENIZEFUNCTIONNAME(GreDeviceSetCursorRc          ),
//      TOKENIZEFUNCTIONNAME(GreSetBitmapOwnerRc           ),
        TOKENIZEFUNCTIONNAME(GreSaveScreenBitsRc           ),
        TOKENIZEFUNCTIONNAME(GreQueryBitmapHandleRc        ),
        TOKENIZEFUNCTIONNAME(GreSetBitmapIdRc              ),
        TOKENIZEFUNCTIONNAME(GreCreateBitmapRc             ),
        TOKENIZEFUNCTIONNAME(GreDeleteBitmapRc             ),
        TOKENIZEFUNCTIONNAME(GreSetBitmapDimensionRc       ),
        TOKENIZEFUNCTIONNAME(GreGetBitmapDimensionRc       ),
        TOKENIZEFUNCTIONNAME(GreSelectBitmapRc             ),
        TOKENIZEFUNCTIONNAME(GreGetBitmapParametersRc      ),
   };

BYTE abShape[]={0x3c,0x00,0x00,0x00,    // bitmap to be drawn
                0x42,0x00,0x00,0x00,  
                0x81,0x00,0x00,0x00,
                0x99,0x00,0x00,0x00,
                0x99,0x00,0x00,0x00,
                0x81,0x00,0x00,0x00,
                0x42,0x00,0x00,0x00,
                0x3c,0x00,0x00,0x00
               };

BYTE abPat1[]={0x08,0x00,0x00,0x00,    // bitmap to be drawn
               0x08,0x00,0x00,0x00,  
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x3C,0x00,0x00,0x00,
               0x42,0x00,0x00,0x00,
               0x81,0x00,0x00,0x00
               };

BYTE abPat2[]={0x0f,0x00,0x00,0x00,    // bitmap to be drawn
               0x08,0x00,0x00,0x00,  
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0x08,0x00,0x00,0x00,
               0xf0,0x00,0x00,0x00
               };

BYTE abCross[]={0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,      
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,   
                0x01,0x00,0x00,0x00,0xff,0xff,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00,
                0x01,0x00,0x00,0x00,0x01,0x00,0x00,0x00
               };

BYTE abDiamond[]={0x08,0x00,0x00,0x00,
                 0x14,0x00,0x00,0x00,
                 0x22,0x00,0x00,0x00,
                 0x49,0x00,0x00,0x00,
                 0x9c,0x80,0x00,0x00,
                 0x49,0x00,0x00,0x00,
                 0x22,0x00,0x00,0x00,
                 0x14,0x00,0x00,0x00,
                 0x08,0x00,0x00,0x00
               };

BYTE abKShape[]={0xc0,0x00,0x00,0x00,
                 0xa0,0x00,0x00,0x00,
                 0x90,0x00,0x00,0x00,
                 0x88,0x00,0x00,0x00,
                 0x87,0x80,0x00,0x00,
                 0x88,0x00,0x00,0x00,
                 0x90,0x00,0x00,0x00,
                 0xa0,0x00,0x00,0x00,
                 0xc0,0x00,0x00,0x00
               };


BYTE abBrick[]= {0x00,0x00,0x00,0x00,
                 0xf3,0x00,0x00,0x00,
                 0xf3,0x00,0x00,0x00,
                 0xf3,0x00,0x00,0x00,
                 0x00,0x80,0x00,0x00,
                 0x3f,0x00,0x00,0x00,
                 0x3f,0x00,0x00,0x00,
                 0x3f,0x00,0x00,0x00
               };




BYTE abCat[]={0x00,0xff,0xff,0x00,0x00,0xa2,0x45,0x00,
              0x00,0xa2,0x45,0x00,0x00,0xa2,0x45,0xe0,
              0x00,0xa2,0x45,0x10,0x00,0xa2,0x45,0x08,
              0x00,0x9c,0x39,0x08,0x00,0xc0,0x03,0x04,

              0x00,0x40,0x02,0x04,0x00,0x40,0x02,0x04,
              0x00,0x40,0x02,0x04,0x00,0x20,0x04,0x04,
              0x00,0x20,0x04,0x04,0x00,0x20,0x04,0x04,
              0x00,0x10,0x08,0x04,0x00,0x10,0x08,0x08,

              0x00,0x10,0x08,0x10,0x00,0x08,0x10,0x20,
              0x00,0x08,0x10,0xc0,0x00,0x08,0x10,0x00,
              0x00,0x07,0xe0,0x00,0x00,0x08,0x10,0x00,
              0x00,0xfc,0x3f,0x00,0x00,0x09,0x90,0x00,

              0x00,0xfc,0x3f,0x00,0x00,0x08,0x10,0x00,
              0x00,0x1a,0x58,0x00,0x00,0x28,0x14,0x00,
              0x00,0x48,0x12,0x00,0x00,0x8f,0xf1,0x00,
              0x01,0x04,0x20,0x80,0x01,0xf8,0x1f,0x80
             };

LONG  colors[]={CLR_RED,     // Colors that will draw with
                CLR_CYAN,
                CLR_PINK,
                CLR_BLUE,
                CLR_BROWN,
                CLR_YELLOW,
                CLR_GREEN,
                CLR_DARKCYAN,
                CLR_DARKGREEN,
                CLR_DARKBLUE
               };

LONG  pats[]={PATSYM_DENSE8,  
              PATSYM_DIAG1,
              PATSYM_DIAG4,
              PATSYM_DEFAULT,
              PATSYM_DENSE4,
              PATSYM_VERT,
              PATSYM_DEFAULT,
              PATSYM_HORIZ,
             };

#else
    extern BYTE  abDiamond[];

    extern  BYTE abCross[];

    extern  BYTE abCat[];

    extern  BYTE abShape[];
    extern  BYTE abKShape[];
    extern  BYTE abBrick[];
    extern LONG  colors[];
    
    extern  LONG  pats[];
    
    extern  BYTE abPat1[];
    
    extern  BYTE abPat2[];

    extern CHAR achLogLine[];

    extern LONG ErrorCount;
   
#endif    

#endif
