/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#ifndef GREBTMP_H
#define GREBTMP_H
/***************************************************************************
 *\\ddd
 * Subtask Name: pdvt
 *
 * Module name: grebtmp
 *
 * Purpose: gre bit map dll include file
 *
 *  $header$
 *
 * Revision Log:  11/09/90 ,PDVT ,Mike Abuzant
 *                              - Created Initial file
 *                12/07/90 ,PDVT ,Mike Abuzant
 *                              - Eliminated hAB parameter
 *                01/17/91, pdvt, markrichardson
 *                              - redesign of grebtmp.c forced changes
 *
 * Contents:  This file contains the following definitions:
 *              - function prototypes
 *              - define's specific to Grebtmp
 * Limitations:
 *  None
 *
 *\\end
 ***************************************************************************/
/* declare all dll functions */
VOID  APIENTRY InitTest(PVOID sel, PTESTINITINFO pInitInfo);
VOID  APIENTRY gre_bit_rc  (HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY grebtmp_pre1(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY grebtmp_pre2(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreBitmapApp(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreDeviceCreateBitmapRc(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreDeviceSelectBitmapRc(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreDeviceDeleteBitmapRc(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreSetPelExh(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreSetPelRc(HPS hPS,  HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreGetPelRc(HPS hPS,  HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreBitbltExh(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreBitbltRc(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreImageDataExh(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreImageDataRc(HPS  hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreSetBitmapBitsExh(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreGetBitmapBitsRc(HPS hPS , HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreSetBitmapBitsRc(HPS hPS , HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreDrawBorderExh(HPS hPS   , HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreDrawBorderRc(HPS hPS    , HWND hWndClient,  BOOL SelectionCall);

#define IMAGESIZE 2000
#define NUMBPOINTS  1000
#define PI      3.14159
#define ALLOCFLAGS 0
#define CONVERTTOINCHES(Value)  (((double)Value)/((double)100.000000/(double)2.5400050800))
#define PIXELSTOUNITS(a,b,c)    ((a)*((double)(b)/CONVERTTOINCHES((c))))
#define NTESTS  18         /* number of functions or entry points in this dll */

#define DeviceIsDisplay()                                                                                                                               \
                        (alDevCaps[CAPS_TECHNOLOGY] == CAPS_TECH_RASTER_DISPLAY)

#define DeviceIsPrinter()       (!DeviceIsDisplay())


/* set function name for dll init routine */
PCHAR TestCaseName= "GRE BitMaps   ";
PCHAR pTestName1  = "GreBitPre1";
PCHAR pTestName2  = "GreBitPre2";
PCHAR pTestName3  = "GreBitApp1";
PCHAR pTestName4  = "GreBitApp";
PCHAR pTestName5  = "GreBitApp3";
PCHAR pTestName6  = "GreSetPelRc";
PCHAR pTestName7  = "GreGetPelRc";
PCHAR pTestName8  = "GreDrawBorderRc";
PCHAR pTestName9  = "GreDeviceCreateBitmapRc";
PCHAR pTestName10 = "GreDeviceSelectBitmapRc";
PCHAR pTestName11 = "GreDeviceDeleteBitmapRc";
PCHAR pTestName12 = "GreImageDataRc";
PCHAR pTestName13  = "GreBitbltRc";
PCHAR pTestName14 = "GreSetBitmapBitsRc";
PCHAR pTestName15 = "GreGetBitmapBitsRc";
PCHAR pTestName16 = "GreSetPelExh";
PCHAR pTestName17 = "GreBitBltExh";
PCHAR pTestName18 = "GreImageDataExh";
PCHAR pTestName19 = "GreSetBitmapBitsExh";
PCHAR pTestName20 = "GreDrawBorderExh";

#endif

