/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#pragma title("GRECLIP.C")

#define INCL_DEV             // include all DEV definitions
#define INCL_WIN             // include Win definitions
#define INCL_GPI             // include all Gpi definitions
#define INCL_GRE             // include all Gre definitions
#define INCL_GRE_CLIP
#define INCL_ERRORS          // include all Gre error definitions

#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <pmddi.h>              // needed for GRE function definitions.
#include <stdio.h>
#include "DTTDLLDF.h"           // test case defines.
#include "common1.h"            // Graphics testing common file.
#include "common2.h"
#define EXTERN                  // put globals in this module
#include "greclip.h"            // Test Definition File.

/****************************************************************************
 *
 * Subtask Name: GreClip.dll
 *
 * Module name:  GreClip.c
 *
 * Purpose:      Main module for GRECLIP testcase
 *
 * Revision Log: 12/17/91,      Graphics Suite Extension, Thom Bain
 *                               Initial Design.
 *
 * Documentation Reference:  Section 13.0
 *
 * Contents:     InitTest
 *               GreClipPre
 *               GreClipApp
 *
 *
 * Design Overview:
 *
 * Limitations:
 *
 *
****************************************************************************/

// declare all functions

VOID  APIENTRY GreClipPre(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreClipApp(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreIntersectClipRectangleExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreExcludeClipRectangleExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreOffsetClipRegionExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSelectAndQueryClipRegionExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreCopyClipRegionExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetXformRectExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreGetClipBoxAndRctsAndVChkExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSaveAndRestoreRegionExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSelectPathRegionExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreRegionSelectBitmapExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreGetClipBoxRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreGetClipRectsRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreOffsetClipRegionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GrePtVisibleRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreRectVisibleRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreQueryClipRegionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSelectClipRegionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreIntersectClipRectangleRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreExcludeClipRectangleRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetXformRectRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSaveRegionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreRestoreRegionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSelectPathRegionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreRegionSelectBitmapRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreCopyClipRegionRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreClipPathCurvesRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);

// Set function name for dll init routine

CHAR * TestCaseName= "GreClip";

static  NAMES_AND_ADDRESSES EntryPointList[]=
    {
          TOKENIZEFUNCTIONNAME(GreClipPre),
//          TOKENIZEFUNCTIONNAME(GreClipApp),
          TOKENIZEFUNCTIONNAME(GreIntersectClipRectangleExh),
          TOKENIZEFUNCTIONNAME(GreExcludeClipRectangleExh),
          TOKENIZEFUNCTIONNAME(GreOffsetClipRegionExh),
          TOKENIZEFUNCTIONNAME(GreSelectAndQueryClipRegionExh),
          TOKENIZEFUNCTIONNAME(GreCopyClipRegionExh),
          TOKENIZEFUNCTIONNAME(GreSetXformRectExh),
          TOKENIZEFUNCTIONNAME(GreGetClipBoxAndRctsAndVChkExh),
//          TOKENIZEFUNCTIONNAME(GreSaveAndRestoreRegionExh),
          TOKENIZEFUNCTIONNAME(GreSelectPathRegionExh),
//          TOKENIZEFUNCTIONNAME(GreRegionSelectBitmapExh),
//          TOKENIZEFUNCTIONNAME(GreClipPathCurvesExh),
          TOKENIZEFUNCTIONNAME(GreGetClipBoxRc),
          TOKENIZEFUNCTIONNAME(GreGetClipRectsRc),
          TOKENIZEFUNCTIONNAME(GreOffsetClipRegionRc),
          TOKENIZEFUNCTIONNAME(GrePtVisibleRc),
          TOKENIZEFUNCTIONNAME(GreRectVisibleRc),
          TOKENIZEFUNCTIONNAME(GreQueryClipRegionRc),
          TOKENIZEFUNCTIONNAME(GreSelectClipRegionRc),
          TOKENIZEFUNCTIONNAME(GreIntersectClipRectangleRc),
          TOKENIZEFUNCTIONNAME(GreExcludeClipRectangleRc),
          TOKENIZEFUNCTIONNAME(GreSetXformRectRc),
          TOKENIZEFUNCTIONNAME(GreSaveRegionRc),
          TOKENIZEFUNCTIONNAME(GreRestoreRegionRc),
          TOKENIZEFUNCTIONNAME(GreSelectPathRegionRc),
          TOKENIZEFUNCTIONNAME(GreRegionSelectBitmapRc),
//          TOKENIZEFUNCTIONNAME(GreClipPathCurvesRc),
          TOKENIZEFUNCTIONNAME(GreCopyClipRegionRc)
         };

/****************************************************************************
 *
 * Routine Name: InitTest()
 *
 * Purpose:  Initialize function names and address array.
 *
 * System Requirements:
 *
 * Revision Log: 12/17/91,      Graphics Suite Extension, Thom Bain
 *                              Initial Design.
 *
 * Inputs:
 *   sel                - passed through to the InitTestSegVars function
 *   init_info_p        - name and address array used by DTT interface
 *
 * Outputs:
 *   init_info_p        - returned initialized with names and addresses
 *
 * Subroutines Required:
 *   InitTestSegVars()  - used by the DTT interface
 *
 * Limitations: None
 *
 *
 ***************************************************************************/
/****************************************************************************
 * Algorithm:
 * {
 *   Get the number of tests.
 *   for the number of tests {
 *                Get the test names;
 *                Get the test addresses;
 *                }
 *   call InitTestSegVars function
 *   }
 *
 ***************************************************************************/

VOID APIENTRY InitTest(PVOID Selector, PTESTINITINFO init_info_p)
{
  register USHORT usTestCounter;

  init_info_p->ntests = NTESTS;
  strcpy(init_info_p->group_name,TestCaseName); //Testcase Name

  for (usTestCounter=0 ;usTestCounter< NTESTS; ++usTestCounter){

     init_info_p->test_addrs[usTestCounter]=
                               EntryPointList[usTestCounter].TestAddress;

     strcpy(init_info_p->test_names[usTestCounter],
                               EntryPointList[usTestCounter].TestName);

  }

  InitTestSegVars(Selector);
  return;
}

/***************************************************************************
 *
 * Routine Name: GreClipPre
 *
 * Purpose: Precision entry point for GRECLIP test case
 *
 * System Requirements: Section 13.
 *
 * Revision Log: 12/17/91,    Graphics Suite Extension, Thom Bain
 *                      Initial Entry Point Design.
 *
 * Inputs:
 *
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    BOOL           // selection call
 *
 * Outputs:
 *    six pattern filled boxes based on the size of the device; basically
 *    there is an inch border all around the device space with half inch
 *    spacing between pattern filled boxes. Four boxes are the same size,
 *    two on the lower left side and two on the lower right side of the
 *    device. The fifth box is across the top and the sixth is a column
 *    between the first four.
 *
 * Subroutines under test: GreIntersectClipRectangle, GreExcludeClipRectangle,
 *    GreSelectClipRegion, GreOffsetClipRegion, GreSelectPathRegion,
 *    GreSetXformRect, GreCopyClipRegion, and GreGetClipBox.
 *
 * Subroutines Required:
 *    ENTER_MAIN, EXIT_MAIN, WinSendMsg, strcmp, ABORTENTRY, SETENTER,
 *    GpiQueryDevice, CLEANUP, GpiSetPattern, gpi_grid, WorldWriteString,
 *    SETEXIT, GreIntersectClipRectangle, GreExcludeClipRectangle, GpiMove,
 *    GpiBox, GreSelectClipRegion, sprintf, MapAndWriteString,
 *    GreSetXformRect, GpiDestroyRegion, GpiBeginPath, GpiEndPath,
 *    GreOffsetClipRegion, GreSelectPathRegion, GreCopyClipRegion,
 *    GpiSetClipPath, GreGetClipBox, and DeviceIsPrinter.
 *
 * Limitations:
 *          OD_QUEUED/PM_Q_STD is an environmental restriction.
 *
 ***************************************************************************/

/***************************************************************************
 * Algorithm:
 * {
 *    - query the environment, if OD_QUEUED/PM_Q_STD call ABORTENTRY
 *    - query the device for the device context
 *    - establish PATSYM_DENSE6 as the default fill pattern
 *    - initialize corner points for drawing a PS sized box
 *    - calculate number of 1/2 inch widths for 1st four boxes (There will
 *      be 1" border with 2" gap in middle for 1" wide box with half inch gap)
 *    - calculate number of 1/2 inch heights for 1st four boxes (again a 1"
 *      border with half inch gaps. Attempt to make all three region heights
 *      equal but adjust to use all of the space (i.e. if one left over give
 *      it to top region, if two left over give one to each of the bottom two
 *      region heights.
 *    - draw half-inch precision grid
 *    - use GreIntersectClipRectangle to establish clip region to be of the
 *      predetermined height, one inch up with one inch margins on left and
 *      right.
 *    - use GreExcludeClipRectangle to remove middle two inches on the
 *      horizontal.
 *    - draw PS sized pattern filled box. Should appear as two boxes; one at
 *      [1, 1] to [width + 1, height + 1] and [width + 3, 1] to
 *      [2 * width + 3 , height + 1] where width and height are the pre-
 *      determined sizes of the first four boxes.
 *    - use GreSelectClipRegion de-activate region and save handle.
 *    - use GreSetXformRect to create a region for region 3 to be at
 *      [1, height + 1.5] to [width + 1, 2 * height + 1.5]
 *    - draw PS sized pattern filled box. Should appear as a boxes at
 *      [1, height + 1.5] to [width + 1, 2 * height + 1.5]
 *    - restore original device window with GreSetXformRect
 *    - use GreSelectClipRegion to re-establish first clip region from the
 *      saved handle.
 *    - use GreOffsetClipRegion to move the region up height + 0.5 inches
 *      and to the right 2 inches.
 *    - draw PS sized pattern filled box. Should appear as a box at
 *      [width + 3, height + 1.5] to [2 * width + 3, 2 * height + 1.5]
 *    - use GreSelectClipRegion to de-activate region and GpiDestroyRegion
 *      to release space back to system.
 *    - create a path that is the rectangle with lower left corner at
 *      [1, 2 * height + 2] to upper right [pg_size_x - 1, pg_size_y - 1]
 *    - make this path active with GpiSetClipPath.
 *    - use GreGetClipBox to get the path region rectangle definition
 *    - use GreIntersectClipRectangle to establish this a a clip region
 *    - use GpiSelectClipPath to discard the clip path
 *    - use GreSelectClipRegion to de-select the current clip region and
 *      save in a handle.
 *    - use GreSelectPathRegion with this handle to establish the path as
 *      a clipping region.
 *    - draw PS sized pattern filled box. should appear as a box from
 *      [1, 2 * height + 2] to [pg_size_x - 1, pg_size_y - 1]
 *    - use GreSelectPathRegion to discard this clip path.
 *    - use GreIntersectClipRectangle to establish a clip region for the
 *      middle columnar box from [width + 1.5, 1.5] to
 *      [width + 2.5, 2 * height + 1.5]
 *    - use GreSelectClipRegion to de-activate and save region handle
 *    - use GreIntersectClipRectangle to establish a smaller clip region.
 *    - use GreSelectClipRegion to restore saved region and save current
 *      region handle.
 *    - use GreCopyClipRegion to copy the current/active region into the
 *      region just saved. The original will be completely replaced.
 *    - use GreSelectClipRegion to select the copied region
 *    - draw a PS sized box, should get box at [width + 1.5, 1.5] to
 *      [width + 2.5, 2 * height + 1.5]
 *    - use GreSelectClipRegion to deactivate region and GpiDestroyRegion
 *      to release the space back to the system.
 * }
 *
 ***************************************************************************/

VOID APIENTRY GreClipPre(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{

  static PCHAR EntryName="GreClipPre"; // entry point name
  HDC          hDC;
  POINTL       ptlLLC, ptlURC, ptlOffset, ptlPathLLC, ptlPathURC;
  RECTL        rcRect;
  HRGN         hrgn1, hrgn2;
  INT          width, height, num_usable;
  CHAR         Buffer[100];


  if (SelectionCall)
        WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
  else
  {

    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop), MPFROMP(&lDCType));

    if (DeviceIsPrinter() && lDCType==OD_QUEUED &&
                             strcmp("PM_Q_STD", dop.pszDataType)==0) {
      ABORTENTRY(EntryName, "OD_QUEUED/PM_Q_STD");
      return;
    }

    // If the environment is o.k. then begin testing.
    ENTER_MAIN(EntryName);

    // Perform the setting up of the test environment.
    SETENTER(EntryName,"Precision Setup");

    // Get the default device context
    if ((hDC=GpiQueryDevice(hPS))==HDC_ERROR)
    {
      CLEANUP("GpiQueryDevice", EntryName);
      return;
    }

    if (GpiSetPattern(hPS, PATSYM_DENSE6) == FALSE)
    {
      CLEANUP("GpiSetPattern", EntryName);
      return;
    }

    // initialize corner points for drawing PS sized box
    ptlLLC.x = 0L;
    ptlLLC.y = 0L;
    ptlURC.x = pg_width - 1;
    ptlURC.y = pg_height - 1;

    // calculate region sizes based on device size, leave 1 inch border
    // and 2 inches in middle for 1 inch wide column
    width = (INT)(pg_size_x - 4); // number of 1/2 inch squares
    // provide for Three verticle regions with 1/2 inch between.
    // because of copied regions 1st 2 must be equal and last 2 uses rest
    num_usable = (INT)(pg_size_y * 2 - 6);  // 1/2" gaps and 1" border
    height = num_usable / 3;
    if (num_usable % 3 == 2) height++;

    // Draw a grid of specified size (HALF_INCH, ONE_INCH, TWO_INCH)
    gpi_grid(hPS, HALF_INCH);
    WorldWriteString(MapX(350L), MapY((pg_size_y - 1) * 100L) + syPosition,
                     "Half-inch precision grid");

    // Log end of setup.
    SETEXIT();

    // use GreIntersectClipRectangle to create a clip region
    // one inch up from bottom and height (1/2") squares high
    rcRect.xLeft = MapX(100L);
    rcRect.xRight = MapX((pg_size_x - 1) * 100L);
    rcRect.yBottom = MapY(100L);
    rcRect.yTop = MapY(height * 50L + 100L);
    if (GreIntersectClipRectangle(hDC, &rcRect) == RGN_ERROR)
    {
      CLEANUP("GreIntersectClipRectangle", EntryName);
      return;
    }

    // use GreExcludeClipRectangle to remove two inch from center
    rcRect.xLeft = MapX(width * 50L + 100L);
    rcRect.xRight = MapX(width * 50L + 300L);
    if (GreExcludeClipRectangle(hDC, &rcRect) == RGN_ERROR)
    {
      CLEANUP("GreExcludeClipRectangle", EntryName);
      return;
    }

    // Draw the PS sized box
    GpiMove(hPS, &ptlLLC);
    GpiBox(hPS, DRO_FILL, &ptlURC, 0L, 0L);

    // get this region's handle and reset clipping region to NULL
    if (GreSelectClipRegion(hDC, NULL, &hrgn1) == RGN_ERROR)
    {
      CLEANUP("GreSelectClipRegion", EntryName);
      return;
    }

    // inform tester what just occurred
    sprintf(Buffer, "[1.0,1.0] - [%3.1f,%3.1f]", ((double)width/2 + 1.0),
                                              ((double)height/2 + 1.0));
    WorldWriteString(MapX(100L), MapY(100L) - syPosition, Buffer);
    MapAndWriteString(100L, ((height + 2) * 50L) + 5L,
                    "GreIntersectClipRectangle");
    sprintf(Buffer, "[%3.1f,1.0] - [%3.1f,%3.1f]", ((double)width/2 + 3.0),
                        (double)width + 3.0, ((double)height/2 + 1.0));
    WorldWriteString(MapX(width * 50L + 300L), MapY(100L) - syPosition,
                                                           Buffer);
    MapAndWriteString(width * 50L + 300L, height * 50L + 105L,
                    "GreExcludeClipRectangle");

    // setup a clipping region using GreSetXformRect to be at location
    // [1, (3 + height)/2] - [1 + width/2, (3 + 2 * height)/2]
    rcRect.xLeft   = (LONG)(0.0254 * (double)hori_pels_per_m + 0.5);
    rcRect.xRight  = (LONG)(0.0254 * (1.0 + ((double)width / 2.0))
                                   * (double)hori_pels_per_m + 0.5);
    rcRect.yBottom = (LONG)(0.0254 * (1.5 + (height / 2.0))
                                   * (double)vert_pels_per_m + 0.5);
    rcRect.yTop    = (LONG)(0.0254 * (1.5 + (double)height)
                                   * (double)vert_pels_per_m + 0.5);

    if (GreSetXformRect(hDC, &rcRect) == RGN_ERROR)
    {
      CLEANUP("GreSetXformRect", EntryName);
      return;
    }

    // Draw the PS sized box
    GpiMove(hPS, &ptlLLC);
    GpiBox(hPS, DRO_FILL, &ptlURC, 0L, 0L);

    // restore rectangle to device size
    rcRect.xLeft = 0L;
    rcRect.xRight = dev_width - 1;
    rcRect.yBottom = 0L;
    rcRect.yTop = dev_height - 1;

    if (GreSetXformRect(hDC, &rcRect) == RGN_ERROR)
    {
      CLEANUP("GreSetXformRect", EntryName);
      return;
    }

    // inform user of what just occurred
    sprintf(Buffer, "[1.0,%3.1f] - [%3.1f,%3.1f]", (double)height/2 + 1.5,
                      (double)width/2 + 1.0, (double)height + 1.5);
    WorldWriteString(MapX(100L), MapY(height * 50L + 150L) - syPosition,
                                                        Buffer);
    MapAndWriteString(100L, height * 100L + 155L, "GreSetXformRect");

    // restore original clip region and save current (if any)
    if (GreSelectClipRegion(hDC, hrgn1, &hrgn2) == RGN_ERROR)
    {
      CLEANUP("GreSelectClipRegion", EntryName);
      return;
    }

    // use GreOffsetClipRegion to move first region up 2.5 inches
    ptlOffset.x = SizeX((width + 4) * 50L);
    ptlOffset.y = SizeY((height + 1) * 50L);
    if (GreOffsetClipRegion(hDC, &ptlOffset) == RGN_ERROR)
    {
      CLEANUP("GreOffsetClipRegion", EntryName);
      return;
    }

    // Draw the PS sized box
    GpiMove(hPS, &ptlLLC);
    GpiBox(hPS, DRO_FILL, &ptlURC, 0L, 0L);

    // reset to no clip region
    if (GreSelectClipRegion(hDC, NULL, &hrgn1) == RGN_ERROR)
    {
      CLEANUP("GreSelectClipRegion", EntryName);
      return;
    }

    if ((hrgn1 != NULLHANDLE) && (GpiDestroyRegion(hPS, hrgn1) == FALSE))
    {
      CLEANUP("GpiDestroyRegion", EntryName);
      return;
    }
    if ((hrgn2 != NULLHANDLE) && (GpiDestroyRegion(hPS, hrgn2) == FALSE))
    {
      CLEANUP("GpiDestroyRegion", EntryName);
      return;
    }

    // inform user of what just occurred
    sprintf(Buffer, "[%3.1f,%3.1f] - [%3.1f,%3.1f]", (double)width/2 + 3.0,
      (double)height/2 + 1.5, (double)width + 3.0, (double)height + 1.5);
    WorldWriteString(MapX(width * 50L + 300L),
                 MapY(height * 50L + 150L) - syPosition, Buffer);
    MapAndWriteString(width * 50L + 300L, height * 100L + 155L,
                                  " GreOffsetClipRegion");

    // create a path and establish it as a clip region
    if (GpiBeginPath(hPS, 1L) == FALSE)
    {
      CLEANUP("GpiBeginPath", EntryName);
      return;
    }

    ptlPathLLC.x = MapX(100L);
    ptlPathLLC.y = MapY((height + 2) * 100L);
    ptlPathURC.x = MapX((pg_size_x - 1) * 100L);
    ptlPathURC.y = MapY((pg_size_y - 1) * 100L);

    GpiMove(hPS, &ptlPathLLC);
    GpiBox(hPS, DRO_OUTLINE, &ptlPathURC, 0L, 0L);

    if (GpiEndPath(hPS) == FALSE)
    {
      CLEANUP("GpiEndPath", EntryName);
      return;
    }

    if (GpiSetClipPath(hPS, 1L, SCP_ALTERNATE | SCP_AND) == FALSE)
    {
      CLEANUP("GpiSetClipPath", EntryName);
      return;
    }

    // fetch the area definition to establish a region with
    if (GreGetClipBox(hDC, &rcRect) == RGN_ERROR)
    {
      CLEANUP("GreGetClipBox", EntryName);
      return;
    }

    if (GreIntersectClipRectangle(hDC, &rcRect) == RGN_ERROR)
    {
      CLEANUP("GreIntersectClipRectangle", EntryName);
      return;
    }

    // discard the clip path
    if (GpiSetClipPath(hPS, 0L, SCP_RESET) == FALSE)
    {
      CLEANUP("GpiSetClipPath", EntryName);
      return;
    }

    // save region handle and set to no region selected
    if (GreSelectClipRegion(hDC, NULL, &hrgn1) == RGN_ERROR)
    {
      CLEANUP("GreSelectClipRegion", EntryName);
      return;
    }

    // re-establish clip path via region handle and gre under test
    if (GreSelectPathRegion(hDC, hrgn1) == FALSE)
    {
      CLEANUP("GreSelectPathRegion", EntryName);
      return;
    }

    // Draw the PS sized box
    GpiMove(hPS, &ptlLLC);
    GpiBox(hPS, DRO_FILL, &ptlURC, 0L, 0L);

    // reset to no clip path
    if (GreSelectPathRegion(hDC, NULL) == FALSE)
    {
      CLEANUP("GreSelectPathRegion", EntryName);
      return;
    }

    // inform user of what just occurred
    sprintf(Buffer, "[1.0,%3.1f] - [%3.1f,%3.1f]",
      (double)height + 2.0, (double)width + 3.0, (double)pg_size_y - 1.0);
    WorldWriteString(MapX(100L),
                 MapY(height * 100L + 200L) - syPosition, Buffer);
    MapAndWriteString(100L, (pg_size_y - 1) * 100L + 5L,
                                  "GreSelectPathRegion");

    // create region for column down center, one inch wide with base
    // at 1.5 inches and top the same as the tops of second row.
    rcRect.xLeft = MapX(width * 50L + 150L);
    rcRect.xRight = MapX(width * 50L + 250L);
    rcRect.yBottom = MapY(150L);
    rcRect.yTop = MapY(height * 100L + 150L);
    if (GreIntersectClipRectangle(hDC, &rcRect) == RGN_ERROR)
    {
      CLEANUP("GreIntersectClipRectangle", EntryName);
      return;
    }

    // reset to no clip region and save in hrgn1 handle
    if (GreSelectClipRegion(hDC, NULL, &hrgn1) == RGN_ERROR)
    {
      CLEANUP("GreSelectClipRegion", EntryName);
      return;
    }

    // move bottom up to top of first box (just to make it different)
    rcRect.yBottom = MapY((height + 2) * 50L);
    if (GreIntersectClipRectangle(hDC, &rcRect) == RGN_ERROR)
    {
      CLEANUP("GreIntersectClipRectangle", EntryName);
      return;
    }

    // restore hrgn1 and save current in hrgn2
    if (GreSelectClipRegion(hDC, hrgn1, &hrgn2) == RGN_ERROR)
    {
      CLEANUP("GreSelectClipRegion", EntryName);
      return;
    }

    // copy this region hrgn1 into hrgn2
    if (GreCopyClipRegion(hDC, hrgn2, &rcRect, COPYCRGN_CLIPRGN)
                                                              == RGN_ERROR)
    {
      CLEANUP("GreCopyClipRegion", EntryName);
      return;
    }

    // set to new hrgn2 and save current region
    if (GreSelectClipRegion(hDC, hrgn2, &hrgn1) == RGN_ERROR)
    {
      CLEANUP("GreSelectClipRegion", EntryName);
      return;
    }

    // Draw the PS sized box
    GpiMove(hPS, &ptlLLC);
    GpiBox(hPS, DRO_FILL, &ptlURC, 0L, 0L);

    // reset to no clip region
    if (GreSelectClipRegion(hDC, NULL, &hrgn2) == RGN_ERROR)
    {
      CLEANUP("GreSelectClipRegion", EntryName);
      return;
    }

    // inform user of what just occurred
    sprintf(Buffer, "[%3.1f,1.5] -", (double)width/2 + 1.5);
    WorldWriteString(MapX(width * 50L + 150L),
                                           MapY(150L) - syPosition, Buffer);
    sprintf(Buffer, " [%3.1f,%3.1f]", (double)width/2 + 2.5,
                                                    (double)height + 1.5);
    WorldWriteString(MapX(width * 50L + 150L),
                                      MapY(150L) - (2 * syPosition), Buffer);
    MapAndWriteString(width * 50L + 100L, height * 100L + 155L,
                                  " GreCopyClipRegion");

    if ((hrgn1 != NULLHANDLE) && (GpiDestroyRegion(hPS, hrgn1) == FALSE))
    {
      CLEANUP("GpiDestroyRegion", EntryName);
      return;
    }

    if ((hrgn2 != NULLHANDLE) && (GpiDestroyRegion(hPS, hrgn2) == FALSE))
    {
      CLEANUP("GpiDestroyRegion", EntryName);
      return;
    }

    // Exit the entry point
    EXIT_MAIN(EntryName);
  }
  return;
}


/***************************************************************************
 *
 * Routine Name: GreClipApp
 *
 * Purpose: General application of the GRECLIP (most of) functions
 *
 * System Requirements: Section 13.0
 *
 * Revision Log: 12/17/91,    Graphics Suite Extension, Thom Bain
 *                      Initial Entry Point Design.
 *
 * Inputs:
 *
 *    hPS            // presentation space
 *    hWndClient     // client window
 *    BOOL           // selection call
 *
 * Outputs:
 *          NONE
 *
 * Subroutines Required:
 *    ENTER_MAIN()
 *    EXIT_MAIN()
 *    All other required subroutines are listed here.
 *
 * Limitations:
 *          NONE
 *
 *
 ***************************************************************************/

/***************************************************************************
 * Algorithm:
 * {
 *      Detailed Design in algorithmic form
 * }
 *
 ***************************************************************************/

VOID APIENTRY GreClipApp(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{

  PCHAR EntryName="GreClipApp"; // entry point name
  HDC   hDC;

      if (SelectionCall)
            WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
      else
   {

// Here is an example of how to call ABORTENTRY if the environment is invalid

//            ABORTENTRY(EntryName, "OD_QUEUED/PM_Q_STD");

// If the environment is o.k. then begin testing.

            ENTER_MAIN(EntryName);

// Perform the setting up of the test environment.

    SETENTER(EntryName, "Initializations" );

    // Get the Device Context Handle from the hPS.
    if ( (hDC=GpiQueryDevice(hPS)) == HDC_ERROR)
    {
      CLEANUP("GpiQueryDevice", EntryName);
      return;
    }
    SETEXIT();

// Log a subitem entry.

//            SUBENTER(ERROR_CODE_UNDER_TEST_GOES_HERE, EntryName);

// Here is an example of how to call SHOWERROR to log error conditions

//            SHOWERROR("Function that failed goes here", EntryName);

// Here is an example of how to call ERRSTATUS to log PASS/FAIL status

//            ERRSTATUS(TRUE, EntryName, szAddMessage);

// Here is an example of how to call ERRSTATUS to log an explanatory message

//            ERRSTATUS(FALSE, LogText1, LogText2);

// Here is an example of how to call ERRSTATUS to sync up its internal counter
// with ErrorCount

//            ERRSTATUS(FALSE, NULL, NULL);

// Log a subitem exit.

//            SUBEXIT();

// Exit the entry point

      EXIT_MAIN(EntryName);
      }
      return;
}
