#Created     : 11-15-93
#Modified by : K. Qureshi
#Last updated: 11-15-93

PROJ     = GREDVCON
PROJFILE = GREDVCON.MAK


BASEDIR   = ..\..\..
OBJDIR    = ..\
BINDIR    = ..\
KH         = $(BASEDIR)\h
IBMH      = $(BASEDIR)\ibmh
H386      = $(BASEDIR)\h386
INC       = $(BASEDIR)\inc
LIB       = $(BASEDIR)\lib
TOOLSPATH = $(BASEDIR)\tools


#
# TOOLKIT21
# replace z: drive and path name to your installed drive and path name
#

TLKT21DIR = z:\toolkt21
TLIBPATH =$(TLKT21DIR)\dll
TPATH    =$(TLKT21DIR)\os2bin
THELP    =$(TLKT21DIR)\os2help
TLIB     =$(TLKT21DIR)\os2lib
TINCLUDE =$(TLKT21DIR)\c\os2h;$(TLKT21DIR)\c\os2h\vdd;$(TLKT21DIR)\asm\os2inc

#
# CSET/W SPECIFIC DEFINES
#

LOCALE = $(BASEDIR)\ibmc\clocale
IBMCINC = $(BASEDIR)\ibmc\cinclude
IBMCLIB = $(BASEDIR)\ibmc\clib
IBMCLIBPATH = $(BASEDIR)\ibmc\cdll
IBMCBIN = $(BASEDIR)\ibmc\cbin
IBMCHELP = $(BASEDIR)\ibmc\chelp
DPATH     = $(LOCALE);$(IBMCHELP);

CINC     = -I. -I.. -I$(IBMH) -I$(H386) -I$(H)
AINC     = -I. -I$(INC)
LIB386   = $(LIB)\os2386.lib
LIBP     = $(LIB)\os2386p.lib
LIBDDE   = $(BASEDIR)\ibmc\clib\dde4mbs $(BASEDIR)\ibmc\clib\dde4mbm
LIBS     =  $(LIBDDE) $(LIB386)


#
# Add new object modules here
#


#OBJS    =


!if [set HELP=$(IBMCHELP);$(THELP)] || \
    [set LOCALE = $(LOCALE)]  || \
    [set LIB=$(IBMCLIB);$(TLIB)] || \
    [set LIBPATH=$(IBMCLIBPATH);$(TLIBPATH)] || \
    [set PATH=$(TOOLSPATH);$(IBMCBIN);$(TPATH);] || \
    [set DPATH=$(DPATH)] || \
    [set INCLUDE=.\;$(IBMCINC);$(TINCLUDE);$(IBMH);..\]

!endif
CC         = icc
H2INC      = h2inc
LINK       = link386

#  /W3           - Warns of all non-ANSI usage
#  /G3           - Generate 80486 code
#  /DLINT_ARGS   - Check functional arguments against prototypes
#  /Sp           - Packs Structure
#  /Ti+          - Generates all debugger information
#  /Sm           - Allow all C Set/2 extensions including those for migration
#  /O-           - Do not optimize object code
#  /Gs-          - Disable stack checking
#  /Mp           - OPTLINK linkage for function
#  /Ge           - Build .EXE file
#  /Ss           - Allow for the // comments

CFLAGS =  /c+ /G3 /W3 /DLINT_ARGS /Sp /Ti- /O- /Mp /Gd+ /Gm+ /Ge- /Sm-  /Ss

LFLAGS   =   /M /li  /STACK:64000  /PACKC /PACKD  /CO  /NOD

compile =$(CC) $(CFLAGS)


TESTNAME  = GREDVCON          #   1) Add Testname Here
MAPNAME   = $(TESTNAME).MAP   #   Map file name. Supplied to the LINKER.
RESFILE   = $(TESTNAME).RES   #   Resource file name produced from .RC file
ARFFILE   = $(TESTNAME).ARF   #   Automatic Response File. Used for linking.
DEFFILE   = $(TESTNAME).DEF   #   Definition file name.
DEPLIST   = $(LOBJ1) $(LOBJ2)  $(LOBJ3)
           # Bitmap Files that need to be included within DLLs as
           # resources.
BITMAP    =

# Step 2) Put object files to link here.

LOBJ1     = gredvcon.obj
LOBJ2     = common1.obj
LOBJ3     = DTTdllvr.obj

          #  Header files that are common to one DLL.

HFILES    = $(TESTNAME).H  DTTdlldf.h common1.h common2.h



.RC.RES:
      @RC -R $*.RC


..\bin\$(TESTNAME).DLL: $(DEPLIST)
    if not exist ..\bin md ..\bin
     $(LINK) $(LFLAGS) @<<$(ARFFILE)
   $(LOBJ1)+
   $(LOBJ2)+
   $(LOBJ3),
   ..\bin\$(TESTNAME).DLL,
   $(MAPNAME),
   $(LIBS),
   $(DEFFILE)
<<

 @IF exist $(RESFILE) RC $(RESFILE) ..\bin\$(TESTNAME).DLL
 @IF exist $(ARFFILE) DEL $(ARFFILE) >NUL


$(RESFILE):     $(TESTNAME).RC  $(BITMAP)

# Step 3) Put object build parts here.


gredvcon.obj:   gredvcon.h gredvcon.c DTTdlldf.h common1.h
    $(compile) /Fo$@ gredvcon.c

common1.obj:      common1.c common1.h
    $(compile) /Fo$@ common1.c

DTTdllvr.obj:   DTTdllvr.c
    $(compile) /Fo$@ DTTdllvr.c
