/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#pragma title("GREESC.C")
#pragma subtitle("IBM Confidential")

/*const char header=$header$*/

#define INCL_DEV      /* include all non common device definitions */
#define INCL_WIN      /* include all Win definitions               */
#define INCL_GPI      /* include all Gpi definitions               */
#define INCL_GREALL   /* include all Gre definitions               */
#define INCL_ERRORS   /* include all Gre error definitions         */

#include <stdio.h>
#include <string.h>
#include <os2.h>
#include <pmddi.h>       /* defines for greall          */
#include "DTTDLLDF.h"    /* test case defines           */
#include "greesc.h"      /* gre escape dll include file */
#include "std_util.h"

/****************************************************************************
 *\\ddd
 * Subtask Name: pdvt
 *
 * Module name: greesc.c
 *
 * Purpose: gre escape dll test case functions
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * SAD References:
 *
 * SAR References:
 *
 * Contents:
 *
 * Design Overview:
 *
 * Limitations:
 *
 *\\end
****************************************************************************/

/****************************************************************************
 *\\ddd
 * Routine Name: InitTest()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID  APIENTRY InitTest(PVOID sel, PTESTINITINFO pInitInfo)
  {
    pInitInfo->ntests = NTESTS;
    strcpy(pInitInfo->group_name,pGroupName);
    strcpy(pInitInfo->test_names[0],pTestName0);
    pInitInfo->test_addrs[0]=GreEscapeApp;
    strcpy(pInitInfo->test_names[1],pTestName1);
    pInitInfo->test_addrs[1]=GreQueryEscapeSupportRc;
    strcpy(pInitInfo->test_names[2],pTestName2);
    pInitInfo->test_addrs[2]=GreStartDocRc;
    strcpy(pInitInfo->test_names[3],pTestName3);
    pInitInfo->test_addrs[3]=GreEndDocRc;
    strcpy(pInitInfo->test_names[4],pTestName4);
    pInitInfo->test_addrs[4]=GreNextBandRc;
    strcpy(pInitInfo->test_names[5],pTestName5);
    pInitInfo->test_addrs[5]=GreAbortDocRc;
    strcpy(pInitInfo->test_names[6],pTestName6);
    pInitInfo->test_addrs[6]=GreNewFrameRc;
    strcpy(pInitInfo->test_names[7],pTestName7);
    pInitInfo->test_addrs[7]=GreDraftModeRc;
    strcpy(pInitInfo->test_names[8],pTestName8);
    pInitInfo->test_addrs[8]=GreFlushOutputRc;
    strcpy(pInitInfo->test_names[9],pTestName9);
    pInitInfo->test_addrs[9]=GreRawDataRc;
    strcpy(pInitInfo->test_names[10],pTestName10);
    pInitInfo->test_addrs[10]=GreStdJournalRc;
    strcpy(pInitInfo->test_names[11],pTestName11);
    pInitInfo->test_addrs[11]=GreGetScalingFactorRc;

    InitTestSegVars(sel);
  }
/****************************************************************************
 *\\ddd
 * Routine Name: GreEscapeApp()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreEscapeApp(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG     error_count;     /* number of function failures */
  FILE*    escapefile;      /* temp file used for escape calls */
  CHAR     out_string[257]; /* used in error messages */
  INT      i;               /* generic loop counter */
  LONG     cInCount;        /* number of bytes pointed to by pInData */
  PBYTE    pInData;         /* pointer to escape code value specifying function */
  HDC      printer_hdc;     /* printer device con+ex+ handle */
  DEVOPENSTRUC dop;         /* device open structure */
  DRIVDATA     driv;        /* sub structure to dop */
  HAB      hAB;             /* anchor block handle */
  LONG     rc;              /* greescape return code */
  LONG     lDCtype;         /* parameter to GreEscape */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
    *pBasisX = 10000;
    *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscapeApp - Entry.\n");

    memset(out_string,'\0',sizeof(out_string));

    if ((escapefile = fopen("temp.cat","w+")) == NULL) {
       sprintf(out_string,"Error opening test file : %x.",escapefile);
       WinMessageBox( HWND_DESKTOP, hWndClient,
                      out_string,
                      "GreEscape",
                      0, MB_OK | MB_MOVEABLE | MB_CUAWARNING );
       return;
    }

    for (i = 0; i < 2; i++) {
        fprintf(escapefile,"12345678901234567890123456789012345678901234567890\n");
        fprintf(escapefile,"PPPPPPPPP   DDDDDDDD    VVV   VVV TTTTTTTTTTTTT   \n");
        fprintf(escapefile,"PPPPPPPPPPP DDDDDDDDDD  VVV   VVV TTTTTTTTTTTTT   \n");
        fprintf(escapefile,"PPP     PPP DDD     DDD VVV   VVV      TTT        \n");    fprintf(escapefile,"PPP     PPP DDD                                   \n");
        fprintf(escapefile,"PPP     PPP DDD     DDD VVV   VVV      TTT        \n");
        fprintf(escapefile,"PPP     PPP DDD     DDD VVV   VVV      TTT        \n");
        fprintf(escapefile,"PPPPPPPPPPP DDD     DDD VVV   VVV      TTT        \n");
        fprintf(escapefile,"PPPPPPPPP   DDD     DDD VVV   VVV      TTT        \n");
        fprintf(escapefile,"PPP         DDD     DDD VVV   VVV      TTT        \n");
        fprintf(escapefile,"PPP         DDD     DDD VVV   VVV      TTT        \n");
        fprintf(escapefile,"PPP         DDD     DDD VVV   VVV      TTT        \n");
        fprintf(escapefile,"PPP         DDD     DDD VVV   VVV      TTT        \n");
        fprintf(escapefile,"PPP         DDDDDDDDDD   VVV VVV       TTT        \n");
        fprintf(escapefile,"PPP         DDDDDDDD      VVVVV        TTT        \n");
        fprintf(escapefile,"\n\n");
    }
    fclose(escapefile);

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    pInData = "temp.cat";
    if ((escapefile = fopen("temp.cat","r")) == NULL) {
       sprintf(out_string,"Error determining size of test file.");
       WinMessageBox( HWND_DESKTOP, hWndClient,
                      out_string,
                      "GreEscape",
                      0, MB_OK | MB_MOVEABLE | MB_CUAWARNING );
       return;
    }
    cInCount = (LONG)fseek(escapefile,SEEK_END,0);
    fclose(escapefile);

       //TSS...added 9/16/91
    if ((printer_hdc=GpiQueryDevice(hPS))==HDC_ERROR) {   /* Get  the default device context */
         BADERROR("GpiQueryDevice()",TRUE,"GreEscapeApp");
         return;
    }


//TSS Check to see if DEVESC_STARTDOC is supported

    pInData = "DEVESC_STARTDOC";
    cInCount = (LONG)strlen(pInData);
    rc = GreEscape(printer_hdc,DEVESC_QUERYESCSUPPORT,cInCount,pInData,NULL,NULL);

//TSS...if DEVESC_STARTDOC is supported, check for proper return code, else
//      skip the test.

    if( rc == DEV_OK ) {

        rc = GreEscape(printer_hdc,DEVESC_STARTDOC,cInCount,pInData,NULL,NULL);
        if (rc == DEVESC_ERROR)
           error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    }


    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreEscapeApp                                                   -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreEscapeApp                                                   -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscapeApp - Exit.\n");
  }
}


/****************************************************************************
 *\\ddd
 * Routine Name: GreQueryEscapeSupportRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreQueryEscapeSupportRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG     error_count;     /* number of function failures */
  LONG     cInCount;    /* number of bytes pointed to by pInData */
  PBYTE    pInData;     /* pointer to escape code value specifying function */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG     rc;
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-QueryEscapeSupport - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }


   /*
    * setup QUERYESCSUPPORT to query a supported function (guess) expecting
    * good return
    */
    pInData = "DEVESC_FLUSHOUTPUT";
    cInCount = (LONG)strlen(pInData);

    rc = GreEscape(printer_hdc,DEVESC_QUERYESCSUPPORT,cInCount,pInData,NULL,NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreQueryEscapeSupport                                          -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreQueryEscapeSupport                                          -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-QueryEscapeSupport - Exit.\n");
  }
}

/****************************************************************************
 *\\ddd
 * Routine Name: GreStartDocRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreStartDocRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG     error_count;     /* number of function failures */
  LONG     cInCount;    /* number of bytes pointed to by pInData */
  PBYTE    pInData;     /* pointer to escape code value specifying function */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;          /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-StartDoc - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    *  start a false document expecting an error returned
    *  the error can either be that the subfunction is not implemented
    *  or an error with the document which we don't care about
    */
    pInData = "c:\no\file\here";
    cInCount = (LONG)strlen(pInData);

    rc = GreEscape(printer_hdc,DEVESC_STARTDOC,cInCount,pInData,NULL,NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreStartDoc                                                    -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreStartDoc                                                    -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-StartDoc - Exit.\n");
  }
}
/****************************************************************************
 *\\ddd
 * Routine Name: GreEndDocRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreEndDocRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG     error_count;     /* number of function failures */
  PLONG    pOutCount;   /* number of bytes pointed to by pOutData */
  PLONG    pOutData;    /* pointer to escape code value specifying function */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;        /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-EndDoc - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    *  end a false document expecting an error returned
    *  the error can either be that the subfunction is not implemented
    *  or an error with the document which we don't care about
    */
    pOutData = (PLONG)"z";
    pOutCount = (PLONG)2;

       // TSS...passed the address of pOutCount and pOutData instead
       // of the value.  This is what is expected in this call.
    rc = GreEscape(printer_hdc,DEVESC_ENDDOC,NULL,NULL,&pOutCount,&pOutData);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreEndDoc                                                      -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreEndDoc                                                      -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-EndDoc - Exit.\n");
  }
}
/****************************************************************************
 *\\ddd
 * Routine Name: GreNextBandRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreNextBandRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG     error_count;     /* number of function failures */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;        /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-NextBand - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    *  call the subfunction with null parameters simply to
    *  see if the function is supported
    */
    rc = GreEscape(printer_hdc,DEVESC_NEXTBAND,NULL,NULL,NULL,NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"GreNextBand                                                     -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"GreNextBand                                                     -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-NextBand - Exit.\n");
  }
}
/****************************************************************************
 *\\ddd
 * Routine Name: GreAbortDocRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreAbortDocRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG     error_count;     /* number of function failures */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;        /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-AbortDoc - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    * call the subfunction with null parameters simple to check
    * if the function is supported
    */
    rc = GreEscape(printer_hdc,DEVESC_ABORTDOC,(LONG)NULL,(PBYTE)NULL,(PLONG)NULL,(PLONG)NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreAbortDoc                                                    -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreAbortDoc                                                    -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-AbortDoc - Exit.\n");

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);
  }
}
/****************************************************************************
 *\\ddd
 * Routine Name: GreNewFrameRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreNewFrameRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG     error_count;     /* number of function failures */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;        /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-NewFrame - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    * call the subfunction with null parameters to simple check
    * if the function is supported
    */
    rc = GreEscape(printer_hdc,DEVESC_NEWFRAME,(LONG)NULL,(PBYTE)NULL,(PLONG)NULL,(PLONG)NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreNewFrame                                                    -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreNewFrame                                                    -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-NewFrame - Exit.\n");
  }
}
/****************************************************************************
 *\\ddd
 * Routine Name: GreDraftModeRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreDraftModeRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG      error_count;     /* number of function failures */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;        /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-DraftMode - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    * call the subfunction with each valid parameter to simply check
    * if the function is supported
    */
    CWRITELOG(L_LOTRACE,0,"+ie+ GreEscape - DRAFTMODE - ON - Function Supported Test - Entry.\n");
    rc = GreEscape(printer_hdc,DEVESC_DRAFTMODE,(LONG)2,(PBYTE)0,(PLONG)NULL,(PLONG)NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);
    CWRITELOG(L_LOTRACE,0,"+ix+ GreEscape - DRAFTMODE - ON - Exit.\n");

    CWRITELOG(L_LOTRACE,0,"+ie+ GreEscape - DRAFTMODE - OFF - Function Supported Test - Entry.\n");
    rc = GreEscape(printer_hdc,DEVESC_DRAFTMODE,(LONG)2,(PBYTE)1,(PLONG)NULL,(PLONG)NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);
    CWRITELOG(L_LOTRACE,0,"+ix+ GreEscape - DRAFTMODE - OFF - Exit.\n");

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"GreDraftMode                                                    -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreDraftMode                                                   -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-DraftMode - Exit.\n");
  }
}
/****************************************************************************
 *\\ddd
 * Routine Name: GreFlushOutputRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreFlushOutputRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG      error_count;     /* number of function failures */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;        /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-FlushOutPut - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    * call the subfunction with null parameters simply to check
    * if the function is supported
    */
    rc = GreEscape(printer_hdc,DEVESC_FLUSHOUTPUT,(LONG)NULL,(PBYTE)NULL,(PLONG)NULL,(PLONG)NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreFlushOutput                                                 -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreFlushOutput                                                 -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-FlushOutPut - Exit.\n");
  }
}
/****************************************************************************
 *\\ddd
 * Routine Name: GreRawDataRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreRawDataRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG      error_count;     /* number of function failures */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;        /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-RawData- Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    * call the subfunction with null parameters simply to check if
    * the function is supported
    */
    rc = GreEscape(printer_hdc,DEVESC_RAWDATA,(LONG)NULL,(PBYTE)NULL,(PLONG)NULL,(PLONG)NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreRawData                                                     -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreRawData                                                     -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-RawData- Exit.\n");
  }
}
/****************************************************************************
 *\\ddd
 * Routine Name: GreStdJournalRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreStdJournalRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG      error_count;     /* number of function failures */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;        /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-StdJournal - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    * call the subfunction with null parameters simply to check
    * if the function is supported
    */
    rc = GreEscape(printer_hdc,DEVESC_STD_JOURNAL,(LONG)NULL,(PBYTE)NULL,(PLONG)NULL,(PLONG)NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreStdJournal                                                  -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreStdJournal                                                  -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-StdJournal - Exit.\n");
  }
}
/****************************************************************************
 *\\ddd
 * Routine Name: GreGetScalingFactrRc()
 *
 * Purpose:
 *
 * System Requirements: 6.9
 *
 * Revision Log:
 *              11-20-90, pdvt, mark richardson
 *                      - initial file
 *
 * Inputs:
 *
 * Outputs:
 *
 * Subroutines Required:
 *
 * Limitations:
 *
 *\\end
 ***************************************************************************/

/****************************************************************************
 *\\algorithm
 * < insert pseudo code here >
 *\\end
 ***************************************************************************/
VOID APIENTRY GreGetScalingFactorRc(HPS hPS,HWND hWndClient,BOOL SelectionCall)
{
  LONG      error_count;     /* number of function failures */
  DEVOPENSTRUC   dop;   /* device open structure */
  DRIVDATA driv;        /* sub structure to dop */
  HDC      printer_hdc; /* return code from DevOpenDC */
  LONG     lDCtype;     /* used by WinSendMsg     */
  ULONG    rc;        /* return code from GreEscape call */
  HAB      hAB;
  CHAR     out_string[257]; /* used in error messages */

  if (SelectionCall) {
    WinSendMsg (hWndClient, (USHORT) WM_DTHREAD_DOES_DEVCALLS, NULL, NULL);
        *pBasisX = 10000;
        *pBasisY = 10000;
  }
  else {
    error_count = 0L;
    LOG_SIGNATURE;
    CWRITELOG(L_LOTRACE,0,"+ee+ GreEscape-GetScalingFactor - Function Supported Test - Entry.\n");

    hAB = WinQueryAnchorBlock(hWndClient);
    dop.pdriv = &driv;
    WinSendMsg(hWndClient,WM_GET_DEVOPENSTRUC,MPFROMP(&dop),MPFROMP(&lDCtype));
    printer_hdc = DevOpenDC(hAB,OD_QUEUED,"*",6L,(PDEVOPENDATA)&dop,NULL);
    if (printer_hdc == DEV_ERROR) {
       BADERROR ("DevOpenDC",TRUE,"GreEscape");
       return;
    }

   /*
    * call the subfunction with null parameters simply to check
    * if the function is supported
    */
    rc = GreEscape(printer_hdc, DEVESC_GETSCALINGFACTOR, NULL,NULL,NULL,NULL);
    if (rc == DEVESC_ERROR)
       error_count += CHECKRETURNERROR(rc,"PMERR_ESC_CODE_NOT_SUPPORTED",SEVERITY_ERROR,PMERR_ESC_CODE_NOT_SUPPORTED);

    // **************************************************
    // TSS...added to kill all output that is generated.*
    // Pass/Fail should be determined by the Log file.  *
    // Changes made on 6/28/91                          *
    DevEscape(GpiQueryDevice(hPS),DEVESC_ABORTDOC,(LONG) NULL,
                                      NULL, NULL,NULL);

    if (error_count) {
       sprintf(out_string,"$Errorcount == %ld.\n",error_count);
       CWRITELOG(L_HDR,0,out_string);
       CWRITELOG(L_HDR,0,
"$GreGetScalingFactor                                            -    FAIL.\n");
    }
    else
       CWRITELOG(L_HDR,0,
"$GreGetScalingFactor                                            -    PASS.\n");

    CWRITELOG(L_LOTRACE,0,"+ex+ GreEscape-GetScalingFactor - Exit.\n");
  }
}
