#Created     : 11-16-93
#Modified by : K. Qureshi
#Last updated: 11-16-93


#  greline.mak make file creates greline.dll
#  for DTT

PROJ     = GRELINE
PROJFILE = GRELINE.MAK


BASEDIR   = ..\..\..
OBJDIR    = ..\
BINDIR    = ..\
KH         = $(BASEDIR)\h
IBMH      = $(BASEDIR)\ibmh
H386      = $(BASEDIR)\h386
INC       = $(BASEDIR)\inc
LIB       = $(BASEDIR)\lib
TOOLSPATH = $(BASEDIR)\tools


#
# TOOLKIT21
# replace z: drive and path name to your installed drive and path name
#

TLKT21DIR = z:\toolkt21
TLIBPATH =$(TLKT21DIR)\dll
TPATH    =$(TLKT21DIR)\os2bin
THELP    =$(TLKT21DIR)\os2help
TLIB     =$(TLKT21DIR)\os2lib
TINCLUDE =$(TLKT21DIR)\c\os2h;$(TLKT21DIR)\c\os2h\vdd;$(TLKT21DIR)\asm\os2inc

#
# CSET/W SPECIFIC DEFINES
#

LOCALE = $(BASEDIR)\ibmc\clocale
IBMCINC = $(BASEDIR)\ibmc\cinclude
IBMCLIB = $(BASEDIR)\ibmc\clib
IBMCLIBPATH = $(BASEDIR)\ibmc\cdll
IBMCBIN = $(BASEDIR)\ibmc\cbin
IBMCHELP = $(BASEDIR)\ibmc\chelp
DPATH     = $(LOCALE);$(IBMCHELP);

CINC     = -I. -I.. -I$(IBMH) -I$(H386) -I$(H)
AINC     = -I. -I$(INC)
LIB386   = $(LIB)\os2386.lib
LIBP     = $(LIB)\os2386p.lib
LIBDDE   = $(BASEDIR)\ibmc\clib\dde4mbs $(BASEDIR)\ibmc\clib\dde4mbm
LIBS     =  $(LIBDDE) $(LIB386)


#
# Add new object modules here
#

OBJS  = greline.obj gre_grid.obj std_util.obj \
         stdutil2.obj \
        DTTdllvr.obj


!if [set HELP=$(IBMCHELP);$(THELP)] || \
    [set LOCALE = $(LOCALE)]  || \
    [set LIB=$(IBMCLIB);$(TLIB)] || \
    [set LIBPATH=$(IBMCLIBPATH);$(TLIBPATH)] || \
    [set PATH=$(TOOLSPATH);$(IBMCBIN);$(TPATH);] || \
    [set DPATH=$(DPATH)] || \
    [set INCLUDE=.\;$(IBMCINC);$(TINCLUDE);$(IBMH);..\]

!endif
CC         = icc
H2INC      = h2inc
LINK       = link386

#  /W3           - Warns of all non-ANSI usage
#  /G3           - Generate 80486 code
#  /DLINT_ARGS   - Check functional arguments against prototypes
#  /Sp           - Packs Structure
#  /Ti+          - Generates all debugger information
#  /Sm           - Allow all C Set/2 extensions including those for migration
#  /O-           - Do not optimize object code
#  /Gs-          - Disable stack checking
#  /Mp           - OPTLINK linkage for function
#  /Ge           - Build .EXE file
#  /Ss           - Allow for the // comments

CFLAGS =  /c+ /G3 /W3 /DLINT_ARGS /Sp /Ti- /O- /Mp /Gd+ /Gm+ /Ge- /Sm-  /Ss


LFLAGS   =   /M /li  /STACK:64000  /PACKC /PACKD  /CO , , /NOD
compile =$(CC) $(CFLAGS)


..\bin\greline.dll: $(OBJS) greline.def
    if not exist ..\bin md ..\bin
    $(LINK) $(OBJS), $@ $(LFLAGS) $(LIBS), GRELINE.DEF;

greline.obj: greline.c greline.h DTTdlldf.h std_util.h gre_grid.h extras.h
    $(compile) /Fo$@ greline.c

gre_grid.obj: gre_grid.c DTTdlldf.h gre_grid.h
    $(compile)  /Fo$@ gre_grid.c

DTTdllvr.obj: DTTdllvr.c DTTdlldf.h
    $(compile) /Fo$@ DTTdllvr.c

std_util.obj: std_util.c DTTdlldf.h
    $(compile) /Fo$@ std_util.c

stdutil2.obj: stdutil2.c DTTdlldf.h
    $(compile) /Fo$@ stdutil2.c

