/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#ifndef GRETXTST_H
#define GRETXTST_H
/*****************************************************************************
 *\\ddd
 * Subtask Name: PDVT
 *
 * Module Name: GRETEXTST
 *
 * Purpose: Include file for GreTextSt dll.
 *
 *  $header$
 *
 * Revision Log: 10/25/90, PDVT, Gisselle Labault
 *               - created initial file
 *               12/17/90, PDVT, Mike Abuzant
 *              -  Added function prototypes
 *              -  Deleted 'hAB' parameter.
 *
 *               01/01/91, PDVT, Mike Abuzant
 *              -  added some define statments.
 *
 * SRS References: Section 6.4
 *
 * Contents:  This file contains the following definitions:
 *              - function prototypes
 *              - define's specific to GRETEXTST
 *
 * Limitations:
 *           none
 *\\end
 *****************************************************************************/

/* declare all dll functions */
VOID  APIENTRY InitTest(PVOID sel, PTESTINITINFO pInitInfo);
VOID  APIENTRY GreTextApp1(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreTextApp2(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreCharStringExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreCharStringPosExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreQueryTextBoxExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreQueryWidthTableExh(HPS hPS, HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY GreRealizeFontExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreDeviceQueryFontsExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreDeviceQueryFontAttributesExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreQueryCharPositionsExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreGetCodePageExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetCodePageExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreGetPairKerningTableExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);

VOID  APIENTRY GreCharStringRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreCharStringPosRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreQueryTextBoxRc(HPS hPS, HWND hWndClient,  BOOL SelectionCall);
VOID  APIENTRY GreQueryWidthTableRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreRealizeFontRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreDeviceQueryFontsRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreDeviceQueryFontAttributesRc(HPS hPS, HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY GreQueryCharPositionsRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GreSetCodePageRc(HPS hPS, HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY GreGetPairKerningTableRc(HPS hPS, HWND hWndClient, BOOL SelectionCall);


typedef struct _FontSelection{
           CHAR Fontname[33];
           LONG lMatch;
}FontSelection;

typedef FontSelection  FAR *PFONTSELECTION;
typedef PFONTSELECTION FAR *PPFONTSELECTION;

BOOL EzQueryFonts(HPS  hPS, HWND hWndClient, PLONG Count, PPFONTSELECTION  FontStorage);
LONG EzCreateLogicalFonts(HPS , HWND,LONG,FontSelection,USHORT);

#define NTESTS  22  /* number of functions or entry points in this dll */

PCHAR TestCaseName= "GRE Text    ";
PCHAR testname1   = "GreTextApp1";
PCHAR testname2   = "GreTextApp2";
PCHAR testname3   = "GreCharStringRc";
PCHAR testname4   = "GreCharStringPosRc";
PCHAR testname5   = "GreQueryTextBoxRc";
PCHAR testname6   = "GreQueryWidthTableRc";
PCHAR testname7   = "GreRealizeFontRc";
PCHAR testname8   = "GreDeviceQueryFontsRc";
PCHAR testname9   = "GreDeviceQueryFontAttributesRc";
PCHAR testname10  = "GreQueryCharPositionsRc";
PCHAR testname11  = "GreSetCodePageRc";
PCHAR testname12  = "GreGetPairKerningTableRc";
PCHAR testname13  = "GreCharStringExh";
PCHAR testname14  = "GreCharStringPosExh";
PCHAR testname15  = "GreQueryTextBoxExh";
PCHAR testname16  = "GreQueryWidthTableExh";
PCHAR testname17  = "GreRealizeFontExh";
PCHAR testname18  = "GreDeviceQueryFontsExh";
PCHAR testname19  = "GreDeviceQueryFontAttributesExh";
PCHAR testname20  = "GreQueryCharPositionsExh";
PCHAR testname21  = "GreGetCodePageExh";
PCHAR testname22  = "GreSetCodePageExh";
PCHAR testname23  = "GreGetPairKerningTableExh";


CHAR *szSel[]={"Normal","Italic","Bold","Strike-out","Undersore"};
USHORT afsSel[]= {0,FATTR_SEL_ITALIC,FATTR_SEL_BOLD,
                          FATTR_SEL_STRIKEOUT,FATTR_SEL_UNDERSCORE};
#define USER_LCID   1L
#define  DEFAULTATTRIBUTES  CHS_OPAQUE|CHS_CLIP|CHS_ATTR_INFO|\
                            CHS_LEAVEPOS|CHS_START_XY
CHAR       ErrorString[200];
#define  SWAPCOORDINATE(aptl)  {                \
                              POINTL  Temp;  \
                              Temp=aptl[TXTBOX_TOPRIGHT];\
                              aptl[TXTBOX_TOPRIGHT]=aptl[TXTBOX_BOTTOMRIGHT];\
                              aptl[TXTBOX_BOTTOMRIGHT]=Temp;\
                              aptl[TXTBOX_CONCAT]=aptl[TXTBOX_TOPLEFT];\
                             }\

#endif

