#Created     : 12-06-93
#Modified by : K. Qureshi
#Last updated: 12-06-93


#  for DTT

PROJ     = DTT
PROJFILE = DTT.MAK


BASEDIR   = ..\..\..
OBJDIR    = ..\
BINDIR    = ..\
KH         = $(BASEDIR)\h
IBMH      = $(BASEDIR)\ibmh
H386      = $(BASEDIR)\h386
INC       = $(BASEDIR)\inc
LIB       = $(BASEDIR)\lib
TOOLSPATH = $(BASEDIR)\tools

#
# TOOLKIT21
# replace z: drive and path name to your installed drive and path name
#

TLKT21DIR = z:\toolkt21
TLIBPATH =$(TLKT21DIR)\dll
TPATH    =$(TLKT21DIR)\os2bin
THELP    =$(TLKT21DIR)\os2help
TLIB     =$(TLKT21DIR)\os2lib
TINCLUDE =$(TLKT21DIR)\c\os2h;$(TLKT21DIR)\c\os2h\vdd;$(TLKT21DIR)\asm\os2inc

#
# CSET/W SPECIFIC DEFINES
#

LOCALE = $(BASEDIR)\ibmc\clocale
IBMCINC = $(BASEDIR)\ibmc\cinclude
IBMCLIB = $(BASEDIR)\ibmc\clib
IBMCLIBPATH = $(BASEDIR)\ibmc\cdll
IBMCBIN = $(BASEDIR)\ibmc\cbin
IBMCHELP = $(BASEDIR)\ibmc\chelp
DPATH     = $(LOCALE);$(IBMCHELP);

CINC     = -I. -I.. -I$(IBMH) -I$(H386) -I$(H)
AINC     = -I. -I$(INC)
LIB386   = $(LIB)\os2386.lib
LIBP     = $(LIB)\os2386p.lib
LIBDDE   = $(BASEDIR)\ibmc\clib\dde4mbs $(BASEDIR)\ibmc\clib\dde4mbm
LIBS     =  $(LIBDDE) $(LIB386)


#
# Add new object modules here
#


!if [set HELP=$(IBMCHELP);$(THELP)] || \
    [set LOCALE = $(LOCALE)]  || \
    [set LIB=$(IBMCLIB);$(TLIB)] || \
    [set LIBPATH=$(IBMCLIBPATH);$(TLIBPATH)] || \
    [set PATH=$(TOOLSPATH);$(IBMCBIN);$(TPATH)] || \
    [set DPATH=$(DPATH)] || \
    [set INCLUDE=.\;$(IBMCINC);$(TINCLUDE);$(IBMH);..\]

!endif
CC         = icc
H2INC      = h2inc
LINK       = link386

#  /W3           - Warns of all non-ANSI usage
#  /G3           - Generate 80486 code
#  /DLINT_ARGS   - Check functional arguments against prototypes
#  /Sp           - Packs Structure
#  /Ti+          - Generates all debugger information
#  /Sm           - Allow all C Set/2 extensions including those for migration
#  /O-           - Do not optimize object code
#  /Gs-          - Disable stack checking
#  /Mp           - OPTLINK linkage for function
#  /Ge           - Build .EXE file
#  /Ss           - Allow for the // comments

CFLAGS  = /W3 /G3 /DLINT_ARGS /Sp /Ti- /Sm /Gm+ /Gd+ /O+ /Gs+ /Mp /Ss
LFLAGS   =  /NOD /STACK:64000 /M /NOF /PACKC /PACKD  /CO /PM:PM
compile =$(CC) $(CFLAGS)


MAPFILE  = dtt.map
LINKER   = link386
LRF      = echo > NUL
RC       = rc
DEF_FILE = DTT.DEF

OBJS  = DTT.obj      DTTCOMM.obj  \
        DTTDLGS.obj  DTTLOG.obj   \
        DTTINIT.obj  DTTPRINT.obj \
        DTTSCRPT.obj
RESS  = DTT.res

compile =$(CC) /c $(CFLAGS)

all: $(PROJ).exe


DTT.obj : DTT.C DTT.h DTTmain.h DTTlog.h dttdlg.h ..\dttdlls\dtt_dll.h
   $(compile) /Fo$@ dtt.c

DTTCOMM.obj : DTTCOMM.C DTT.h DTTcomm.h dttdlg.h ..\dttdlls\dtt_dll.h
   $(compile) /Fo$@ dttcomm.c

DTTLOG.obj : DTTLOG.C DTT.h DTTlog.h dttdlg.h ..\dttdlls\dtt_dll.h
   $(compile) /Fo$@ dttlog.c

DTTDLGS.obj : DTTDLGS.C DTT.h DTTlog.h DTTdlgs.h dttdlg.h ..\dttdlls\dtt_dll.h
   $(compile) /Fo$@ dttdlgs.c

DTTINIT.obj : DTTINIT.C DTT.h DTTlog.h DTTinit.h dttdlg.h ..\dttdlls\dtt_dll.h
   $(compile) /Fo$@ dttinit.c

DTTPRINT.obj : DTTPRINT.C DTT.h DTTprint.h dttdlg.h ..\dttdlls\dtt_dll.h
   $(compile) /Fo$@ dttprint.c

DTTSCRPT.obj : DTTSCRPT.C DTT.h DTTscrpt.h dttdlg.h ..\dttdlls\dtt_dll.h
   $(compile) /Fo$@ dttscrpt.c

DTT.res : DTT.RC DTT.h DTT.DLG dttdlg.h ..\dttdlls\dtt_dll.h


$(PROJ).exe : $(DEF_FILE) $(OBJS) $(RESS)
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE)
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS);
<<

        $(LINKER) @$(PROJ).lrf
        $(RC) $(RESS) $@


.rc.res :
        rc -r -p $< $@

