/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT (C) Microsoft Corporation, 1989                                 */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = DTTINIT.H
 *
 * DESCRIPTIVE NAME = This header file contains all the constants, variables,
 *                    function prototypes for use by the DTTINIT.c module.
 *
 *
 *
 *
 * VERSION = V2.0
 *
 * DATE
 *
 * DESCRIPTION :
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
*/

/*
** Constant definitions used in InitTestCases function
*/

#define  NORMAL_FILES  0               /* used in DosFindFirst/Next         */
#define  FILE_ATTRIBUTE NORMAL_FILES   /* "                                 */
#define  SEARCH_PATTERN "*.DLL"        /* "                                 */
#define  RESERVED      0L              /* "                                 */
#define  INIT_PROC_NAME "INITTEST"     /* used in DosGetProcAddr            */
#define  ERROR         0               /* error return code                 */
#define  BACKSLASH     '\\'
#define  ERROR_TITLE   "Error Loading File"
#define  MEMORY_ALLOC_SIZE 65536L

/*
** External function prototypes
*/

extern TID startPrintThread(VOID);

extern TID startScriptThread(VOID);
extern MRESULT EXPENTRY CmdLineDlgProc(HWND,USHORT,MPARAM,MPARAM);

/*
** External vars
*/

extern HAB hABPrintThread;
extern TID ScriptThreadID;       /* Thread ID for background script thread */
extern TID PrintThreadID;        /* Thread ID for background print thread  */
extern CHAR szAppName[20];       /* class name of application (DTT)        */
extern CHAR *pass_fail;          /* test log pass/fail variable            */

/*
** Local function prototypes
*/

BOOL DTT_Init(INT argc,CHAR **argv);
BOOL get_parms(INT argc,CHAR **argv);
VOID ParseFileSpec(PCHAR pszFileSpec,PCHAR szSearchPattern);
CHAR *GetNextFileSpec(INT argc,CHAR *argv[]);
BOOL LoadAndInitializeTestCase(HWND hWnd,PCHAR szSearchPattern);
VOID PostErrorMessage(HWND hWnd,USHORT MessageID);
INT InitPrinters(VOID);
INT _cdecl qsort_compare(const void *s1,const void *s2);
VOID Dtt_WriteHeader(VOID);
VOID Dtt_RecordLogLevel(VOID);
