/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT (C) Microsoft Corporation, 1989                                 */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = DTTLOG.H
 *
 * DESCRIPTIVE NAME = This header file defines the macros and external functions
 *                    for access to the DTT logging tool.
 *
 *
 *
 *
 * VERSION = V2.0
 *
 * DATE
 *
 * DESCRIPTION :
 *
 * NOTES
 *
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
*/

/*
** Open the logging file
** - filename is a null terminated string specifying the name of the log file
** example:  DTT_OPENLOG("DTT_LOG");
*/

#define  DTT_OPENLOG(filename) Dtt_openlog(filename)
VOID Dtt_WriteHeader(VOID);

VOID Dtt_RecordLogLevel(VOID);

/*
** Write to the log file
** - level is logging level
** - rc is a return code (not used but kept for compatibility with testlog)
** - string is the string to output to the log file
** example:  DTT_CWRITELOG(L_FAIL,0,"*ERROR - partial arc did not close\n");
*/

#define  DTT_CWRITELOG(level,logentry)  if((INT)level <=dttloglevel){   \
                      fprintf(logfile,logentry);                          \
                       }
/*
** Close the log file
** - no parms (yet)
** example:  DTT_CLOSELOG();
*/

#define  DTT_CLOSELOG() Dtt_closelog()

/*
** if in DTTLOG module then define as local
*/

#if      defined(DTTLOG)
INT dttloglevel;                      /* Dtt log level (from command line) */
FILE *logfile;                        /*  log file                         */
VOID Dtt_openlog(CHAR *logname);      /* open log                          */
VOID Dtt_closelog();                  /* close log file                    */

#else
extern INT dttloglevel;                 /* logging level (from CWRITELOG)  */
extern FILE *logfile;                   /* pointer to log file             */
extern VOID Dtt_openlog(CHAR *logname); /* open log                        */
extern VOID Dtt_closelog(VOID);         /* close log file                  */
#endif
