.*/*Ŀ*/
.*/*                                                                          */
.*/* PROGRAM NAME: Audio Device Driver Exerciser                              */
.*/* -----------                                                              */
.*/*  This file defines the help panels for the PMADDE                        */
.*/*  These panels are defined using the Information Presentation Language    */
.*/*  markup tags.  This file is compiled with the IPFC conversion tool to    */
.*/*  create the .hlp file which becomes the help library file for the        */
.*/*  program.                                                                */
.*/*                                                                          */
.*/* COPYRIGHT:                                                               */
.*/* ----------                                                               */
.*/*  Copyright (C) International Business Machines Corp., 1993               */
.*/*                                                                          */
.*/* DISCLAIMER OF WARRANTIES:                                                */
.*/* -------------------------                                                */
.*/*  The following [enclosed] code is sample code created by IBM Corporation.*/
.*/*  This sample code is not part of any standard IBM product and is provided*/
.*/*  to you solely for the purpose of assisting you in the development of    */
.*/*  your applications.  The code is provided "AS IS", without warranty of   */
.*/*  any kind.  IBM shall not be liable for any damages arising out of your  */
.*/*  use of the sample code, even if they have been advised of the           */
.*/*  possibility of such damages.                                            */
.*/*                                                                          */
.*/*                                                                          */
.*/**/
.*
:userdoc.
:title.Audio Device Driver Exerciser
.*:body.
.*--------------------------------------------------------
:h1 res=29 name=GENHLP.About Audio Device Driver Exerciser (PMADDE)
:i1 id=GENHLP.Audio Device Driver Exerciser
:p.The Audio Device Driver Exerciser(PMADDE) is a sample program that
demonstrates a test engine for exercising a Ring 0 Multimedia
Presentation Manager/2 Audio stream handler.  Audio Device Driver
Exerciser is used to test code for low-level MMPM/2 components,
such as audio device drivers or stream handlers.
:p.Audio Device Driver Exerciser is useful in testing the individual functions
of the audio driver bypassing media control interface code.
:p.Multiple Devices and Multiple Streams are supported by
Audio Device Driver Exerciser.
:p.For documentation see the :hp1.MMPM/2 Device Driver Reference:ehp1. (S71G3678).
.*--------------------------------------------------
:h1 res=32 name=HELP_HOWTO.How to use Audio Device Driver Exerciser (PMADDE)
:i2 refid=GENHLP.How to use PMADDE
:p.
PMADDE supports multiple devices. PMADDE defaults to the first waveform
audio device it locates. If you have more than one audio device
installed, use :hp2.Options:ehp2. menu and select :hp2.Change Device... :ehp2.
to select the audio device you want to test.
:p.
:hp6.Step 1.:ehp6. Select :hp2.Data Stream:ehp2.. From this pull down menu
select :hp2.SpiGetHandler...:ehp2. and you will see a list of installed
handlers.  Select AUDIOSH$(audio stream handler) and FSSH(file system stream
handler). The Active Handlers window then lists the handle names, classes, and
the IDs for AUDIOSH$ and FSSH.
:p.Handler ID's are provided for active handlers to be a source(producer) and
a target(consumer).
:p.
:hp6.Step 2.:ehp6. Select :hp2.Data Stream:ehp2.. From this pull down menu
select :hp2.SpiCreateStream...:ehp2.Enter the source(3) and target(2) stream
handler ID's and select the stream data type from the list. The Stream state
field in the Active Streams window now displays information about the stream
that has been created.  The audio device driver has accepted the audio IOCtls
and the IDC APIs to creat the stream. On most devices you can create multiple
streams.

:p.
:hp6.Step 3.:ehp6. Select :hp2.Data Stream:ehp2.. From this pull down menu
select :hp2.SpiAssociate...:ehp2. to display the Associate Data Stream window.
Enter the input stream number, and an audio file name to be associated with.

:p.
:hp6.Step 4.:ehp6. Select :hp2.Data Stream:ehp2.. From this pull down menu
select :hp2.SpiStart...:ehp2. to display the Start Stream window. Enter the
stream number to be started and select the start flag.  The SpiStartStream
function starts data streaming in a specific stream or a synchronized group
of streams. This function also enables a stream to be prerolled.
:p.To start stream immediately select :hp2.Start:ehp2. flag.  Select the
:hp2.Preroll:ehp2. flag to cause the source stream handler to start and fill
the buffers. An event is generated by the Sync/Stream Manager when a stream
is prerolled.

:p.
Other :hp2.Data Streaming:ehp2. functions that are supported by PMADDE
are
:ul compact.
:li. :hp2. :link refid=STOP reftype=hd.SpiStop...:ehp2. :elink.
:li. :hp2. :link refid=INSTALL reftype=hd.SpiInstallProtocol...:ehp2. :elink.
:li. :hp2. :link refid=DESTROY reftype=hd.SpiDestroy...:ehp2. :elink.
:li. :hp2. :link refid=SEEK reftype=hd.SpiSeek...:ehp2. :elink.
:li. :hp2. :link refid=TIME reftype=hd.SpiQueryTime...:ehp2. :elink.
:eul.
.*-------------------------------------------------------------------
:h1 res=29 name=HOWTO_SUPP.How to support new devices.
:i2 refid=GENHLP.How to add support for new devices.
:p.
PMADDE currently supports
:ul compact.
:li. IBM MACPA
:li. IBM speaker driver
:li. Creative Labs Sound Blaster Pro
:li. Creative Labs Sound Blaster 16 ASP
:li. Media Vision Pro Audio Spectrum
:eul.
:p.
PMADDE can support new devices with minimum changes to the PMADDE source.
:p.
First, change directory to "MMOS2\MMTOOLKT\NEATSTUF\PMADDE" and modify
the :hp2.pmaddevs.rc:ehp2. to include the data for the device you intend
to support.
:p.
Then modify if necessary the file :hp2.pmadsubs.c:ehp2.. In
function :hp2.ListInsertStreamDataTypes:ehp2. check and see if all the
data types for your new device are listed, if not add the missing data
types to this function.  If you insert any missing data types also modify
the file :hp2.pmadde.h:ehp2. to increase the number of data types in the
#define statement :hp2.NUMDATATYPES:ehp2. by the number of data types
you added to the function ListInsertStreamDataTypes.

Now, rebuild the PMADDE source and you can test your new device using
PMADDE.

:p.
:hp6.Note.:ehp6. MMPM/2 should recognise this new device else PMADDE
may not be able to see this new device listed in the Change Device...
window.

.*--------------------------------------------------------
:h2 res=18 name=STREAM.Data Stream
:i1 id=STREAM.Data Stream
:p.The Data Stream menu lists SPI streaming function options
including SpiGetHandler, SpiCreateStream,
SpiAssociateStream, SpiStartStream, SpiStopStream, and so on.
.*---------------------------------------------------------
:h2 res=6 name=GETHANDLER.Help for SpiGet Handler
:i2 refid=STREAM.Get Handler
:p.Use :hp2.SpiGet Handler:ehp2. to get
stream handles.  This sends an SpiGetHandler function to return a
stream handler ID and ensure that the stream handler is loaded.  This
operation must be completed prior to stream creation.
:p.Note that the source and target stream handler, as well
as the source and target device association, must be specified when the
stream is created.
:p.:hp7.Note:ehp7. AUDIOSH$ and FSSH are the only handlers that can be
tested using the PMADDE program. The source code can modified to create
tools that test stream handlers other than AUDIOSH$ and FSSH.
.*--------------------------------------------------------
:h2 res=1 name=CREATE.Help for SpiCreate
:i2 refid=STREAM.Create Stream
:p.Use :hp2.SpiCreate:ehp2. to create a stream.
When a media control driver (or other multimedia
application) determines that data will be streamed between devices,
it sends SpiCreateStream, which results in the stream creation.
The caller specifies the source and target stream handler IDs,
source and target device specific information, and the stream data type.
:p.In the entry fields type source and target stream
handler IDs and from the list box choices select the appropriate
data type.
.*--------------------------------------------------------
:h2 res=2 name=ASSOCIATE.Help for SpiAssociate
:i2 refid=STREAM.Associate Stream
:p.Use :hp2.SpiAssociate:ehp2. to
associate the specified stream with the specified audio file.  In the
entry fields type the stream number you wish to associate and the audio
file name to be associated.
.*--------------------------------------------------------
:h2 res=3 name=START.Help for SpiStart
:i2 refid=STREAM.Start Stream
:p.Use :hp2.SpiStart:ehp2. to
start the stream.  This choice sends SpiStartStream which starts
data streaming in a specific stream or a synchronized group of streams,
depending on the flags for this function.  This function also allows
a stream or group of streams to be prerolled.  Preroll allows the
source stream handlers to start and fill the buffers.  An event is
generated by the Sync/Stream Manager when the streams are prerolled.
The application can then start the streams for an improved real-time
response and initial synchronization of streams.
.*--------------------------------------------------------
:h2 res=4 name=STOP.Help for SpiStop
:i2 refid=STREAM.Stop Stream
:p.Use :hp2.SpiStop:ehp2. to
stop the data streaming.  There are three types of stops for this
command.  The first is the regular stop or pause, which pauses the
data stream, but does not disturb any data.  The second type of
stop is a discard stop, which requests that the stream be stopped
immediately and the data left in the stream buffers be discarded.
The third type is a flush stop, which requests that the source
stream handler be stopped, but that the target stream handler continue
until the last buffer held at the time the stop was requested is
consumed by the target stream handler.
:p.For a discard or flush stop, the Sync/Stream Manager will detect
when the stream handlers have stopped and return all buffers.  At
this point, the Sync/Stream Manager notifies the application with
an EVENT_STREAM_STOPPED event in the Event Monitor window.
:p.Streams can be restarted after a stop or end-of-stream (EOS).  For
the EOS case, the stream would need to be reassociated with another
object or seeked back to some point in the stream to actually start
streaming again.  A flush stop after a pause stop causes the stream
to flush the existing buffers to the output device.
:nt.Typically, data streaming continues until the
end of the stream.  When this happens, the Sync/Stream Manager sends
an EVENT_EOS event to the applications event routine.
:ent.
.*--------------------------------------------------------
:h2 res=7 name=INSTALL.Help for SpiInstall Protocol
:i2 refid=STREAM.Install Protocol
:p.Use :hp2.SpiInstall Protocol:ehp2. to
install stream protocol in the stream handler.
.*--------------------------------------------------------
:h2 res=9 name=DESTROY.Help for SpiDestroy
:i2 refid=STREAM.Destroy Stream
:p.Use :hp2.SpiDestroy:ehp2. to
destroy the stream.  This sends SpiDestroyStream
to destroy the specified stream.  Destroy Stream exercises the
DDCMD_CONTROL(DDCMD_STOP) and DDCMD_REG_STREAM messages from the
inter-device driver communication (IDC) level.  When a stream
is no longer to be used by an application, it must be destroyed.
:p.Note that the stream handlers involved may remain active with other
streams, and will remain available to create additional streams
(without additional calls to SpiGetHandler).  The application will
receive no further stream events in its event handling routine
after calling the SpiDestroyStream function.  All system resources
allocated to the stream are released, including the physical memory
used to create stream buffers.
:p.After the stream is destroyed, the stream handler state returns
to its condition prior to the creation of the
stream.  If the stream being destroyed is a master stream of a
sync group, all synchronization under that master stream will
become inactive.  If the stream is a slave in a sync group,
the stream will be removed from the sync group and will not affect the
master or other slave streams in the group.
.*--------------------------------------------------------
:h2 res=5 name=SEEK.Help for SpiSeek
:i2 refid=STREAM.Seek Stream
:p.Use :hp2.SpiSeek:ehp2. to
seek the stream to a certain position, back to 0, or position forward.
This choice seeks to a specific point in the stream source object.
Depending on the type of object associated to the stream at a source or
target, this function directs the appropriate stream handler to relocate
the current stream index, or position, to the specified location.  The
object types that support this function are memory, file, CD track, and
library object.  Use this function to reposition the stream forward or
backward from its current position.  This can be performed only on a
newly created stream, a stream that has not been started,
or a stream that has been stopped (discard stop, flush
stop, or EOS).
.*--------------------------------------------------------
:h2 res=16 name=TIME.Help for SpiQuery Time
:i2 refid=STREAM.Query Stream Time
:p.Use :hp2.SpiQuery Time:ehp2. to
seek time information.  This choice sends the SpiGetTime function to
the stream handler which issues a DDCMD_STATUS message to the audio
device driver to report the current stream time in milliseconds.
This function is supported for any stream that is active or stopped,
and will not disrupt data transport in the stream.  A more accurate
method to determine the stream time is to enable stream time events,
which will report stream time continuously and in real-time to the
application.
.*--------------------------------------------------------
:h1 res=25 name=VIEWS.Help for View
:i1 id=VIEW.View
:p.Use the choices on the :hp2.View:ehp2. menu to
view installed stream handlers or to view device status.
.*--------------------------------------------------------
:h1 res=27 NAME=HANDLERS.Help for View Installed Handlers
:i2 refid=VIEW.View Installed Stream Handlers
:p.Use :hp2.Installed Handlers:ehp2.
to view the list of MMPM/2 installed stream handlers.
.*--------------------------------------------------------
:h1 res=15 name=STATUS.Help for Device Status
:i2 refid=VIEW.View Device Status
:p.Use :hp2.Device Status:ehp2.
to view the status of the device for a specified stream.
.*--------------------------------------------------------
:h1 res=19 name=OPTIONS.Help for Options
:i1 id=OPTIONS.Options
:p.Use the choices on the :hp2.Options:ehp2. menu to run a script file,
open an OS/2 window, change the device, or create a LOG file.
.*--------------------------------------------------------
:h1 res=17 name=FILE.Help for Run Script File
:i2 refid=OPTIONS.Run Script File
:p.Use :hp2.Run Script File:ehp2. to execute an existing script file.
The script file must have been previously created and must
contain valid streaming commands.
Select the appropriate script file name you wish
to open.  Select :hp2.OK:ehp2. to begin execution of the script.
:p.
A script file can be generated
by specifying command line arguments when starting the program.
Type:
:xmp.
PMADDE :hp1.scriptfile logfile:ehp1.
:exmp.
:p.
For example:
:xmp.
PMADDE TEST.SCR TEST.LOG
:exmp.
:p.
After specifying the arguments all further user interactive actions will
be recorded and a script file generated.  The log file logs command
completion status.
.*--------------------------------------------------------
:h1 res=11 name=DEVNAME.Help for Change Device
:i2 refid=OPTIONS.Change Device
:p.Use :hp2.Change Device:ehp2. to
change the device.  Select from the list of available devices.
:p.Note that the data types in the Create Data Stream window are changed
showing the data types supported by the selected device.
:p.Multiple devices and multiple streams are supported by
Audio Device Driver Exerciser.  So, streams can be created on
different devices.
.*--------------------------------------------------------
:h1 res=28 name=LOGFILE.Help for Create Log File
:i2 refid=OPTIONS.Create Log File
:p.Use :hp2.Create Log File:ehp2. to
create a log file.  The log file will keep track of commands issued,
status of the commands and return codes.  The date and time
are also logged.
.*--------------------------------------------------------
:h1 res=30 name=OPEN.Open File
:p.
Use this option to Open File.
:ul compact.
:li. :hp2. :link refid=FILE reftype=hd.Run Script File...:ehp2. :elink.
:li. :hp2. :link refid=LOGFILE reftype=hd.Create Log File...:ehp2. :elink.
:eul.
.*--------------------------------------------------------
:h1 res=23 name=KEYSHELP.Help for PMADDE Keys
:p.The following keys can be used to control the Audio Device
Driver Exerciser:
:dl.
:dt.Alt+D
:dd.Select :hp2.Data Stream:ehp2. from menu bar.
:dt.Alt+V
:dd.Select :hp2.View:ehp2. from menu bar.
:dt.Alt+O
:dd.Select :hp2.Options:ehp2. from menu bar.
:dt.Alt+H
:dd.Select :hp2.Help:ehp2. from menu bar.
:edl.
:euserdoc.
.*--------------------------------------------------------

