/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/*********************** START OF SPECIFICATIONS *******************************
*
* SOURCE FILE NAME: PMADLEX.C
*
* DESCRIPTIVE NAME: Audio Device Driver Lexical Routines.
*
* FUNCTION: Lexical functions to support test script.
*
*
*/
#ifndef EOF
#define EOF       (-1)
#endif
#define INCL_DOS                     /* DosAPI  Definitions include     */
#define INCL_PM                      /* Presentation Manager include    */
#include <os2.h>                     /* OS/2 2.x System include         */
#include <stdlib.h>                  /* C Standard Library include      */
#include <stdio.h>                   /* C Standard IO include           */
#include <string.h>                  /* C String Functions include      */
#include <stdarg.h>                  /* C Standard Arguments include    */
#include <fcntl.h>                   /* C File Control Library include  */
#include <os2me.h>                   /* MultiMedia System include       */
#include <audio.h>                   /* Multimedia Audio Driver include */
#include "pmadde.h"                  /* Component Private Definitions   */
#include "pmadlex.h"                 /* Component Lexical Definitions   */
#include "pmadext.h"                 /* Component External Definitions  */

CHAR h7space[] = "     ";
ULONG    ulSleepInt = 0;

/****************************START OF SPECIFICATIONS *************************
*
* FUNCTION: WriteScriptFile
*
* ARGUMENTS: Command Token
*
* RETURN:
*
* DESCRIPTION: This function records user choices and generates the Script.
*
* C FUNCTION CALLS: String Functions
*
* INTERNAL FUNCTION REFERENCES: WriteFile()
*
* GLOBAL VARIABLES REFERENCED:  hfileScript.
*
* GLOBAL VARIABLES MODIFIED:    None
*
*****************************END OF SPECIFICATIONS ***************************/

RC WriteScriptFile(USHORT usCmnd)
{
   static char szbody[556];         /* Temporary Storage */
   char space[4] = "  ";            /* text allignment   */
   PSZ   pszTemp;                   /* Temporary Ptr     */

   /* This function is invoked at various times depending on user
   ** choices to generate the script file. The function gets a
   ** command token as argument and writes out the script senetence
   ** for that token in the current script file. Note that the
   ** grammar is sort of hard coded in here.
   */
   memset(szbody,0,sizeof(szbody));
   switch (usCmnd)
   {
    case INIT:
         WriteFile (hfileScript,szLine);
         WriteFile (hfileScript,szLine1);
         WriteFile (hfileScript,szLine2);
         WriteFile (hfileScript,szLine);
         strcpy (szbody,"BEGIN");
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
         strcpy (szbody,"DEVICENAME ");
         strcat (szbody,aStreamData[StreamCount].AudioDCB.szDevName);
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
       break;

    case GETHANDLER:
         strcpy (szbody,"GETHANDLER");
         strcat (szbody,space);
         strcat (szbody,aActiveHandlers[HandlerCount-1].nszHandlerName);
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
         break;

    case CREATE:
         strcpy (szbody,"CREATE");
         strcat (szbody,space);
         pszTemp = LongToString(aStreamData[ulIndex].hidSrc);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         pszTemp = LongToString(aStreamData[ulIndex].hidTgt);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         pszTemp = LongToString(aStreamData[ulIndex].ulmode);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
         break;

    case ASSOCIATE:
         strcpy (szbody,"ASSOCIATE");
         strcat (szbody,space);
         pszTemp = LongToString(aStreamData[ulIndex].hStream);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         strcat (szbody,aStreamData[ulIndex].nszFileName);
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
         break;

    case START:
         strcpy (szbody,"START");
         strcat (szbody,space);
         pszTemp = LongToString(aStreamData[ulIndex].hStream);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         pszTemp = LongToString (aStreamData[ulIndex].ulStartFlag);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
         break;

    case STOP:
         strcpy (szbody,"STOP");
         strcat (szbody,space);
         pszTemp = LongToString(aStreamData[ulIndex].hStream);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         pszTemp = LongToString (aStreamData[ulIndex].ulStopFlag);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
         break;

    case SEEK:
         strcpy (szbody,"SEEK");
         strcat (szbody,space);
         pszTemp = LongToString(aStreamData[ulIndex].hStream);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         pszTemp = LongToString (aStreamData[ulIndex].ulSeekFlag);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         pszTemp = LongToString (aStreamData[ulIndex].ulSeekPoint);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
         break;

    case DESTROY:
         strcpy (szbody,"DESTROY");
         strcat (szbody,space);
         pszTemp = LongToString(aStreamData[ulIndex].hStream);
         strcat (szbody,pszTemp);
         strcat (szbody,space);
         strcat (szbody,delim);
         break;

    case QRYTIME:
         break;

    case DEVNAME:
         strcpy (szbody,"DEVICENAME ");
         strcat (szbody,aStreamData[StreamCount].AudioDCB.szDevName);
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
         break;

    case EXIT:
         strcpy (szbody,"END");
         strcat (szbody,space);
         strcat (szbody,delim);
         WriteFile (hfileScript,szbody);
         break;
   } /* Known Commands */
} /* WriteScript File */

/****************************START OF SPECIFICATIONS *************************
*
* FUNCTION: ReadNExecScriptFile
*
* ARGUMENTS: None.
*
* RETURN:   Return Code.
*
* DESCRIPTION: This function replays an PMADDE script file.
*
* OS/2 API's USED: WinSendMsg().
*
* C FUNCTION CALLS: fopen ().
*
* INTERNAL FUNCTION REFERENCES: Tokenizebuffer()
*                               ExecCmnd ()
*
* GLOBAL VARIABLES REFERENCED:  hfileScript, szScriptFile.
*
* GLOBAL VARIABLES MODIFIED:    hfileScript.
*
* NOTES:
*
* SIDE EFFECTS: None.
*
*****************************END OF SPECIFICATIONS ***************************/
void _Optlink  ReadNExecScriptFile()
{
   ULONG    ulAction ;         /* File Open Action */
   APIRET   RetCode ;          /* Return Code      */
   ULONG    ulBytesRead ;      /* Bytes Read       */
   ULONG    TokCmd ;           /* Command Token    */
   HAB      habScrThread ;     /* HAB for this thread*/
   HMQ      hmqScrThread ;     /* HMQ for this thread*/


   /* Intialize PM and obtain anchor block for current thread */

    habScrThread = WinInitialize((USHORT) NULL);

  /* Create queue to receive messsages  on this thread */

   hmqScrThread = WinCreateMsgQueue(habScrThread,0);

   /* Open the script file.  */

  RetCode = DosOpen (szScriptFile,
                     &hfileScript,
                     &ulAction,
                     0,
                     FILE_NORMAL,
                     OPEN_ACTION_OPEN_IF_EXISTS,
                     OPEN_FLAGS_WRITE_THROUGH | OPEN_FLAGS_NO_CACHE|
                     OPEN_FLAGS_SEQUENTIAL | OPEN_SHARE_DENYNONE|
                     OPEN_ACCESS_READONLY,
                     0);

   if (RetCode)
   {
      mprintf ("Error Opening %s %d \n",szScriptFile,RetCode);
      return ;
   }

   /* Disable all the main Action bar items other than help */

   WinSendMsg (WinWindowFromID(hwnd1,FID_MENU),
               MM_SETITEMATTR,
               MPFROM2SHORT (ID_STRMCMND,TRUE),
               MPFROM2SHORT (MIA_DISABLED,MIA_DISABLED));

   WinSendMsg (WinWindowFromID(hwnd1,FID_MENU),
               MM_SETITEMATTR,
               MPFROM2SHORT (IDM_INSTHNDLRS,TRUE),
               MPFROM2SHORT (MIA_DISABLED,MIA_DISABLED));

   WinSendMsg (WinWindowFromID(hwnd1,FID_MENU),
               MM_SETITEMATTR,
               MPFROM2SHORT (IDM_OPTIONS,TRUE),
               MPFROM2SHORT (MIA_DISABLED,MIA_DISABLED));

   WinSendMsg (WinWindowFromID(hwnd1,FID_MENU),
               MM_SETITEMATTR,
               MPFROM2SHORT (IDM_OS2SHELL,TRUE),
               MPFROM2SHORT (MIA_DISABLED,MIA_DISABLED));

   WinSendMsg (WinWindowFromID(hwnd1,FID_MENU),
               MM_SETITEMATTR,
               MPFROM2SHORT (IDM_SCRIPT,TRUE),
               MPFROM2SHORT (MIA_DISABLED,MIA_DISABLED));

    /* This is the loop that keeps reading the script file until EOF
    ** and tokenizes the buffer. Tokenizebuffer actually does the
    ** file read breaks the buffer into tokens and also parses it.
    ** Tokenizebuffer has the command table on its stack. If you
    ** need to add new keywords change the command table to recognize
    ** the keyword in the script file. Also Modify WriteScriptFile()
    ** function to write the key word.
    */

     while(( TokCmd = TokenizeBuffer ()) != TOK_EOF)
     {
        /* Execute the command */

        RetCode = ExecCmnd (TokCmd);
     } /* While not EOF */

   /* Destroy the message queue */
   WinDestroyMsgQueue( hmqScrThread );

   /* Terminate and release resources */
   WinTerminate( habScrThread );

   } /* Read and Execute Script File */

/****************************START OF SPECIFICATIONS *************************
*
* FUNCTION: TokenizeBuffer
*
* ARGUMENTS: Char String
*
* RETURN:    Token Command.
*
* DESCRIPTION: This function replays an PMADDE script file.
*
* GLOBAL VARIABLES REFERENCED:  hfileScript.
*
* GLOBAL VARIABLES MODIFIED:    None
*
*****************************END OF SPECIFICATIONS ***************************/
ULONG TokenizeBuffer ()
{

   static KEYWORDS aKeyWords[NUM_KEYWORDS] =
     {
         "ASSOCIATE",  TOK_ASSOCIATE,     /* Command Associate   */
         "START",      TOK_START,         /* Command Start       */
         "STOP",       TOK_STOP,          /* Command Stop        */
         "GETHANDLER", TOK_GETHANDLER,    /* Command Get Handler */
         "CREATE",     TOK_CREATE,        /* Command Create      */
         "DESTROY",    TOK_DESTROY,       /* Command Destroy     */
         "SEEK",       TOK_SEEK,          /* Command Seek        */
         "DEVICENAME", TOK_DEVNAME,       /* Command Device Name */
         "LOGFILE",    TOK_LOGFILE,       /* Command Log File    */
         "PROTOCOL",   TOK_PROTOCOL,      /* Command Protocol    */
         "SLEEP",      TOK_SLEEP,         /* Command Sleep       */
         "BEGIN",      TOK_BEGIN,         /* Command Begin       */
         "END",        TOK_END,           /* Command End         */
     };

   SZ       buffer[READ_BUFFSIZ];        /* File Read buffer     */
   PCHAR    pchWord;                     /* Tokenized Word Ptr   */
   PCHAR    pchComment;                  /* Pointer to comment   */
   PSZ      pszTemp;                     /* Temporary Ptr        */
   char     tokensep[] = " \t,\n";       /* Token Seperators     */
   char     delimiter[] = ";";           /* Sentence delimiter   */
   ULONG    lFirstTok = 0;               /* First Token          */
   int      i,k;                         /* Loop Indices         */
   RC       RetCode;                     /* API return codes     */
   BOOL     fFoundKey = FALSE;           /* Found Key Word flag  */
   BOOL     fFoundStream = FALSE;        /* Found Stream flag    */

  while ((ReadLine(buffer)) != EOF)
   {
       pchWord = buffer;
       pchComment = buffer;

       /* Skip white space */

       while (isspace(*pchWord))
         *pchWord++;

       /* Get the First Token */

       pchWord = strtok (buffer,tokensep);

       CheckString (pchWord);

       /*
       ** Loop thro to look up the current token in our
       ** static command table
       */

       for (i = 0; i<NUM_KEYWORDS; i++)
       {
           if ((strncmp (pchWord,(aKeyWords[i].pchKeyWord),
                         strlen(aKeyWords[i].pchKeyWord)))== 0)
           {
                  lFirstTok = aKeyWords[i].lToken;
                  fFoundKey = TRUE;
                  break;
           }  /* Key Word Match */
       }/* Number of Key Words */

      fFoundKey = TRUE;

       /* If an unknown key word is encountered in the script
       ** Flag error and terminate the app
       */

       if (!fFoundKey) {
          mprintf ("Unrecognized KeyWord in Script: %s\n",pchComment);
       }
       /* Found an valid token, switch and build the parameter
       ** block for the command.
       */

       switch (lFirstTok)
       {
         case TOK_DEVNAME:
              pchWord = strtok (NULL,tokensep);

              CheckString (pchWord);

              /* Device Name > 8 is a fatal error */

              if (strlen(pchWord) > 7) {
                  mprintf ("Invalid Device Name \n");
                  DosExit (0,0);
              }
              /* Non alpha numeric device names are fatal */

               /*
               ** Once a devicename keyword is found
               ** we initialize the rest of our internal
               ** data structures to reflect this device as
               ** the default device. All future operations
               ** will refer to this device until explicitly
               ** changed by another device statement.
               */


              /* Make sure Proper resource id match exists */

              for (i = 0; i < MAXSTREAMS; i++)
              {
                  if ((strnicmp (PhysicalDevData[i].szPhysicalDevName,
                              pchWord,7)) == 0)
                  {
                       for (k = StreamCount; k < MAXSTREAMS; k++)
                       {
                            aStreamData[k].ulResID = PhysicalDevData[i].ulResourceId;

                            strcpy (aStreamData[k].AudioDCB.szDevName,
                                    PhysicalDevData[i].szPhysicalDevName);
                       } /* StreamCount to max Streams */
                  } /* Physical device match */
              } /* Maximun number of streams */

              /* Get next token */
              pchWord = strtok (NULL,tokensep);
              return (TOK_DEVNAME);
              break;

         case TOK_ASSOCIATE:
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              ulIndex = atol (pchWord);

              /* Find the correct stream */
              for (i = 0; i < StreamCount; i++ )
              {
                  if (aStreamData[i].hStream == ulIndex)
                  {
                      fFoundStream = TRUE;
                      ulIndex = i;
                      break;
                  }/* Index Match */
              }/* Total Number of streams */

              if (!fFoundStream)
              {
                    mprintf ("Stream Not Found %d\n",ulIndex);
                    break;
              }

              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);

              strcpy (aStreamData[ulIndex].nszFileName,pchWord);
              pchWord = strtok (NULL,tokensep);

              CheckString (pchWord);

              return (TOK_ASSOCIATE);
            break;

         case TOK_START:
              pchWord = strtok (NULL,tokensep);

              CheckString (pchWord);
              ulIndex = atol (pchWord) ;

              for (i = 0; i < StreamCount; i++ )
              {
                  if (aStreamData[i].hStream == ulIndex)
                  {
                      fFoundStream = TRUE;
                      ulIndex = i;
                      break;
                  }
              }
              if (!fFoundStream)
              {
                    mprintf ("Stream Not Found %d\n",ulIndex);
                    break;
              }


              /* Get the Start flags */

              pchWord = strtok (NULL,tokensep);

              CheckString (pchWord);

              aStreamData[ulIndex].ulStartFlag = atol(pchWord);
              pchWord = strtok (NULL,tokensep);

              CheckString (pchWord);

              CheckFlags (START,aStreamData[ulIndex].ulStartFlag);

              return (TOK_START);

            break;

         case TOK_STOP:
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              ulIndex = atol (pchWord);

              for (i = 0; i < StreamCount; i++ )
              {
                  if (aStreamData[i].hStream == ulIndex)
                  {
                      fFoundStream = TRUE;
                      ulIndex = i;
                      break;
                  }
              }
              if (!fFoundStream)
              {
                    mprintf ("Stream Not Found %d \n",ulIndex);
                    break;
              }

              /* Get the Stop flag */
              pchWord = strtok (NULL,tokensep);

              CheckString (pchWord);

              aStreamData[ulIndex].ulStopFlag = atol(pchWord);

              /* Check for delimiter */

              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);

              /* Check to see if flags are valid */

              CheckFlags (START,aStreamData[ulIndex].ulStopFlag);

              return (TOK_STOP);
            break;

         case TOK_GETHANDLER:
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              strcpy (aActiveHandlers[HandlerCount].nszHandlerName, pchWord);
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              return (TOK_GETHANDLER);
            break;

         case TOK_CREATE:
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              aStreamData[StreamCount].hidSrc = atol(pchWord);
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              aStreamData[StreamCount].hidTgt = atol(pchWord);
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              aStreamData[StreamCount].ulmode = atol(pchWord);
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              return (TOK_CREATE);
            break;

         case TOK_DESTROY:
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              ulIndex = atol (pchWord);

              for (i = 0; i < StreamCount; i++ )
              {
                  if (aStreamData[i].hStream == ulIndex)
                  {
                      fFoundStream = TRUE;
                      ulIndex = i;
                      break;
                  }
              }
              if (!fFoundStream)
              {
                    mprintf ("Stream Not Found %d\n",ulIndex);
                    break;
              }


              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              return (TOK_DESTROY);
            break;

         case TOK_SEEK:

              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              ulIndex = atol (pchWord);
              for (i = 0; i < StreamCount; i++ )
              {
                  if (aStreamData[i].hStream == ulIndex)
                  {
                      fFoundStream = TRUE;
                      ulIndex = i;
                      break;
                  }
              }
              if (!fFoundStream)
              {
                    mprintf ("Stream Not Found %d\n",ulIndex);
                    break;
              }
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              aStreamData[ulIndex].ulSeekFlag = atol(pchWord);
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              aStreamData[ulIndex].ulSeekPoint = atol(pchWord);
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              CheckFlags (START,aStreamData[ulIndex].ulSeekFlag);
              return (TOK_SEEK);
            break;

         case TOK_SLEEP:

              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              ulSleepInt = atol (pchWord);
              pchWord = strtok (NULL,tokensep);
              CheckString (pchWord);
              return (TOK_SLEEP);
              break;

         case TOK_QUERYTIME:
              break;

         case TOK_END:
             return (TOK_END);
            break;

         case TOK_LOGFILE:
            break;

         case TOK_PROTOCOL:
            break;

         default: return (TOK_COMMENT);
       } /* First Token switch */
   }    /* While not EOF */
   return (TOK_EOF);
} /* Tokenizebuffer() */

/****************************START OF SPECIFICATIONS *************************
*
* FUNCTION: ExecCmnd
*
* ARGUMENTS: Command Token
*
* RETURN:
*
* DESCRIPTION: This function executes command serially from PMADDE script file.
*
* OS/2 API's USED: WinSendMsg()
*                  DosResetEventSem()
*                  DosWaitEventSem()
*                  DosSleep()
*
* C FUNCTION CALLS:_beginThread(), String functions
*
* INTERNAL FUNCTION REFERENCES: PrintXXX(), API Workers, Support Routines.
*
* GLOBAL VARIABLES REFERENCED:  hfileScript.
*
* GLOBAL VARIABLES MODIFIED:    None
*
*****************************END OF SPECIFICATIONS ***************************/

APIRET ExecCmnd (ULONG CmndToken)
{

   SZ       buffer[READ_BUFFSIZ];    /* Temporary Storage  */
   PCHAR    pchWord;                 /* Word Pointer       */
   USHORT   usfBegin = FALSE;        /* Local error flag   */
   USHORT   usfEnd = FALSE;          /* Local error flag   */
   APIRET   RetCode;                 /* API return Code    */
   PSZ      pszTemp;                 /* Temporary Ptr      */
   ULONG    ulCount;                 /* Semaphore Post     */

    switch (CmndToken)
       {
          case TOK_COMMENT:
               break;

          case TOK_DEVNAME:
               sACPAOpened = 0;
               /*
               ** Fix Device Specific information
               ** for the specific audio device in use.
               */
               FixDeviceData ();
               break;
          case TOK_SLEEP:
               DosSleep (ulSleepInt);
               break;

          case TOK_BEGIN:
               usfBegin = TRUE;
               break;

          case TOK_END:
               break;

          case TOK_GETHANDLER:
               /* Call The Worker */
               RetCode = GetStreamHandler();
               /*
               ** Update Display information to reflect the
               ** currently active stream handlers
               */
               PrintCmndInfo (GETHANDLER,0,RetCode);

              if (!RetCode)
              {
                  strcpy (buffer,
                          aActiveHandlers[HandlerCount -1].nszHandlerName);

                  strcat (buffer,h7space);

                  strcat (buffer,h7space);

                  pszTemp = LongToString(aActiveHandlers[HandlerCount-1].hidSrc);
                  strcat(buffer,pszTemp);
                  strcat (buffer,h7space);
                  pszTemp = LongToString (aActiveHandlers[HandlerCount-1].hidTgt);
                  strcat(buffer,pszTemp);
                  WinSendMsg (hwndActLst,
                              (ULONG)LM_INSERTITEM,
                              MPFROMSHORT(LIT_SORTASCENDING),
                              MPFROMP(buffer));

              } /* No Error Code */
               break;

          case TOK_CREATE:
               /*
               ** Fix Device Specific information
               */
               RetCode = FixDeviceData();

               /* Call The Worker */

               RetCode = CreateStream();
              /*
              ** Update Display with command information and return
              ** codes. The Stream handle is set to 0 at create time.
              */
               PrintCmndInfo (CREATE,0,RetCode);
               if (!RetCode)
                   PrintActiveInfo (hwndActWinFrm);
               break;

          case TOK_ASSOCIATE:
               /* Call The Worker */
               RetCode = AssociateStream();

               PrintCmndInfo ( ASSOCIATE,ulIndex, RetCode);
               if (!RetCode)
                  PrintActiveInfo (hwndActWinFrm);

               break;

          case TOK_START:

               DosResetEventSem (aStreamData[ulIndex].hevThrdSem,&ulCount);

               RetCode =  _beginthread (StartStream,NULL,8196,NULL);
               if (RetCode != -1)
               {
                   /*
                   ** Wait for the thread we just started to
                   ** indicate that everything is allright so
                   ** that we can update stream state.
                   */

                   DosWaitEventSem (aStreamData[ulIndex].hevThrdSem, (ULONG)-1);

                   PrintCmndInfo (PLAY,
                                  aStreamData[ulIndex].hStream,
                                  aStreamData[ulIndex].RetCode);

                   if (!aStreamData[ulIndex].RetCode)
                   {
                       strcpy(aStreamData[ulIndex].nszState, "STREAMING");

                       PrintActiveInfo (hwndActWinFrm);
                   }/* Good SpiCreateStream Return only */

               } /* No Negative One Return Code */
               break;

          case TOK_SEEK:
               RetCode = SeekStream();
               PrintCmndInfo (SEEK,ulIndex,RetCode);
               if (!RetCode);
                  PrintActiveInfo (hwndActWinFrm);
               break;

          case TOK_STOP:
               RetCode = StopStream();
               PrintCmndInfo (STOP,ulIndex,RetCode);
               if ((aStreamData[ulIndex].ulStopFlag == SPI_STOP_FLUSH) ||
                   (aStreamData[ulIndex].ulStopFlag == SPI_STOP_DISCARD))
                   DosSleep (1700);
               if (!RetCode)
                  PrintActiveInfo (hwndActWinFrm);
               break;

          case TOK_DESTROY:
               RetCode = DestroyStream();
               PrintCmndInfo (DESTROY,ulIndex,RetCode);
               if (!RetCode)
                  PrintActiveInfo (hwndActWinFrm);
               break;

       }/* Of Switch */

} /* Execute Command Function */

/****************************START OF SPECIFICATIONS *************************
*
* FUNCTION: CheckString
*
* ARGUMENTS:
*
* RETURN:
*
* DESCRIPTION: This function Checks for a Null String, and if found
*              Terminates the application.
*
* GLOBAL VARIABLES REFERENCED:  hfileScript.
*
* GLOBAL VARIABLES MODIFIED:    None
*
*****************************END OF SPECIFICATIONS ***************************/
RC CheckString (PCHAR pchInputStr)
{

   if (pchInputStr == NULL)
   {
       mprintf ("Null String: Terminating Application \n");
       DosExit (0,0);
   } /* Null String */

}/* CheckString */

/****************************START OF SPECIFICATIONS *************************
*
* FUNCTION: CheckFlags
*
* ARGUMENTS: command, Flags.
*
* RETURN: none.
*
* DESCRIPTION: This function Checks the validity SPI  flags and reports
*              it to the user.
*
* OS/2 API's USED: None
*
* C FUNCTION CALLS:None
*
* INTERNAL FUNCTION REFERENCES: mprintf()
*
* GLOBAL VARIABLES REFERENCED:
*
* GLOBAL VARIABLES MODIFIED:    None
*
* NOTES:
*
* SIDE EFFECTS: None.
*
*****************************END OF SPECIFICATIONS ***************************/

VOID CheckFlags(USHORT usCmnd, ULONG ulComFlag)
{
  static ULONG ulCreate;
  ulCreate = ulComFlag;

  switch ( usCmnd )
  {
    case START:
      ulCreate  &= ~(SPI_START_STREAM  + SPI_START_PREROLL );
      if (ulCreate > 0)
        mprintf("SpiStartStream Invalid Flag: use SPI_START_STREAM or SPI_START_PREROLL");
      break;
    case STOP:
      ulCreate  &= ~(SPI_STOP_STREAM  + SPI_STOP_FLUSH + SPI_STOP_DISCARD );
      if (ulCreate > 0)
       mprintf("SpiStopStream Invalid Flag: use SPI_STOP_STREAM or SPI_STOP_FLUSH or SPI_STOP_DISCARD");
       break;
    case SEEK:
      ulCreate &= ~( SPI_SEEK_ABSOLUTE + SPI_SEEK_RELATIVE + SPI_SEEK_FROMEND +  \
                       SPI_SEEK_MMTIME   + SPI_SEEK_BYTES );
      if (ulCreate > 0)
       mprintf("SpiSeekStream Invalid Flag: use SPI_SEEK_ABSOULTE or SPI_SEEK_RELATIVE or SPI_SEEK_FROMEND");
       break;
    default:
       mprintf("Unnecessary Flag-Check the script file");
       break;
   }

}
/****************************START OF SPECIFICATIONS *************************
*
* FUNCTION: ReadLine
*
* ARGUMENTS: buffer
*
* RETURN: EOF
*
* DESCRIPTION: This function Reads a line from the script file
*
* OS/2 API's USED: DosRead()
*
* GLOBAL VARIABLES REFERENCED:  hfileScript.
*
* GLOBAL VARIABLES MODIFIED:    None
*
*****************************END OF SPECIFICATIONS ***************************/
RC ReadLine (PSZ buffer)
{
  ULONG     ulBytesRead;     /* Number of bytes read */
  UCHAR     abBuff;          /* Buffer read in to    */

  /*
  ** Keep Reading character by character until you find a carriage
  ** return line feed sequence.
  */

  while (TRUE)
  {
         DosRead (hFileScript,&abBuff,sizeof(abBuff),&ulBytesRead);

         /*
         ** 0 bytes read or 0x1a character encountered, we return
         ** EOF to  caller
         */

         if ((!ulBytesRead) || (abBuff == 0x1A))
            return (EOF);

         if (abBuff == '\r')

            DosRead (hFileScript,&abBuff,sizeof(abBuff),&ulBytesRead);

            /*
            ** Store the byte just read into retun pointer
            */

            *buffer++ = abBuff;

         if (abBuff == '\n')
             break;

  } /* While true */
  *buffer = '\0';

  return (0);

} /* Get Line */
