/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/*********************** START OF SPECIFICATIONS *******************************
*
* SOURCE FILE NAME: PMADLEX.H
*
* DESCRIPTIVE NAME: Audio Device Driver Lexical Definitons.
*
* FUNCTION: Lexical Analyzer Token Definitions.
*
*
*/
#define NUM_KEYWORDS       13      /* Number of Known Keywords */
#define TOK_ASSOCIATE      1       /* Token Associate Stream   */
#define TOK_START          2       /* Token Start Stream       */
#define TOK_STOP           3       /* Token Stop Stream        */
#define TOK_GETHANDLER     4       /* Token Get Stream Handler */
#define TOK_CREATE         5       /* Token Create Stream      */
#define TOK_DESTROY        6       /* Token Destroy Stream     */
#define TOK_SEEK           7       /* Token Seek Stream        */
#define TOK_QUERYTIME      8       /* Token Query Stream Time  */
#define TOK_DEVNAME        9       /* Token Device Name        */
#define TOK_LOGFILE        10      /* Token Log File Name      */
#define TOK_PROTOCOL       11      /* Token Install Protocol   */
#define TOK_COMMENT        12      /* Token Comment            */
#define TOK_BEGIN          13      /* Token Script Begin       */
#define TOK_END            14      /* Token Script End         */
#define TOK_SLEEP          15      /* Token Sleep              */
#define TOK_EOF            16      /* Token EOF                */
#define READ_BUFFSIZ       512     /* Input String Buffer Size */
#define delim              ";"     /* Sentence delimiter       */

typedef struct _KEYWORDS{
   PCHAR  pchKeyWord;              /* Keyword Pointer          */
   ULONG   lToken;                 /* Token Match for keyword  */
}KEYWORDS;

HFILE hFileScript;                /* Script file handle   */

/* Script Header definitions */

static char szLine[]=";*****************************************************";
static char szLine1[]=";**  Audio Device Driver Exerciser V 1.0 ";
static char szLine2[]=";**    Test Script File. ";

/* Lex function prototypes */

ULONG TokenizeBuffer ();                         /* Break Input into Tokens */
APIRET ExecCmnd (ULONG CmndToken);               /* Execute Token Command   */
RC CheckString (PCHAR pchInputStr);              /* Check if Null String    */
VOID CheckFlags(USHORT usCmnd, ULONG ulComFlag); /* Check Valid Flags       */
RC ReadLine (PSZ buffer);                        /* Read Line               */
