/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
/*********************** START OF SPECIFICATIONS *******************************
*
* SOURCE FILE NAME: ADDE.H
*
* DESCRIPTIVE NAME: Audio Device Driver Exerciser.
*
* FUNCTION: Component Global Data Structures, and Constant definitions
*
*
*/
RC   rc;
RC   EventRtn();
LONG Open_Driver();
LONG AudioInit(ULONG,ULONG);
LONG AudioIdle(ULONG,ULONG);
LONG AudioChange(HFILE);
LONG Close_Driver(HFILE);
LONG LoadDSP(HFILE, LPMCI_AUDIO_INIT);
LONG Set_IO_Ports(LPMCI_AUDIO_CHANGE);
/* Stream Structures */

EVCB    Events;


/*--------------------------------------------------------------------------*\
 *  Defines
\*--------------------------------------------------------------------------*/
#define EOS                '\0'

/******************************************************************************/
/* SH0 implicit events that can be used to monitor the SH0 stream handler     */
/******************************************************************************/
#define SH0EVENT_STARTSRC       0x8000L // Source received SHC_START
#define SH0EVENT_STARTTGT       0x8001L // Target received SHC_START
#define SH0EVENT_GETFULL_ERR    0x8002L // GETFULL error received
#define SH0EVENT_GETEMPTY_ERR   0x8003L // GETEMPTY error received

#define SSMEVENT_GETEMPTY             0x8004L // GETEMPTY request
#define SSMEVENT_GETFULL              0x8005L // GETFULL request
#define SSMEVENT_RETURNEMPTY          0x8006L // RETURNEMPTY request
#define SSMEVENT_RETURNFULL           0x8007L // RETURNFULL request
#define SSMEVENT_STARTTGT_SINGL       0x8008L // SSM starting target
#define SSMEVENT_STARTTGT_SYNC        0x8009L // SSM starting target
#define SSMEVENT_STARTSRC_WAIT        0x800AL // SSM starting Source
#define SSMEVENT_MAST_SYNC_PULSE      0x800BL // SSM Master sync pulse receiv
#define SSMEVENT_SLAVE_SYNC_PULSE     0x800CL // SSM Slave sync pulse sent
#define SSMEVENT_SLAVE_SYNC_OVERRUN   0x800DL // SSM Slave sync overrun sent
#define SSMEVENT_SMH_NOTIFY_ERROR     0x800EL // SMH_NOTIFY error

/*
** Event processing flags
*/
  ULONG    aulMastFlag[MAXSTREAMS];
  ULONG    aulMErrorFlag[MAXSTREAMS];
  ULONG    aulMStopFlag[MAXSTREAMS];
  ULONG    aulMPrerollFlag[MAXSTREAMS];
  ULONG    aulMPlayFlag[MAXSTREAMS];
  ULONG    aulMCueTimeFlag[MAXSTREAMS];
  ULONG    aulMCueDataFlag[MAXSTREAMS];
  ULONG    aulMOverrunFlag[MAXSTREAMS];
  BOOL     fDisplayNotifyEvents = FALSE;
  BOOL     fDisplayStartEvents = FALSE;

/*  DATA_EVCB MTEVCB = {EVENT_CUE_DATA, 0, 0, 0, 0, 0, 0, 0}; */

/* master stream cue data control block */

  BOOL     fProgress = FALSE;
  ULONG    ulSysFileNum;

//  SPCBKEY  spcbkey = {DATATYPE_ADPCM_AVC,0};
  unsigned char timinit[10] = { 0xf0, 0, 0, 0x3a, 3, 1, 0x08, 3, 3, 0xf7 } ;

#define VSD_NUM_DSP_PATHS       4

CHAR abDSPPath[VSD_NUM_DSP_PATHS][20] =
        {
        "\\MMOS2\\DSP\\",
        "\\MMOS2\\DLL\\",
        "\\MMOS2\\",
        ".\\"
        };
