/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1995 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 WARP source code is provided to you solely for  */
/*    the purpose of assisting you in your development of OS/2 WARP device   */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Device Driver Source Kit for OS/2. This  */
/*    Copyright statement may not be removed.                                */
/*                                                                           */
/*****************************************************************************/
#ifndef DEVCALLS_H
#define DEVCALLS_H
/***************************************************************************
 *\\ddd
 * Subtask Name: pdvt
 *
 * Module name: devcalls
 *
 * Purpose: Gpi bit map dll include file
 *
 *  $header$
 *
 *
 * Contents:  This file contains the following definitions:
 *
 *              - function prototypes
 *              - define's specific to DevCalls
 *
 * Limitations:
 *  None
 *
 *\\end
 ***************************************************************************/

/* declare all dll functions */
VOID  APIENTRY DevQueryCapsExh(HPS hPS,HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY DevEscapeExh(HPS hPS,HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY DevEscSupportListApp(HPS hPS,HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY DevQueryDeviceNamesExh(HPS hPS,HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY DevQueryHardcopyCapsExh(HPS hPS,HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY DevPostDeviceModesExh(HPS hPS,HWND hWndClient,BOOL SelectionCall);

VOID TestEscCode(HDC hDC, HPS hPS, HWND hWndClient, LONG code);
#define NUMTESTS 6          // number of functions or entry points in this dll.
#define NUMLINES  (sizeof(devcaps) / sizeof(devcaps[0]))
#define NUMESC   (sizeof(esccodes) / sizeof(esccodes[0]))
#define FIXEDTOLONG 65536;


struct {
    LONG  lIndex;
    CHAR  *szID;
    } esccodes[] =
      {
         DEVESC_QUERYESCSUPPORT       , "DEVESC_QUERYESCSUPPORT",
         DEVESC_QUERYVIOCELLSIZES     , "DEVESC_QUERYVIOCELLSIZES",
         DEVESC_GETSCALINGFACTOR      , "DEVESC_GETSCALINGFACTOR",
         DEVESC_STARTDOC              , "DEVESC_STARTDOC",
         DEVESC_ENDDOC                , "DEVESC_ENDDOC",
         DEVESC_NEXTBAND              , "DEVESC_NEXTBAND",
         DEVESC_ABORTDOC              , "DEVESC_ABORTDOC",
         DEVESC_NEWFRAME              , "DEVESC_NEWFRAME",
         DEVESC_DRAFTMODE             , "DEVESC_DRAFTMODE",
         DEVESC_BREAK_EXTRA           , "DEVESC_BREAK_EXTRA",
         DEVESC_CHAR_EXTRA            , "DEVESC_CHAR_EXTRA",
         DEVESC_SETMODE               , "DEVESC_SETMODE",
         DEVESC_FLUSHOUTPUT           , "DEVESC_FLUSHOUTPUT",
         DEVESC_RAWDATA               , "DEVESC_RAWDATA",
      };


struct {
    LONG  lIndex;
    CHAR  *szIdentifier;
  }
  devcaps[] =
  {
    CAPS_FAMILY                       , "CAPS_FAMILY",
    CAPS_IO_CAPS                      , "CAPS_IO_CAPS",
    CAPS_TECHNOLOGY                   , "CAPS_TECHNOLOGY",
    CAPS_DRIVER_VERSION               , "CAPS_DRIVER_VERSION",
    CAPS_HEIGHT                       , "CAPS_HEIGHT",
    CAPS_WIDTH                        , "CAPS_WIDTH",
    CAPS_HEIGHT_IN_CHARS              , "CAPS_HEIGHT_IN_CHARS",
    CAPS_WIDTH_IN_CHARS               , "CAPS_WIDTH_IN_CHARS",
    CAPS_VERTICAL_RESOLUTION          , "CAPS_VERTICAL_RESOLUTION",
    CAPS_HORIZONTAL_RESOLUTION        , "CAPS_HORIZONTAL_RESOLUTION",
    CAPS_CHAR_HEIGHT                  , "CAPS_CHAR_HEIGHT",
    CAPS_CHAR_WIDTH                   , "CAPS_CHAR_WIDTH",
    CAPS_SMALL_CHAR_HEIGHT            , "CAPS_SMALL_CHAR_HEIGHT",
    CAPS_SMALL_CHAR_WIDTH             , "CAPS_SMALL_CHAR_WIDTH",
    CAPS_COLORS                       , "CAPS_COLORS",
    CAPS_COLOR_PLANES                 , "CAPS_COLOR_PLANES",
    CAPS_COLOR_BITCOUNT               , "CAPS_COLOR_BITCOUNT",
    CAPS_COLOR_TABLE_SUPPORT          , "CAPS_COLOR_TABLE_SUPPORT",
    CAPS_MOUSE_BUTTONS                , "CAPS_MOUSE_BUTTONS",
    CAPS_FOREGROUND_MIX_SUPPORT       , "CAPS_FOREGROUND_MIX_SUPPORT",
    CAPS_BACKGROUND_MIX_SUPPORT       , "CAPS_BACKGROUND_MIX_SUPPORT",
    CAPS_VIO_LOADABLE_FONTS           , "CAPS_VIO_LOADABLE_FONTS",
    CAPS_WINDOW_BYTE_ALIGNMENT        , "CAPS_WINDOW_BYTE_ALIGNMENT",
    CAPS_BITMAP_FORMATS               , "CAPS_BITMAP_FORMATS",
    CAPS_RASTER_CAPS                  , "CAPS_RASTER_CAPS",
    CAPS_MARKER_HEIGHT                , "CAPS_MARKER_HEIGHT",
    CAPS_MARKER_WIDTH                 , "CAPS_MARKER_WIDTH",
    CAPS_DEVICE_FONTS                 , "CAPS_DEVICE_FONTS",
    CAPS_GRAPHICS_SUBSET              , "CAPS_GRAPHICS_SUBSET",
    CAPS_GRAPHICS_VERSION             , "CAPS_GRAPHICS_VERSION",
    CAPS_GRAPHICS_VECTOR_SUBSET       , "CAPS_GRAPHICS_VECTOR_SUBSET",
    CAPS_DEVICE_WINDOWING             , "CAPS_DEVICE_WINDOWING",
    CAPS_ADDITIONAL_GRAPHICS          , "CAPS_ADDITIONAL_GRAPHICS",
    CAPS_PHYS_COLORS                  , "CAPS_PHYS_COLORS",
    CAPS_COLOR_INDEX                  , "CAPS_COLOR_INDEX",
    CAPS_GRAPHICS_CHAR_WIDTH          , "CAPS_GRAPHICS_CHAR_WIDTH",
    CAPS_GRAPHICS_CHAR_HEIGHT         , "CAPS_GRAPHICS_CHAR_HEIGHT",
    CAPS_HORIZONTAL_FONT_RES          , "CAPS_HORIZONTAL_FONT_RES",
    CAPS_VERTICAL_FONT_RES            , "CAPS_VERTICAL_FONT_RES",
  };

POINTL ptl;
CHAR   achLogLine[100];
BOOL   bSuccess;
LONG   ErrorCount=0L;
BOOL   NBand;
#endif


