
CC      = icc
compile =$(CC) /c $(CFLAGS)

CFLAGS = /c /G3 /W3 /Sp /Ti+ /O- /Gd+ /Gm+ /Ge- /Sm /Ss
LFLAGS = /NOD /M /STACK:64000 /PACKC /PACKD



TESTNAME  = DEVCALLS
LIBS      = DDE4MBS DDE4MBM OS2386   #   Lib's to link DLLs with.
MAPNAME   = $(TESTNAME).MAP   #   Map file name. Supplied to the LINKER.
RESFILE   = $(TESTNAME).RES   #   Resource file name produced from .RC file
ARFFILE   = $(TESTNAME).ARF   #   Automatic Response File. Used for linking.
DEFFILE   = $(TESTNAME).DEF   #   Definition file name.
DEPLIST   = $(LOBJ1)  $(LOBJ2)  $(LOBJ3)  $(DEFFILE)

           # Bitmap Files that need to be included within DLLs as
           # resources.

BITMAP    =


LOBJ1     =  devcalls.obj
LOBJ2     =  PTTdllvr.obj
LOBJ3     =  common.obj

          #  Header files that are common to one DLL.

HFILES    = $(TESTNAME).H PTTdlldf.h common.h Ptt_dll.h


.SUFFIXES: .RES .RC .DLL   # make 'make.exe'  aware of these uncommon file
#                            extensions.

.c.obj:
      @icc $(CFLAGS) $*.C

.RC.RES:
      @RC -R $*.RC


$(TESTNAME).DLL: $(DEPLIST)
     @LINK386  $(LFLAGS) @<<$(ARFFILE)
   $(LOBJ1)+
   $(LOBJ2)+
   $(LOBJ3),
   $@,
   $(MAPNAME),
   $(LIBS),
   $(DEFFILE)
<<

 @IF exist $(RESFILE) RC $(RESFILE) $(TESTNAME).DLL
 @IF exist $(ARFFILE) DEL $(ARFFILE) >NUL

$(RESFILE):     $(TESTNAME).RC  $(BITMAP)


$(TESTNAME).OBJ:  $(TESTNAME).C $(HFILES)
   $(compile) /Fo$@ $(TESTNAME).C

PTTdllvr.OBJ:  PTTdllvr.C
   $(compile) /Fo$@ PTTDLLVR.C

COMMON.OBJ:    COMMON.C COMMON.H
   $(compile) /Fo$@ COMMON.C

