# Makefile for GPIBITMAP
# 11/03/93

CFLAGS = /c /G3 /W3 /DLINT_ARGS /Sp /Ti+ /O- /Mp /Gd+ /Gm+ /Ge- /Sm /Ss
LFLAGS    = /CO /NOD /M /STACK:64000 /PACKC /PACKD


LIBS      = DDE4MBS DDE4MBM OS2386   #   Lib's to link DLLs with.
TESTNAME  = GPIBTMP
MAPNAME   = GPIBTMP.MAP       #   Map file name. Supplied to the LINKER.
RESFILE   = $(TESTNAME).RES   #   Resource file name produced from .RC file
ARFFILE   = $(TESTNAME).ARF   #   Automatic Response File. Used for linking.
DEFFILE   = $(TESTNAME).DEF   #   Definition file name.
DEPLIST   = $(LOBJ1)  $(LOBJ2)  $(LOBJ3) $(RESFILE)

           # Bitmap Files that need to be included within DLLs as
           # resources.

BITMAP    = GPIBTMP1.BMP GPIBTMP2.BMP GPIBTMP3.BMP GPIBTMP4.BMP GPIBTMP5.BMP

LOBJ1     = $(TESTNAME).OBJ
LOBJ2     = COMMON.OBJ PTTDLLVR.OBJ
LOBJ3     =

          #  Header files that are common to one DLL.

HFILES    = $(TESTNAME).H PTTDLLDF.H COMMON.H PTT_DLL.H


.SUFFIXES: .RES .RC .DLL   # make 'make.exe'  aware of these uncommon file
#                            extensions.

.RC.RES:
      @RC -R $*.RC

$(TESTNAME).DLL: $(DEPLIST)
     @LINK386  $(LFLAGS) @<<$(ARFFILE)
   $(LOBJ1)+
   $(LOBJ2)+
   $(LOBJ3),
   $(TESTNAME).DLL,
   $(MAPNAME),
   $(LIBS),
   $(DEFFILE)
<<

 @IF exist $(RESFILE) RC $(RESFILE) $(TESTNAME).DLL
 @IF exist $(ARFFILE) DEL $(ARFFILE) >NUL

$(RESFILE)      : $(TESTNAME).RC $(BITMAP)

$(TESTNAME).OBJ : $(TESTNAME).C  $(HFILES)
  icc $(CFLAGS) /Fo$@ $(TESTNAME).C

COMMON.OBJ      : COMMON.C COMMON.H
  icc $(CFLAGS) /Fo$@ COMMON.C

PTTDLLVR.OBJ    : PTTDLLVR.C  PTTDLLDF.H  ERRORS.H
  icc $(CFLAGS) /Fo$@ PTTDLLVR.C

