# Makefile for GPIFONT
# 11/03/93

CFLAGS = /c /G3 /W3 /DLINT_ARGS /Sp /Ti+ /O- /Mp /Gd+ /Gm+ /Ge- /Sm /Ss
LFLAGS    = /M /CO /NOD /STACK:64000 /PACKC /PACKD


LIBS      = DDE4MBS DDE4MBM OS2386   #   Lib's to link DLLs with.
TESTNAME  = GPIFONT
MAPNAME   = $(TESTNAME).MAP   #   Map file name. Supplied to the LINKER.
RESFILE   = $(TESTNAME).RES   #   Resource file name produced from .RC file
ARFFILE   = $(TESTNAME).ARF   #   Automatic Response File. Used for linking.
DEFFILE   = $(TESTNAME).DEF   #   Definition file name.
DEPLIST   = $(LOBJ1)  $(LOBJ2)  $(LOBJ3)  $(DEFFILE)

           # Bitmap Files that need to be included within DLLs as
           # resources.

BITMAP    =


LOBJ1     =  gpifont.obj
LOBJ2     =  PTTdllvr.obj
LOBJ3     =  common.obj

          #  Header files that are common to one DLL.

HFILES    = $(TESTNAME).H PTTdlldf.h common.h


.SUFFIXES: .RES .RC .DLL   # make 'make.exe'  aware of these uncommon file
#                            extensions.

.RC.RES:
      @RC -R $*.RC

$(TESTNAME).DLL: $(DEPLIST)
     @LINK386  $(LFLAGS) @<<$(ARFFILE)
   $(LOBJ1)+
   $(LOBJ2)+
   $(LOBJ3),
   $(TESTNAME).DLL,
   $(MAPNAME),
   $(LIBS),
   $(DEFFILE)
<<

 @IF exist $(RESFILE) RC $(RESFILE) $(TESTNAME).DLL
 @IF exist $(ARFFILE) DEL $(ARFFILE) >NUL

$(RESFILE):     $(TESTNAME).RC  $(BITMAP)


$(TESTNAME).OBJ:  $(TESTNAME).C $(HFILES)
   icc $(CFLAGS) /Fo$@ $(TESTNAME).C

COMMON.OBJ:    COMMON.C COMMON.H
   icc $(CFLAGS) /Fo$@ COMMON.C

PTTDLLVR.OBJ: PTTDLLVR.C  PTTDLLDF.H  ERRORS.H
   icc $(CFLAGS) /Fo$@ PTTDLLVR.C
