PROJ     = PTT
PROJFILE = PTT.MAK


CC = icc

#  /W3           - Warns of all non-ANSI usage
#  /G3           - Generate 80486 code
#  /DLINT_ARGS   - Check functional arguments against prototypes
#  /Sp           - Packs Structure
#  /Ti-          - Generates all debugger information
#  /Sm           - Allow all C Set/2 extensions including those for migration
#  /O+           - Optimize object code
#  /Gs+          - Stack checking
#  /Ge           - Build .EXE file
#  /Ss           - Allow for the // comments

CFLAGS  = /W3 /G3 /DLINT_ARGS /Sp /Ti- /Sm /Gm+ /Gd+ /O+ /Gs+ /Ss

# DDE4MBS DDE4MBM   - MULTITHREAD, BUILDS .EXE/.DLL, and MIGRATION LIBRARY
LLIBS   = DDE4MBS DDE4MBM OS2386

MAPFILE  = ptt.map
LFLAGS   =  /NOD /STACK:64000 /M /NOF /PACKC /PACKD  /CO /PM:PM
LINKER   = link386
LRF      = echo > NUL
RC       = rc
DEF_FILE = PTT.DEF

OBJS  = PTT.obj      PTTCOMM.obj  \
        PTTDLGS.obj  PTTLOG.obj   \
        PTTINIT.obj  PTTPRINT.obj
RESS  = PTT.res

compile =$(CC) /c $(CFLAGS)


all: $(PROJ).exe

.SUFFIXES:
.SUFFIXES: .sbr .obj .res .c .rc

PTT.obj : PTT.C PTT.h PTTmain.h PTTlog.h pttdlg.h PTT_DLL.h
   $(compile) /Fo$@ ptt.c

PTTCOMM.obj : PTTCOMM.C PTT.h PTTcomm.h pttdlg.h PTT_DLL.h
   $(compile) /Fo$@ pttcomm.c

PTTDLGS.obj : PTTDLGS.C PTT.h PTTlog.h PTTdlgs.h pttdlg.h PTT_DLL.h
   $(compile) /Fo$@ pttdlgs.c

PTTLOG.obj : PTTLOG.C PTT.h PTTlog.h pttdlg.h PTT_DLL.h
   $(compile) /Fo$@ pttlog.c

PTTINIT.obj : PTTINIT.C PTT.h PTTlog.h PTTinit.h pttdlg.h PTT_DLL.h
   $(compile) /Fo$@ pttinit.c

PTTPRINT.obj : PTTPRINT.C PTT.h PTTprint.h pttdlg.h PTT_DLL.h
   $(compile) /Fo$@ pttprint.c


PTT.res : PTT.RC PTT.h PTT.DLG pttdlg.h PTT_DLL.h


$(PROJ).exe : $(DEF_FILE) $(OBJS) $(RESS)
        $(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE)
$(LLIBS: = +^
)
$(DEF_FILE) $(LFLAGS);
<<

        $(LINKER) @$(PROJ).lrf
        $(RC) $(RESS) $@


.rc.res :
        rc -r -p $< $@
